/**** BLABLABLA
# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include <ctype.h>
# include <stddef.h>
#include "gtk/gtk.h"  ***/
#include "gtk/gtk.h"  
#define MAX_SHIFT 200
#define MAX_WORD 1000
#define NSUP_ENTRY 50
#define ISS_MAX 5
#define NSUP_BFE 10
#define N_BFE 3

/********************************************************************/
/*
 *  the file   idx_gene is the alphabeticaly ordered list of all the
 *  words which are into a dico
 *  posit[] is the collection of the positions of the words which
 *  are into the highlighted file and of some of those which are 
 *  into the idx_gene file in fact only the first one which is on the 
 *  highest priority dictionary.
 *  posit[i] = posit[0] + position into the highlight file
 *  posit[i] =  position into the idx_gene file
 *  posit[0] >= last position into the idx_gene file
 *  Remark : for dico the same word cannot be present more than 
 *  two times. First into the highlight file and i+1 (the following)
 *  into the idx_gene file. 
 *  If a word is present one time :
 *  if posit >= posit[0] it is an unknown highlighted word
 *  if posit[i] < posit[0] it is the position into the idx_gene file
 *  of the first of these words. The one with the highest priority.
 *  The others, those on the following lines whose position is
 *  inferior to posit[i+1] are for the same word but in lesser 
 *  priority dictionaries
 */
/********************************************************************/
 typedef struct _Start_State   {
   int num_book ;
   int num_page ;
   int root_x ;
   int root_y ;
   int root_width ;
   int root_height ;
   int width_book ;
}Start_State ; 
/********************************************************************/
 typedef struct _W_loop   {
   int w_shift ;
   int pos_word[MAX_SHIFT+1];
   int pos_dic[MAX_SHIFT+1] ;
   char code_multi[MAX_SHIFT+1];/* code for multiword expressions*/
   char *s_expr[MAX_SHIFT+1];/* chain for the full expression */
}W_loop ; 
/********************************************************************/
/********************************************************************/
typedef struct _Prenestro {

   int nc_max_dico[3];
   int npix_dico[3];
   int npix_tot_dico[1];
   int level_dico[3];
   char BFE_dico[10];
   char font_dico[100];
   GdkColor Color_dico[5];
   int book_pix_size[3] ;
 /**  char *ss_trf;**/
}Prenestro ;/** struct used to define the window sizes
	      and caracteristics*/
/********************************************************************/
typedef struct _Trf_capsul {

   int nb;
   int nb0;
   long  *posit;
/*   long  pos_db[400];*/
   long  *pos_db;
   GtkWidget *entry;
 /**  char *ss_trf;**/
}Trf_capsul ;/** struct used to navigate the dictionaries */
/********************************************************************/
typedef struct _Trf_string {
    int priority;
    int nb_dico;
    int lenmx_string ; /*length of strings st_dico, st_idx1, st_alias*/
    char *st_dico;
    char *st_idx1;
    char *st_alias;
    /*  length of strings norm_dico and color_dico is nb_dico+1 */
    char *norm_dico;/*  norm of a dico useful for combing and displaying
                        the dictionaries */
    char *color_dico ;/* the words of a dico may be displayed 
			with a given color (not implemented yet) */
}Trf_string;/** struct used to transfer strings **/
/********************************************************************/
typedef struct _Trf_combing { /* used to comb dictionaries  */
    int len_words_add ; /*length of string st_words_add */
    int len_gramm_add ; /*length of string st_gramm_add for grammar adds*/
    int len_words_extracted; /*  working chain*/
    char *st_words_add;
    char *st_gramm_add;
    char *words_extracted;
}Trf_combing;/** struct used to transfer strings of additional words **/
/********************************************************************/
typedef struct _Trf_Clist {

   GtkWidget *clist[3];
   char *which_dico;
   int no_which_dico ;
   long adres_dico ;
   Trf_string *G_dico;
   Trf_capsul *cap;
   Prenestro *Caract_win;
   char s1_entry[104];
 /**  char *ss_trf;**/
}Trf_Clist ;/** struct used to navigate the dictionaries */
/********************************************************************/
typedef struct _Trf_klik {

   int ibb ;/* total number of calls for dictionary windows */
   int status_hbox ; /* status number of hbox_trf */	   
   GtkWidget *ClearG_Dic;  
   GtkWidget *ppbox_trf;  
   GtkWidget *pbox_trf;  
   GtkWidget *hbox_trf;
   GtkWidget  *vbox_trf[3];
   Trf_Clist *tClist;
   GtkWidget  *button_clear[3];
   GtkWidget  *label_word;
   GtkWidget  *button1;
   char s_klik[100]; /* number put as a character string */
   int add_posit;
   char *s_word ;/*  text of button*/
   char *s_expr ; /* chain for the full expression */
   char *s_button ;
}Trf_klik ;/** struct used to transfer data between book and dictionaries windows*/
/********************************************************************/
typedef struct _Trf_entry {

 /*  GtkWidget *entry;  */
/*   Trf_capsul *cap;  */
   int ncall_entry;
   W_loop *w_loop;
   char s1_entry[6][100];
   Trf_klik *klik[NSUP_ENTRY] ;  
 /**  char *ss_trf;**/
}Trf_entry ;/** struct used to copy text into the command line      */
/********************************************************************/
typedef struct _Trf_extrm {

   int nb_line;
   int nbsup_line;
   int max_line;
   int nb_word;
   int nbsup_word;
   int max_word;
   int nchar_line; // nb charc by line ***
   int nline_page; // nb line by page ***
 /**  char *ss_trf;**/
}Trf_extrm ;/** struct used to transfer data between book and dictionaries windows*/
/********************************************************************/
typedef struct _Trf_book {
      int nb0;
      int nb ;
      int ifile_book ; // This is the current file_book number
      int ipage ; /* This is the current page number */
      int max_pages ; // max pages in ifile_book
      int nt_books ; // total number of books in library
      int lstb_insert ; // last book before book insertion
      int ibb ;/* total number of calls for dictionary windows */
      long *posit ;
      long *pos_db ;
      FILE *fp_log; /*  log output file */
/*      char pages[1000];   */
      int lenmx_pages ;
      char *pages; /* adjustable string with the names of the file books */
      GtkWidget *win_main ;
      GtkWidget *win_book ;
//      GtkWidget *win_label ;
      GtkWidget *hzbox ;
      GtkWidget *box1 ;
      GtkWidget *scroll_bzh ;
      GtkWidget *dico_b ;
      GtkWidget *entry_book;
/*      GtkWidget *clist ;  */
/*      GtkWidget *label_word[MAX_WORD];
      GtkWidget *button1[MAX_WORD];*/
      Trf_string *stgs_dico;
      Trf_klik *klik[MAX_WORD]; 
      char *s_button[MAX_WORD];
//      Trf_Sklik *Sklik; /* Super klik pack of all the kliks */
      GtkWidget *lbox2[100];/* The lines onto the page */
      Trf_extrm *extrm;
}Trf_book;/** struct used to transfer data between pages of book **/
/********************************************************************/
typedef struct _Trf_posit{
   int nb_posit;
   int nbmx_posit;
   int n_highlight;
   long *posit;
   int nb_pos_db;
   int nbmx_pos_db;
   long *pos_db;
}Trf_posit;
/********************************************************************/
/*             Prototype of functions                       ********/
/********************************************************************/
void CREATE2_BUTTON_PRINTF(GtkWidget *box[],int il,  \
	          char s1_col[], char s1_word[],char s1_expr[],\
              char s1_klik[],int add1_posit,GtkWidget *scroll_bzh, \
                          GtkWidget *dico_b, int ib , \
  Trf_string *stgs_dico,Trf_klik *klik[], int cd_multi)  ;
/********************************************************************/
void CREATE_BUTTON_PRINTF(GtkWidget *box[],int il,  \
	char s1_col[], char s1_word[],char s1_expr[],\
              char s1_klik[],int add1_posit,GtkWidget *scroll_bzh, \
                          GtkWidget *dico_b, int ib , \
  Trf_string *stgs_dico,Trf_klik *klik[], int cd_multi)  ;
/*################################################################*/
int NO_PUNCTU(char *s);
/*################################################################*/
  void write_com_line( GtkWidget  *widget,
                       GdkEvent *event,
                       Trf_klik *data ) ;
/*################################################################*/
int NO_WHITE_LINE(char s[]);
/*################################################################*/
 int FILE_NAME_CMD_LINE(char *s1,char *s , int ipage,int max_pages);
/*################################################################*/
void EXTRACT_ONE_PAGE(int itype,long int li0[], long int li1[], \
         Trf_extrm *extrm,int iappel, FILE *fp , int nb ,\
		long posit[] ,int nb0,\
	long pos_db[],GtkWidget *box1,GtkWidget *lbox2[], \
	GtkWidget *scroll_bzh, GtkWidget *dico_b,   \
	Trf_string *stgs_dico,Trf_klik *klik[]);
/********************************************************************/
void LENN_LEVR(Trf_extrm *extrm,int iappel,FILE *fp ,\
		int nb , long posit[] , int nb0 , \
               long pos_db[], GtkWidget *box1,GtkWidget *lbox2[], \
     GtkWidget *scroll_bzh, GtkWidget *dico_b , \
      Trf_string *stgs_dico,Trf_klik *klik[]) ;
/********************************************************************/
void LECT_FICH_QUERE (Trf_extrm *extrm,int nb0, int nb,\
		long posit[] , long pos_db[], \
      GtkWidget *box1,GtkWidget *lbox2[], \
      GtkWidget *scroll_bzh,  \
      GtkWidget *dico_b, \
      Trf_string *stgs_dico,Trf_klik *klik[],\
      Trf_book *book,GtkWidget *win_book,GtkWidget *entry_book) ;
/*      Trf_string *stgs_dico,Trf_klik *klik[],char pages[] ,\
      GtkWidget *win_book, GtkWidget *win_label) ;*/
/********************************************************************/
  gint delete_event( GtkWidget *widget,
                     GdkEvent  *event,
                     gpointer   data );
/********************************************************************/
  gboolean callback_down(GtkWidget *widget, GdkEvent *event, gpointer data);
/********************************************************************/
  void callback_down2(GtkWidget *widget, GdkEvent *event, Trf_klik *data);
/********************************************************************/
  gboolean callback_up(GtkWidget *widget, GdkEvent *event, gpointer data);
/********************************************************************/
  void callback_up2(GtkWidget *widget, GdkEvent *event, Trf_klik *data);
/********************************************************************/
  void callback_event(GtkWidget *widget, GdkEvent *event, \
		   Trf_klik *data);
/********************************************************************/
      void free_navig(GtkWidget *widget, Trf_Clist *navig );
/********************************************************************/
      void free_navig_i(GtkWidget *widget, Trf_entry *navig_i );
/********************************************************************/
  void ON_QUIT(GtkWidget *widget, Trf_book *data);
/********************************************************************/
  void callback_GClear_Dicos(GtkWidget *widget,  \
		   Trf_book *data);
/********************************************************************/
  void entry_GClear_Dicos(GtkWidget *widget,  \
		   Trf_entry *data);
/********************************************************************/
  void callback_PClear_Dicos(GtkWidget *widget,  \
		   Trf_klik *data);
/********************************************************************/
      void free_chain_char(GtkWidget *widget, char *ss ) ;
/********************************************************************/
  void selection_made( GtkWidget      *clist,
                       gint            row,
                       gint            column,
                       GdkEventButton *event,
                       Trf_Clist        *data );
/********************************************************************/
  void selection_made1( GtkWidget      *clist,
                       gint            row,
                       gint            column,
                       GdkEventButton *event,
                       Trf_Clist        *data );
/********************************************************************/
  void  MAKE_YOUR_CHOICE(char YEZH,int i_max,gchar *drink [][1]) ;
/********************************************************************/
  void  DRINK_UNKNOWN(char YEZH,int i_max,gchar *drink [][1]) ;
/********************************************************************/
  void  DISPATCH_OVER_LINES(gchar *text,gchar *drink [][1],
		  Trf_Clist *data) ;
/********************************************************************/
void  ADJUST_WORD(char *s_word,int add_posit,
	   long posit[],long *adres_idx);
/********************************************************************/
 int     COMPARE_STRINGS(char s_word[],char s_extr[]);
/********************************************************************/
  void cback_new_page(GtkWidget *widget,  Trf_book  *data);
  /********************************************************************/
  void cback_prev_page(GtkWidget *widget,  Trf_book  *data);
  /********************************************************************/ 
  void cback_page_not_found(GtkWidget *widget,  Trf_book  *data, char s1[]);
  /********************************************************************/ 
  void   KLASK_NB_PAJ(int *nb0_pages,char mem_pages[], char anv_file[]) ;
/********************************************************************/
void START_PAGE_NUMBER(Start_State *S_state,Trf_book *book);
/********************************************************************/
  void callback(GtkWidget *widget, GdkEvent *event, gpointer data);
/********************************************************************/
/****
 *               File :   gtkb2_2.c
 ****/               
/********************************************************************/
void CALC_INDEX( FILE *fp_log,Trf_string *G_dico , Trf_posit *t_posit ) ;
/********************************************************************/
void DO_ORD_G_IDX_FILE( Trf_string *G_dico , Trf_posit *t_posit ) ;
/********************************************************************/
void IDX1_EACH_DICO( FILE *fp_log,Trf_string *G_dico, int *modif_dico);
/********************************************************************/
void STRINGS_AJUST( Trf_string *G_dico) ;
/********************************************************************/
void   DO_UNORD_G_IDX_FILE(FILE *fp_log,Trf_string *G_dico);
/********************************************************************/
void    ADD_ENTRY_SUP(FILE *fp_log,FILE *fpii,FILE *fpi,\
	int *nbw1a,int *nbw2,char sa[], char ss1[]);
/********************************************************************/
void   EXAM_UNORD_G_IDX(Trf_string *G_dico,int  *modif);
/********************************************************************/
void   EXAM_ORD_G_IDX(Trf_string *G_dico,int  *modif);
/********************************************************************/
void TRIINS_1 (int nb , FILE *fp , long posit[] ) ;
/********************************************************************/
void TRIINS_2 (int priority,int nb , FILE *fp , long posit[] ); 
/********************************************************************/
void MERGESORT(int priority,int left0,int right0 , FILE *fp ,\
		long num[] ) ;
void MSORT(int priority, FILE *fp,long num[], long temp[],\
		int left, int right);
void MERGE(int priority, FILE *fp,long num[], long temp[],\
		int left, int mid, int right);
/********************************************************************/
void MSORT_h(int priority,FILE *fp, FILE *fph,long num[], long temp[],\
		int left, int right);
void MERGE_h(int priority,FILE *fp, FILE *fph,long num[], long temp[],\
		int left, int mid, int right);
/********************************************************************/
int COMPARE (int j , int i , FILE *fp , long posit[] ) ;
/********************************************************************/
int COMPARE_1 (char s1[] , int i , FILE *fp , long posit[] ); 
/********************************************************************/
int COMPARE_1P (char s1[] , int i , FILE *fp , long posit[] ) ;
/********************************************************************/
int COMPARE_2 (int j , int i , FILE *fp , long posit[] ) ;
/********************************************************************/
int COMPARE_3 (int priority,int j , int i , FILE *fp , long posit[] ); 
/********************************************************************/
int COMPARE_3h (int priority,int j , int i , FILE *fp , FILE *fph, \
		long posit[] ); 
/********************************************************************/
void ECHANG (int j , int i , long posit[] ) ;
/********************************************************************/
void TRIINS (int nb , FILE *fp , long posit[] ) ;
/**********************************************************************/
void TRIINS_1 (int nb , FILE *fp , long posit[] ) ;
/********************************************************************/
int EXIST_DEJA(char s1[] , FILE *fp , long posit[] , \
		int *im , int *ip) ;
/********************************************************************/
int EXIST_DEJA_2(char s1[] , FILE *fp , long posit[] , \
		int *im , int *ip) ;
/********************************************************************/
int EXIST_DEJAh(char s1[] , FILE *fp , FILE *fph,long posit[] , \
		int *im , int *ip) ;
/********************************************************************/
int EXIST_DEJA_2h(char s1[] , FILE *fp , FILE *fph, long posit[] , \
		int *im , int *ip) ;
/********************************************************************/
void FILTR_MAJ(int nb , FILE *fp , long posit[] );
/********************************************************************/
void CALC_DIB(int *nb0 , Trf_posit *t_posit );
/********************************************************************/
void POSIT_INDEX( FILE *fp , int *nb , \
		int *nb_posit, int *nbmx_posit,long **posit);
/*####################################################################*/
void TOTAL_POSIT1_INDEX( Trf_posit *t_posit, int priority);
/*####################################################################*/
void POSIT1_INDEX( FILE *fp , Trf_posit *t_posit);
/*####################################################################*/
void POSIT2_INDEX( FILE *fp , Trf_posit *t_posit);
/*####################################################################*/
void CLEAN_POSIT( FILE *fp , FILE *fph , Trf_posit *t_posit);
/*################################################################*/
void WRITE_CLEAN_POSIT( FILE *fp,FILE *fph , Trf_posit *t_posit);
/*####################################################################*/
/********************************************************************/
void SORTIE_PROV(FILE *fpi,int nb,long posit[]);
/********************************************************************/




/********************************************************************/
int POS_NALPHA(int l_dep, int l , char s[]) ;
/********************************************************************/
void  APPEL_SS_MEM(int i_dep,int i_fin,int ism,char ss_mem[][100]);
/********************************************************************/
void EXTRACT_WORD(int *i_dep,int *j_dep,int i_fin,int j_fin, \
                 char ss_mem[] [100],int nb, int nb0, \
		 long posit[] , long pos_db[] , FILE *fp1, FILE *fph, \
	 GtkWidget *box1,GtkWidget *lbox2[],W_loop *w_loop1, \
		          char s1_col[], char s1_word[],\
                          char s1_klik[],GtkWidget *scroll_bzh, \
                          GtkWidget *dico_b, int iappel,int *ib , \
	  Trf_string *stgs_dico,Trf_klik *klik[],Trf_extrm *extrm)  ;
/********************************************************************/
void FLUSH_SS_MEM(int *i_dep,int *j_dep,int i_fin,char ss_mem[][100],
                 int nb, int nb0, \
 long posit[] , long pos_db[] , FILE *fp1, FILE *fph, GtkWidget *box1,\
 GtkWidget *lbox2[],W_loop *w_loop1,\
  char s1_col[], char s1_word[],\
  char s1_klik[],GtkWidget *scroll_bzh,  GtkWidget *dico_b, \
   int iappel,int *ib ,  \
  Trf_string *stgs_dico,Trf_klik *klik[],Trf_extrm *extrm)  ;
/********************************************************************/
void CALL_FLUSH_SS_MEM(int *i_dep,int *j_dep,int i_fin,\
             char ss_mem[][100], int nb, int nb0, \
 long posit[] , long pos_db[] , FILE *fp1, FILE *fph, GtkWidget *box1,\
 GtkWidget *lbox2[],W_loop *w_loop1,\
  char s1_col[], char s1_word[],\
  char s1_klik[],GtkWidget *scroll_bzh,  GtkWidget *dico_b, \
   int iappel,int *ib ,  \
  Trf_string *stgs_dico,Trf_klik *klik[],Trf_extrm *extrm)  ;
/********************************************************************/
void ADD_DISPLAY_SINGLE_LINE(char *s,int *it,int *kt,\
      int *it_dep,int *jt_dep,int *lb,\
      char ss_mem[][100], int nb, int nb0, \
 long posit[] , long pos_db[] , FILE *fp1, FILE *fph, GtkWidget *box1,\
 GtkWidget *lbox2[],W_loop *w_loop1,\
  char s1_col[], char s1_word[],\
  char s1_klik[],GtkWidget *scroll_bzh,  GtkWidget *dico_b, \
   int iappel,int *ib ,  \
  Trf_string *stgs_dico,Trf_klik *klik[],Trf_extrm *extrm)  ;
/********************************************************************/
void COMPLETE_MEMORY_LINE(char *s,int *it,int *kt,\
      int *it_dep,int *jt_dep,\
      char ss_mem[][100], int nb, int nb0, \
 long posit[] , long pos_db[] , FILE *fp1, FILE *fph, GtkWidget *box1,\
 GtkWidget *lbox2[],W_loop *w_loop1,\
  char s1_col[], char s1_word[],\
  char s1_klik[],GtkWidget *scroll_bzh,  GtkWidget *dico_b, \
   int iappel,int *ib ,  \
  Trf_string *stgs_dico,Trf_klik *klik[],Trf_extrm *extrm)  ;
/********************************************************************/
void ADD_TO_MEMORY_LINE(char *s,int i, char ss_mem[][100]);
/********************************************************************/
void FURCH_WORD(int ki_dep, int kj_dep,int *kki_fin,int *kkj_fin, \
                 char ss_mem[] [100],int nb, int nb0, \
		 long posit[] , long pos_db[] , FILE *fp1,  FILE *fph,\
	 GtkWidget *box1,GtkWidget *lbox2[],W_loop *w_loop1, \
		          char s1_col[], char s1_word[],\
                          char s1_klik[],GtkWidget *scroll_bzh, \
                          GtkWidget *dico_b, int iappel,int *ib , \
	  Trf_string *stgs_dico,Trf_klik *klik[], \
	  Trf_extrm *extrm)  ;
/*#################################################################*/
void  EXTRACT_WORD_IN_SS_MEM(int *j,int jj_sup,char *ss_mem,char *s1);
/*#################################################################*/
void  EIL_EXTRACT_WORD_SSMEM(int *j,int jj_sup,char *ss_mem,char *s1);
/*#################################################################*/
void WRITE_PACK_OF_WORDS(int ki_dep, int kj_dep,\
		int *kki_fin,int *kkj_fin, \
         int iw_tot,char ss_mem[][100],int ism,int nb,  \
		 long posit[] ,  FILE *fp1, FILE *fph,\
         GtkWidget *box1,GtkWidget *lbox2[], W_loop *w_loop1,\
            char s1_col[], char s1_word[],\
                          char s1_klik[],GtkWidget *scroll_bzh, \
                          GtkWidget *dico_b, \
			   int iappel,int *ib , \
	  Trf_string *stgs_dico,Trf_klik *klik[], \
	  Trf_extrm *extrm)  ;
/********************************************************************/
void SEARCH_WORD( char ss_mem[][100],int nb, int nb0, \
		 long posit[] , long pos_db[] , FILE *fp1, \
                 W_loop *w_loop1, int *iw ) ;
/********************************************************************/
void SEARCH_EXPLODE(int iw,int *iwt,W_loop *w_loop1, \
  char ss_mem[] [100],FILE *fp1,FILE *fph,long posit[],long pos_db[],\
	    int *im0,int *im2,int im3) ;
/********************************************************************/
void ADD_EXPLODE_TIR_WORD(int i,int *iwt,\
     W_loop *w_loop1, char s1[],char ss_mem[] [100],FILE *fp1,\
     FILE *fph,long posit[],long pos_db[],\
	    int *im0,int *im2,int im3);
/********************************************************************/
int FURCH(char s1[] , FILE *fp , FILE *fph,long posit[] , \
		long pos_db[] ,int *im , int *ip, int idb); 
/********************************************************************/
int STRICT_FURCH(char s1[] , FILE *fp , FILE *fph,long posit[] , \
		long pos_db[] , int *im , int *ip, int idb); 
/********************************************************************/
int DIBENN(char s1[] ,int *im0, int *ip0, FILE *fp , FILE *fph, \
		long posit[] ,long pos_db[], int *im , int *ip) ;
/********************************************************************/
int PENN_KENTAN(char s1[] , FILE *fp, FILE *fph, long posit[] , \
		int *im , int *ip); 
/********************************************************************/
int STRICT_PENN_KENTAN(char s1[] , FILE *fp , FILE *fph, long posit[] \
		,int *im , int *ip); 
/********************************************************************/
int CLIMB(int l0,char s2[], char s3[], FILE *fpi, long posit[], int *im) ;
/********************************************************************/
int COMPARE_1 (char s1[] , int i , FILE *fp , long posit[] ) ;
/********************************************************************/
int COMPARE_1h (char s1[] , int i , FILE *fp, FILE *fph , long posit[] ) ;
/********************************************************************/
int COMPARE_1P (char s1[] , int i , FILE *fp , long posit[] ) ;
/********************************************************************/
int COMPARE_1Ph (char s1[] , int i , FILE *fp ,FILE *fph, long posit[] ) ;
/********************************************************************/
int IDX_GENE_EXTRACT ( int i , FILE *fp, FILE *fph, long posit[] ) ;
/********************************************************************/
void FIND_PAR1(char s[],int brk[]) ;
/********************************************************************/
void EXTRACT_N_INT(int n,char *s, int i_extracted[]);
/********************************************************************/
void ADJ_S_EXPR_FIRST_CHAR(int ish,W_loop *w_loop1, \
     char ss[],FILE *fp1,FILE *fph,long posit[]);
/********************************************************************/
void ADJ1_S_EXPR_FIRST_CHAR(int ish,W_loop *w_loop1, \
     char ss[],FILE *fp1,FILE *fph,long posit[]);
/********************************************************************/
void ADJ_S_EXPR(int iw,int iwm,W_loop *w_loop1, \
     char ss_mem[] [100],FILE *fp1,FILE *fph,long posit[]);
/********************************************************************/
int EXIST_MULTI1(int *j,int iw,W_loop *w_loop1, \
            char ss_mem[][100],FILE *fp1, FILE *fph,long posit[],\
	    int *im0,int *im2) ;
/********************************************************************/
void STRICT_SEARCH(int *iw,W_loop *w_loop1, \
     char ss_mem[] [100],FILE *fp1,FILE *fph,long posit[],long pos_db[],\
	    int *im0,int *im2,int im3) ;
/********************************************************************/
void EXPLODE_TIRETED_WORD(int i,int *iw,W_loop *w_loop1, char s1[],\
  char ss_mem[] [100],FILE *fp1,FILE *fph,long posit[],long pos_db[],\
	    int *im0,int *im2,int im3);
/********************************************************************/
void ELIM_HIGHLIGHTED(int iw,W_loop *w_loop1, \
  char ss_mem[] [100],FILE *fp1,FILE *fph,long posit[],long pos_db[],\
	    int *im0,int *im2,int im3); 
/********************************************************************/
void ELIM1_HIGHLIGHTED(int *dj, char s[],FILE *fp,int nmax_posit,\
		long posit[], long *adres, int *im) ;
/********************************************************************/
int EXIST_MULTI2(int *jj,int iw, int *iw_tot,W_loop *w_loop1, \
    char ss_mem[][100],FILE *fp1,FILE *fph,long posit[],\
    int *im0,int *im2) ;
/********************************************************************/
int EXIST_OCHV(int j,W_loop *w_loop1 ,char ss_mem[] [100], \
               FILE *fp1,long posit[],int *im0,int *im2) ;
/********************************************************************/
char  COL_SPEC_N(char s1[], int i,int iwsh, W_loop *w_loop1,\
	long posit[], FILE *fp, FILE *fph,int im0, int im2)  ;
/********************************************************************/
char  COL_SPEC_B(char s1[], int i,int iwsh, W_loop *w_loop1,\
	long posit[], FILE *fp, FILE *fph,int im0, int im2)  ;
/********************************************************************/
void  PARTIAL_HIGHLIGHT(char ss[],char *cc,FILE *fph);
/********************************************************************/
void BUTTON_PRINTF(GtkWidget *lbox2[],int il,char ss_mem[][100],int imax,   \
	int iw_dep,int iw_fin,int iw_tot,W_loop *w_loop1,\
	long posit [],FILE *fp1, FILE *fph, \
	char s1_col[], char s1_word[],\
	char s1_klik[],GtkWidget *scroll_bzh, \
	GtkWidget *dico_b,  int iappel, int *ib , \
	Trf_string *stgs_dico,Trf_klik *klik[],\
	Trf_extrm *extrm)  ;
/********************************************************************/
int  TEST_MULTIWORD(int iw, int iw_tot,W_loop *w_loop1,\
		char ss_mem [][100],int *nb_words);
/********************************************************************/
void ADJUST_S_WORD(int test_multi,int nb_words, int ib, Trf_klik *klik[]);
/********************************************************************/
void CREATE_BUTTON_PRINTF_P(GtkWidget *box, char s1_col[],  \
	char s1_word[],	char s1_klik[]);  
/********************************************************************/
void DEF_COLOR(int ic0,char ss_mem[][100],char s1_col []);
/********************************************************************/
void DEF_COLOR1(int il, int ic0,int ic1, \
		char ss_mem[][100],char s1_col []);
/********************************************************************/
void DEF_S1_KLIK(int iw,W_loop *w_loop1,long posit[],\
   FILE *fp1,FILE *fph,char s1_klik[],int *add1_posit);
/********************************************************************/
void DEF2_S1_KLIK(FILE *fp1, int iw, int ia,Trf_entry *Tentry,\
		      int *add_posit,long *adres_idx);
/********************************************************************/
void  SUPER_FURCH(char s1[] , FILE *fp ,FILE *fph, long posit[] , \
      long pos_db[] , int *im , int *ip, int idb,int il, int ic, \
      int *iw, W_loop *w_loop1);
/********************************************************************/
void TRO_ACCENT(int *i, int *j ,char s1[] );
/********************************************************************/
void RM_ACCENTS(char s1[] );
/********************************************************************/
void RM_ACCENTS_AND_TRANSF(char s1[] );
/********************************************************************/
int SPE_ALPHA_NUM(char s1 ) ;
/********************************************************************/
int SPE_PUNCTU(char s1 );
/********************************************************************/
void WORK_RM_ACCENT(int *i, int *j ,char s1[] );
/********************************************************************/
void WORK_ACCENT(int *i, int *nb ,char s1[] );
/********************************************************************/
void DECODE_ACCENTS(char s1[] );
/********************************************************************/
void SMPLF_SUP_INF(int *code_scd_entry,int *code_scd_parenth,char s[] );
/********************************************************************/
/**  void OBER_CLIST( Prenestro *Caract_win,long adres, \
		  GtkWidget *clist1,GtkWidget *clist2, \
		  GtkWidget *clist3, char s_word[]);
**/
  void OBER_CLIST( Trf_Clist *navig,long adres,char s_word[]);
/********************************************************************/
  void DUMMY_OBER_CLIST( Trf_Clist *navig,long adres,char s_word[]);
/********************************************************************/
  void RANN0_OBER_CLIST( Trf_Clist *navig, long adres_idx , \
  char s_word[], long adres,char s_dico[],char s_alias[], \
  int n_dico, int nb_times,char s_true[]);
/********************************************************************/
  void RANN1_OBER_CLIST( Trf_Clist *navig, long adres_idx , \
  char s_word[], long adres,char s_dico[],char s_alias[], \
  int n_dico, int nb_times);
/********************************************************************/
void  EXTRACT_DICO_NAME_ADD(char s_gene[],Trf_string *G_dico, \
		char s_dico[], char s_alias[] ,int *n_dico, long *adres);
/********************************************************************/
void  EXTRACT_ALIAS_NO(char s_gene[],Trf_string *G_dico, \
		 char s_alias[],int *n_dico);
/********************************************************************/
void  ADJUST_ADRES(FILE *fp,long *adres,int ndic,int ndic1, \
		Trf_string *G_dico);
/********************************************************************/
void  ADJUST2_ADRES(char with_accent[] ,FILE *fp,long *adres,\
		int ndic, int ndic1, Trf_string *G_dico);
/********************************************************************/
void  ADJUST1_ADRES(FILE *fp,long *adres,int ndic,Trf_string *G_dico);
/********************************************************************/
long KLASK_BZ(char BFE, FILE *fp, long adres);
/********************************************************************/
void RM_EXTRA(char s[],char y[]);
/********************************************************************/
void GET_WORD_STRING(int l, char s[], int i_deb, int *i_fin, \
		int *i_next_deb);
/********************************************************************/
void SKRIVAN_LINE(int code_print,PangoFontDescription *fs,\
    int npix_max,int *nchar_max,char s_star[],\
    int *i0star_mem,int *i1star_mem,char s_mem[], char s[], \
    int *i_fin_mem,GtkWidget *clist,GdkColor white[], \
    int *code_fond,int *nl,int  no_dico, Trf_string *G_dico) ;
/********************************************************************/
void  STAR_I0_I1(char s_star[],char s[],int *i0_star,int *i1_star);
/********************************************************************/
int sg_text_width(char *txt, PangoFontDescription *font);
/********************************************************************/
void  POSITION_DBLE_STAR(char *star,char s[],int l_s, int l_star,
		int *i0_star, int *i1_star);
/********************************************************************/
int  COND_PIX_CHAR(char s_mem[],char drink1[],
	int npix_max,int *nchar_max,PangoFontDescription *fs);
/********************************************************************/
void MODIF_S(char s[],int  no_dico, Trf_string *G_dico) ;
/********************************************************************/
void  ALIAS_TO_NB(Trf_string *G_dico,char sta[],int *nb_alias) ;
/********************************************************************/
void FORCE_FLUSH(int code_print,int nchar_max,\
int *i0star_mem,int *i1star_mem,char s_mem[],  \
int *i_fin_mem, GtkWidget *clist, GdkColor white[],\
int *code_fond,int *nl) ;
/********************************************************************/
void JUMP_LINE( int code_print,int *i_fin_m, \
GtkWidget *clist,GdkColor white[], int *code_fond, int *nl) ;
/********************************************************************/
  void DOWN_DICO(PangoFontDescription *fs, char BFE,char s_star[],\
		  FILE *fp, long *first,  \
  int npix_max,int *nchar_dic_i, GtkWidget *clist1, int *nl, int *code_end,\
  int y_case_mem[], int level,int level_sup,GdkColor white[],\
  int no_dico, Trf_string *G_dico);
/********************************************************************/
  void DOWN1_DICO(PangoFontDescription *fs, char BFE,\
		  FILE *fp, long *first, \
  int npix_max,int *nchar_dic_i, GtkWidget *clist1, int *nl, int *code_end,\
  int y_case_mem[], int level,int level_sup,GdkColor white[],\
  int no_dico, Trf_string *G_dico);
/********************************************************************/
void  REMOVE_PARENTH(int *i_parenth, char s[]);
/*********************************************************************/
void ELIM_BLANK(char *stp);
/*********************************************************************/
void ELIM_BETW_PARENTH(char s[],char *stp, char *stp3);
/********************************************************************/
  void DOWN_DICO_COMBING( FILE *fp_log,char BFE, FILE *fp, long *first,\
		  Trf_combing *t_combing);
/********************************************************************/
  void DOWN_DICO_SCOMBING(FILE *fp_log,int code, char BFE, FILE *fp,\
		  long *first,Trf_combing *t_combing );
/********************************************************************/
  void INIT_GRAMM( FILE *fp_log,char ss[],Trf_combing *t_combing );
/********************************************************************/
void  EXTRACT_BETW_QUOTES(FILE *fp_log,int *i_quote,char s[],\
        Trf_combing *t_combing);
/********************************************************************/
void  EXTRACT_BETW_SQUOTES(FILE *fp_log,int *i_quote,int code,char s[],\
        Trf_combing *t_combing);
/********************************************************************/
void  ADD_T_COMBING(Trf_combing *t_combing);
/********************************************************************/
void  ADD_T_SCOMBING(Trf_combing *t_combing);
/********************************************************************/
void  CONDENS_T_COMBING(FILE *fp_log,Trf_combing *t_combing);
/********************************************************************/
void  CONDENS1_T_COMBING(FILE *fp_log,Trf_combing *t_combing);
/********************************************************************/
void  DEPLACE_GRAMM(int *ideb_g2, int *ideb_g,int i1, int i2, char *s);
/********************************************************************/
void  WFILE_T_COMBING(FILE *fp_log,FILE *fp2,char s2[],\
		Trf_combing *t_combing, int *tnbw);
/********************************************************************/
void  WFILE_T_SCOMBING(FILE *fp_log,FILE *fp2,char s2[],\
		Trf_combing *t_combing, int *tnbw);
/********************************************************************/
void WORDS_BETW_QUOTES(FILE *fp_log,char s[],char *stp, char *stp3, \
	Trf_combing *t_combing);
/********************************************************************/
void ANALY_EXTRA(char y[],int y_case[]);
/********************************************************************/
void     TREAT_FIRST_LINE(gint row,gchar *text,Trf_Clist *data);
/********************************************************************/
void     HOW_MUCH_SAME_WORD(FILE *fp,FILE *fph,char s_idx_gene[],\
		Trf_Clist *data, int *nb_times);
/********************************************************************/
void     EXTRACT_NB_ADRES(gchar *text,int *n_adres);
/********************************************************************/
void  EXTRACT_ADRES_DICOS(gchar *text,Trf_Clist *data,int *n_adres, \
		long adres_dico[]);
/********************************************************************/
void     TOWARDS_ACCENTS(FILE *fp,char sans_accents[],\
      int n_dico, Trf_Clist *data, long *adres_dico, \
      char avec_accents[]);
/********************************************************************/
void   TOWARD1_ACCENTS(char s[],Trf_string *G_dico,   \
		char avec_accents[], int *n_dico, char s_alias[] );
/********************************************************************/
void  GET_ADRES_DICOS(Trf_Clist *data,int *n_adres, \
		long adres_dico[]);
/********************************************************************/
void  ADD_INDIRECTIONS(FILE *fp,char s_gene[],Trf_Clist *data);
/********************************************************************/
void  GOTODIC_OLD_NORM(char **ptc1,Trf_Clist *data,int *n_adres, \
		long adres_dico[],FILE *fp,FILE *fph) ;
/********************************************************************/
void  RM_EXTRA_BLANCS(char *s);
/********************************************************************/
void  GOTODIC_NEW_NORM(char **ptc1,Trf_Clist *data,int *n_adres, \
		long adres_dico[],FILE *fp, FILE *fph) ;
/********************************************************************/
void     SORT_ADRES_DICOS(Trf_Clist *data,int *n_adres, \
		long adres_dico[]);
/********************************************************************/
void     SUPL_ADRES_DICOS(Trf_Clist *data,int *n_adres, \
		long adres_dico[]);
/********************************************************************/
void  NGOTODIC_OLD_NORM(char **ptc1,Trf_Clist *data,int n0_dico, \
		FILE *fp) ;
/********************************************************************/
void  NGOTODIC_NEW_NORM(char **ptc1,Trf_Clist *data,int n0_dico, \
		FILE *fp) ;
/********************************************************************/
/********************************************************************/
/********************************************************************/
/********************************************************************/
/********************************************************************/
/************          gtkb2_5.c                         ************/
/************   This file contains the  utility sub      ************/
/************   which are used to treat the        .     ************/
/************   configuration file : furch.conf          ************/
/************                                            ************/
/********************************************************************/
/********************************************************************/
void  FURCH_SET(Prenestro *Caract_win,Trf_book *book, \
		Trf_string *G_dico, int *n_highlight);
/********************************************************************/
//void   EXTRACT_PAGES(FILE *fp,char s[],int *n_pages,char ss_pages[]);
void   EXTRACT_PAGES(FILE *fp,char s[],int *n_pages,Trf_book *book);
/********************************************************************/
void   EXTRACT_DICO_NAMES(FILE *fp,char s[],Trf_string *G_dico);
/********************************************************************/
void    EXTRACT_INPUT(int *n_pages,int i,char s[],\
		char ss_pages[],int *code_fin)	;
/********************************************************************/
void   EXTRACT_HIGHLIGHT(FILE *fp,char s[],int *n_words);
/********************************************************************/
void    EXTRACT1_INPUT(int i,char s[],\
		Trf_string *G_dico,int *code_fin);
/********************************************************************/
void    SCD(char s[],char s_file[],\
		Trf_string *G_dico,int *code_loop, int *code_fin);
/********************************************************************/
void    EXTRACT2_INPUT(int i,char s[],\
		Trf_book *book,int *code_fin);
/********************************************************************/
void    EXTRACT3_INPUT(int i,char s[],char s1[],int *code_fin);
/********************************************************************/
void   EXTRACT_ORDER(FILE *fp,char s[],char BFE[]);
/********************************************************************/
void   EXTRACT_LEVEL(FILE *fp,char s[],int nb_tobe,int param[]);
/********************************************************************/
void   EXTRACT_COLOR(FILE *fp,char s[],GdkColor *white);
/********************************************************************/
void    EXTRACT_FONT_NAME(int *n_fonts,int i,char s[],\
		char ss_fonts[],int *code_fin)	;
/********************************************************************/
void   EXTRACT_FONT_DICO(FILE *fp,char s[],int *n_fonts, \
		char ss_fonts[]);
/********************************************************************/
void    FILTRE_FONT_DICO(char s[],char ss_fonts[]) ;
/********************************************************************/
void   KLASK_PAJ(int *jpage,int *jfile_book,char mem_pages[],\
        char anv_file[], long int li0_extracted[],long int li1_extracted[],\
	      int *type, int *max_pages, int *nt_books);
/********************************************************************/
void   CASE_ARROW(char anv_file[],int nb0_pages,int n1,int n2,int jpages);
/********************************************************************/
void   EXTRACT_2NB(char anv_file[],int *n1,int *n2);
/********************************************************************/
int COMPAT(FILE *fp,FILE *fph,int iim0,long posit[],\
		                 char s3[] ,char s1[]) ;
/********************************************************************/
void callback_entry( GtkWidget *widget, Trf_entry *Tentry );
/********************************************************************/
  void callback_entry_book( GtkWidget *widget, Trf_book *book );
/********************************************************************/
int  EXTRACT_NB_FIRST_FIELD(char *ss);
/********************************************************************/
void clean_entry( GtkWidget *widget, GdkEvent *event,Trf_entry *Tentry );
/********************************************************************/
  void clean_entry_book( GtkWidget *widget, GdkEvent *event,\
		  Trf_book *book );
/********************************************************************/
  void SUITE_CBACK_ENTRY( long adres_idx, Trf_klik *data);
/********************************************************************/
void    FROM_COM_LINE(int ia, int iw,FILE *fp1,Trf_entry *Tentry);
/********************************************************************/
  void  EIL_LINE(char YEZH,int i_max,char drink []) ;
/********************************************************************/
void IDX1_DICO( FILE *fp_log,FILE *fp , char s[], char s1[],\
		FILE *fpi, int *nb);
/********************************************************************/
void  OTHER_WORDS(FILE *fp, FILE *fpi, char ss[]);
/********************************************************************/
void IDX1_DICO_SPLF( FILE *fp_log,FILE *fp , char s[],FILE *fpi, int *nb);
/********************************************************************/
int end_word(int idep, char s[]);
/********************************************************************/
double DIFF_TIME_FILE(char name_file_origin[] , 
		                char name_file_derived[] );
/********************************************************************/
 void   WINDOWS_DIFFTIME(double *deltat,char ss_timer[],\
		 char ss_timer1[]);
/********************************************************************/
char *PATH_FROM_G_dico(int i, Trf_string *G_dico) ;
/********************************************************************/
char *FILE_FROM_G_dico(int i, Trf_string *G_dico) ;
/********************************************************************/
   char *PATH_FROM_STRING_FILE(char path_file[]);
/********************************************************************/
   char *RM_PATH_FROM_STRING(char path[]);
/********************************************************************/
   char *FILENAME_FROM_PATH(char path[]);
/********************************************************************/
   char *EXTRACT_SHABANG(FILE *fp);
/********************************************************************/
   void EXTRACT_NORM_DICO(FILE *fp,int n_dico,Trf_string *G_dico);
/********************************************************************/
  void     TREAT_SS_GIDX(char ss[] ,char sa[], long nc_diff) ;
/********************************************************************/
  void     ELIM_POSIT(FILE *fp , int *nb, long posit[]) ;
/********************************************************************/
void MODIF_POSIT(int ii,long nc,long posit[]);
/********************************************************************/
void   PAJ_BEFORE(int i0_pos, char mem_pages[],int *page_ante);
/********************************************************************/
void START_OF_NUMBER(char *ss1,int iss1_bfnb, int iss1_afnb,\
           int nb_in_file, char *book_list_tot,\
             char *book_pages, int *page_ante);
/********************************************************************/
void NUMBER_IN_FILE(char *ss1,int *iss1_bfnb,int *iss1_afnb, int *nb_in_file);
/********************************************************************/
void FIRST_NUMBER_IN_FILE(char *ss1,int iss1_start,\
                 int *iss1_bfnb,int *iss1_afnb, int *nb_in_file);
/********************************************************************/
void FILE_NOT_FOUND(Trf_extrm *extrm,int iappel, int nb ,\
		long posit[] ,int nb0,\
	long pos_db[],GtkWidget *box1,GtkWidget *lbox2[], \
	GtkWidget *scroll_bzh, GtkWidget *dico_b,   \
	Trf_string *stgs_dico,Trf_klik *klik[],char s1[]) ;
/********************************************************************/
  void cback_page_parachutee(GtkWidget *widget,  Trf_book  *data, char *s1);
/********************************************************************/
 int  IS_PAGE_KNOWN(char *stbp,int ipath,char *ss0,char *ss1 );
/********************************************************************/
 int  ARROW_IS_PAGE_KNOWN(char *stbp,int ipath,char *ss0 );
/********************************************************************/
void   INSERT_IN_BOOK_STRING(char *ss0,Trf_book *book);
/********************************************************************/
int  EXTRACT_SCD_FIELD(char *ss);
/********************************************************************/
/*
 *       File :   gtkb_prepfiles.c
 */
/********************************************************************/
void   PRELECT_ALL_FILES(Trf_book *book);
/********************************************************************/
int  TEST_DSCR_ASSOC_FILE(char *ss,int ncharl, int nlp_max,FILE *fp_dscr);
/********************************************************************/
int  MAX_PAGES_IN_FILE(char *ss);
/********************************************************************/
int EXTRACT4_ONE_PAGE(long int li0[], long int li1[], \
         Trf_extrm *extrm,int iappel, FILE *fp , int nb ,\
		long posit[] ,int nb0,\
	long pos_db[],GtkWidget *box1,GtkWidget *lbox2[], \
	GtkWidget *scroll_bzh, GtkWidget *dico_b,   \
	Trf_string *stgs_dico,Trf_klik *klik[]);
/********************************************************************/
void DUMP_SS_MEM ( char ss_mem[][100], int i_dep, int i_fin);
/********************************************************************/
int OPEN8PAR(char c);
/********************************************************************/
/********************************************************************/
/********************************************************************/
/********************************************************************/
/********************************************************************/
/********************************************************************/
/***********************  end of header file    *********************/
/********************************************************************/
/********************************************************************/
/********************************************************************/
/********************************************************************/
/********************************************************************/
/********************************************************************/
