# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include <ctype.h>
# include <stddef.h>
#include <gtk/gtk.h>
#include "gtkb2_0.h"

/********************************************************************/
/********************************************************************/
/*********            file gtkb2_8.c                    *************/
/*
 *   Treatment of the book command line
 */
/********************************************************************/
/*################################################################*/
  void clean_entry_book( GtkWidget *widget, GdkEvent *event,\
		  Trf_book *book )
/*
 *    When clicked the entry line of the book part will be cleaned of the
 *    selected characters
 */
{/*   start clean_entry_book   */
    gint start,end;

/* 
 */
      gtk_editable_get_selection_bounds(GTK_EDITABLE(\
	book -> entry_book),&start,&end); 
/*      printf("clean entry start=%d end=%d \n",start,end);
      fflush(stdout);*/ 
      if(end > 0){
/*        gtk_editable_cut_clipboard(GTK_EDITABLE(\
	Tentry -> klik[0] -> tClist -> cap -> entry)); */
        gtk_editable_delete_selection(GTK_EDITABLE(\
	book -> entry_book)); 
      }/*if(end > 0){*/
}/*   end of clean_entry   */
/*################################################################*/
  void callback_entry_book( GtkWidget *widget, Trf_book *book )
  /*    
   *    On a un Trf_book  au lieu d'un Trf_klik
   *    We must try to find the page which is 
   *    written into the entry line.
   *    
   *   
   */
  {
    const gchar *entry_text;
    FILE *fp;
    gchar  *ss,*ss1,*stbp,*ss0;
    int l,l1,i,is,is0,j;
    int page_ante,prim_field;
    int iss_path,scd_field,max_pages;
 /*
  * Not understood why but the gtk_rc_parse_string are necessary otherwise
  * the change of file by the command line makes unwanted coloring of 
  * the words when the mouse pointer is on a word and still have a
  * return on the command line 
  */
/*
 */
      char ss_red[]="widget \"*buttonred*\" style \"button_red\"";
      gtk_rc_parse_string(ss_red);
      char ss_redhl[]="widget \"*buttonhlred*\" style \"button_red_hlight\"";
      gtk_rc_parse_string(ss_redhl);
      char ss_green[]="widget \"*buttongreen*\" style \"button_green\"";
      gtk_rc_parse_string(ss_green);
      char ss_blue[]="widget \"*buttonblue*\" style \"button_blue\"";
      gtk_rc_parse_string(ss_blue);
      char ss_bluehl[]="widget \"*buttonhlblue*\" style \"button_blue_hlight\"";
      gtk_rc_parse_string(ss_bluehl);
      char ss_noir[]="widget \"*buttonnoir*\" style \"button_noir\"";
      gtk_rc_parse_string(ss_noir);
      char ss_noirhl[]="widget \"*buttonhlnoir*\" style \"button_noir_hlight\"";
      gtk_rc_parse_string(ss_noirhl);
/*
 *   End of not understood part
 */
//      char ss_bluehl[]="widget \"*buttonhlblue*\" style \"button_blue_hlight\"";
//      char ss_noirhl[]="widget \"*buttonhlnoir*\" style \"button_noir_hlight\"";
 
    entry_text = gtk_entry_get_text(GTK_ENTRY(\
	book -> entry_book));
     ss = g_locale_from_utf8(entry_text,-1,NULL,NULL,NULL);
     scd_field= -1;
/*     printf("callback_entry_book ss=%s@@@ \n",ss);
     fflush(stdout);*/
     prim_field =  EXTRACT_NB_FIRST_FIELD(ss);
     if(prim_field > 0){
        (*book).ifile_book = prim_field ;
	(*book).ipage = 0;
        cback_new_page(widget,book);
        free(ss);
	return;
     }//if(prim_field > 0){
     scd_field = EXTRACT_SCD_FIELD(ss);
/*     printf("callback_entry_book scd_field=%d \n",scd_field);
     fflush(stdout);*/
     if(strlen(ss) <= 0){
        free(ss);
/*        free(entry_text);   does not work */
	return;
     }/*if(strlen(ss) <= 0){*/
//     printf("callback_entry_book ss=%s@@@ \n",ss);
/*
 *   If ss = filename look at filename into furch.conf
 *                    if not in furch.conf look at ./filename
 *   If ss = PATH/filename or PATH\filename look at them into furch.conf
 *                    if it is not found look at PATH/filename
 *   When the file is into furch.conf the index of the book is recorded 
 *   so the NEXT or PREV button will give you the correct answer.
 *   When the file has not been found in furch.conf but if the file
 *   is found at the indicated position, then the book index is changed
 *   and the new book is inserted.
 *
 */
/*
 *   Conditioning of ss into ss1
 */
     l=strlen(ss)+1;
     ss1= g_malloc((l+5)*sizeof(char));
     i=l-2;
     while(i >= 0 && *(ss+i) == ' ')--i;
//     printf("callback_entry_book level 1 i=%d \n",i);
     if(i < 0){
        free(ss);
	free(ss1);
        return;
     }/*if(i < 0){*/
     *(ss+i+1)='\0';
     while(i >= 0 && *(ss+i) != ' ' &&\
		     *(ss+i) != '/' && *(ss+i) != '\\')--i;
     iss_path=0;
     is0=i+1; // start of file name without PATH
     is=i;
     if(is > 0 && *(ss+is) != ' '){
        iss_path=1; // in that case we have a PATH before the file name
        while(is >= 0 && *(ss+is) != ' ' )--is; // Go back to start of PATH
     }/*if(*(ss+i) == ' '){*/
     ++is;
/*     printf("callback_entry_book level 2 is=%d ss=%s@@@\n",is,ss);
     printf("iss_path=%d  \n",iss_path);*/
//  is is the start of the PATH name if iss_path=1
     ss0 = ss+is; // full  PATH + file name
/*
 *   extract the filename which is the end of ss
 */
     j=0;
     i=is0; // start of file name without PATH
     while(i <= l-1 && *(ss+i) != ' '){
//	printf("i=%d j=%d (ss+i)=%s@@@@ \n",i,j,ss+i);
	*(ss1+j) = *(ss+i);
	++i;
	++j;
     }/*while(i <= l-1 && *(ss+i) != ' '){*/
     *(ss1+j) = '\0';
//   ss1 contains the name of the file (without PATH) we are in search of.
//   ss0 contains the name of the file (with PATH) we are in search of.
/*     printf("callback_entry_book actual search ss1=%s@@@ \n",ss1);
     printf("callback_entry_book actual search ss0=%s@@@ \n",ss0);*/
/*******/
     l1=strlen(ss1);
     if(l1 <= 0){
	free(ss);
	free(ss1);
        return;
     }/*if(i < 0){*/
     stbp=(*book).pages;
/*
 *   We look if the file name is into stbp  : as is
 *   (We exclude the arrow cases)
 */
     page_ante = IS_PAGE_KNOWN(stbp,iss_path,ss0,ss1);
//   printf("callback_entry_book after IS_PAGE_KNOWN page_ante=%d \n",page_ante);
/*
 *   We look if the file name is into stbp  : only for the file 
 *   names with an arrow
 */
     if(page_ante < 0 ){
        page_ante = ARROW_IS_PAGE_KNOWN(stbp,iss_path,ss0);
     }//if(page_ante < 0 ){
//   printf("callback_entry_book after ARROW_IS_PAGE_KNOWN page_ante=%d \n",page_ante);
     if(page_ante >= 0 ){// The page was recognized
        (*book).ifile_book = page_ante + 1 ;
        (*book).ipage = 0;
        max_pages =  MAX_PAGES_IN_FILE(ss1);
	if(max_pages >= 1 && scd_field > max_pages)scd_field = max_pages;
	if(scd_field > 1 )(*book).ipage = scd_field - 1;
//      printf("callback_entry_book max_pages=%d \n",max_pages);
/*	if(max_pages >= 1 && (*book).ipage >= max_pages)\
	                     (*book).ipage = max_pages -1;*/
//	gtk_grab_add(widget);
// gtk_editable_set_position(GTK_EDITABLE (widget),-1);// OK but uneffective
        cback_new_page(widget,book);
//	gtk_grab_remove(widget);
	free(ss);
	free(ss1);
	return;
     }//if(page_ante >= 0 ){
/*
 * At that level we must check directly the file PATH because
 * we have not found it into the file list
 */
/*       printf("ENTRY_BOOK level 2 ss1=%s \n",ss1);
       printf("ENTRY_BOOK level 2 ss0=%s \n",ss0);*/
       if((fp = fopen(ss0,"r")) == NULL ){
         cback_page_not_found(widget,book,ss0);
	 free(ss);
	 free(ss1);
	 return;
       }//if((fp = fopen(ss1,"r")) == NULL ){
/*
 * At that level the page is found by direct PATH search
 * we open it and it is inserted into the file list at 
 * the place we are openning it in the list of books
 */
	 fclose(fp);
         INSERT_IN_BOOK_STRING(ss0,book);
//         cback_page_parachutee(widget, book, ss0);
         (*book).nt_books = (*book).nt_books + 1;
//	 if(scd_field > 1 )(*book).ipage = scd_field - 1;
         max_pages =  MAX_PAGES_IN_FILE(ss1);
//       printf("callback_entry_book max_pages=%d \n",max_pages);
	 if(max_pages >= 1 && scd_field > max_pages)scd_field = max_pages;
	 if(scd_field > 1 )(*book).ipage = scd_field - 1;
/*	 if(max_pages >= 1 && (*book).ipage >= max_pages)\
	                      (*book).ipage = max_pages -1;*/
         cback_new_page(widget,book);
	 free(ss);
	 free(ss1);
	 return;
  }
 /* ###################################################################*/
int  EXTRACT_SCD_FIELD(char *ss)
/*
 *   This sub will extract the second field of ss which should be
 *   an integer number which will be returned
 *   This sub will also put a \0 after the first field
 */
//     scd_field = EXTRACT_SCD_FIELD(ss);
{/*====================================================================*/
   int scd_field;
   int l,i,j;

   scd_field = -1;
   l=strlen(ss);
   i=0;
   while(i < l && *(ss+i) == ' ')++i;
   while(i < l && *(ss+i) != ' ')++i;
   if(i == l)return(scd_field);
   *(ss+i) = '\0' ;
   if(i+1 < l){
      j = atoi(ss+i+1);
      if(j > 0)scd_field = j;
   }//if(i+1 < l){
   return(scd_field);
}/*====================================================================*/
 /* ###################################################################*/
int  EXTRACT_NB_FIRST_FIELD(char *ss)
/*
 *   This sub will extract the first field of ss when it is a number.
 *   It returns a positive integer number when ss begins by a number>
 *   It returns -1 otherwise.
 */
{/*====================================================================*/
   int prim_field;
   int l,i,j,kc0,kc9;

   prim_field = -1;
   l=strlen(ss);
   if(l <= 0)return(prim_field);
   i=0;
   while(i < l && *(ss+i) == ' ')++i;
   if(i >= l)return(prim_field);
   kc0 = (int) '0';
   if(kc0 <= 0 )kc0=kc0+256;
   kc9 = (int) '9';
   if(kc9 <= 0 )kc9=kc9+256;
   j = (int) *(ss+i);
   if(j <= 0) j=j+256;
   if(j >= kc0 && j <= kc9){
      prim_field = atoi(ss+i);
   }//if(j >= kc0 && j <= kc9){
   return(prim_field);
}/*====================================================================*/
 /* ###################################################################*/
void   INSERT_IN_BOOK_STRING(char *ss0,Trf_book *book)
	   
/*
 *    In ss0 we have the PATH of the book file
 *    We must insert this name into memory string containing
 *    the names of all the books
 *    We insert it after the name of the current book or more exactly
 *    if the current book belong to a xxxx->xxx pack of files we
 *    insert after this pack.
 *    The current jfile_book number is modified so as to give 
 *    access to the newly inserted file. The stucture book 
 *    is thus modified.
      int lenmx_pages ;
      char *pages; // adjustable string with the names of the file books 
 *
 */
{/**   INSERT_IN_BOOK_STRING  begins  **/
static int nb_books = -1 ;/* start with value -1 retains its new value*/
int nb0_books,i,j,k,l;
int n1,n2;// max_pages in book file
int jfile_book;
char *mem_pages, *anv_file;
int   lss0,ip_bar, lex ,nlmx;

//long int li0_extracted[3], li1_extracted[3];
   mem_pages = book -> pages;
   jfile_book = (*book).ifile_book;
   if(jfile_book < 0) jfile_book = 0;
   printf("entree INSERT_IN_BOOK_STRING book_no=%d\n",jfile_book);
   printf("entree INSERT_IN_BOOK_STRING mem_pages=%s \n",mem_pages);
   fflush(stdout);
/*   if(nb_books < 0)KLASK_NB_PAJ(&nb_books, mem_pages,anv_file);

   if(nb_books > 0 && *jfile_book > nb_books){
      *jfile_book= *jfile_book-nb_books;
 //     printf("modif 1 nb_pages KLASK_PAJ jpage=%d \n",*jpage);
   }*/
   /*
    * Here we have the problem of a negative jfile_book. If nb_books
   * has already been determined (nb_books > 0 ) no problem.
   * If not, we have to determine nb_books first
   */
   fflush(stdout);
   l=strlen(mem_pages);
/*
 *    anv_file must be allocated a memory we take it large enough
 */
    anv_file =  (char *) malloc((l+5)*sizeof(char));
      nb0_books = 0;
      i=0;
      n1=-1;
      n2=-1;
   if(jfile_book == 0 ){
      nb0_books = 0;
      i=-1;
   }else{//if(jfile_book == 0 ){
      while(i < l && nb0_books < jfile_book ){
         while(mem_pages[i] == ' ')++i; /* remove preceeding blancs */
         j=0;
         while(i < l && mem_pages[i] != ' '){
/**	    printf("i=%d j=%d \n",i,j);  **/
	    anv_file[j]=mem_pages[i];
	    ++j;
	    ++i;
         }/*while(i < 0 && mem_pages[i] != ' '){*/
	 
         anv_file[j]='\0';
         if(j > 0){/* extract number of pages pb  ->    */
	    if(strstr(anv_file,"->") != NULL){
	       /**  here we must extract the numbers n1 and n2 n1->n2 */
	       EXTRACT_2NB(anv_file,&n1,&n2);
	       nb0_books = nb0_books+abs(n2 -n1)+1;
	    }else{/*if(strstr != NULL){ */
	       ++nb0_books;
	    }/*if(strstr != NULL){ */
         }/*if(j > 0){*/
      }/**while(i < l && nb0_books < *jpage ){ **/
   }//if(jfile_book == 0 ){
   /**  try to compute nb_page **/
/*   while(i < l && mem_pages[i] == ' ')++i;
   if(i >= l)nb_books = nb0_books; *//* adjust value of nb_page which will */
                                  /* be retained  in the subroutine */
      printf("INSERT_IN_BOOK_STRING after anv_file=%s , nb_books=%d nb0_books=%d \n",\
		   anv_file,nb_books,nb0_books);
      fflush(stdout);
      free(anv_file);
/*
 *  At that level i is the ' ' or the /0
 *  nb0_books  is the number of books before the one to be inserted
 *  We must extend the memory allocation of book -> pages ;
 *     1) compute the number of characters necessary for the extension
 *     2) Realloc book -> pages
 *     3) Make place for insertion.
 */
      lss0 = strlen(ss0);
      ip_bar= 0;
      if(lss0 > 2 && ( (*ss0 == '.' &&\
                  (*(ss0+1) == '/' || *(ss0+1) == '\\'  )) \
		   || *(ss0) == '/'))ip_bar = 1;
      lex=lss0+1;
      if(ip_bar == 0 ) lex=lex+2;
      nlmx = (*book).lenmx_pages + lex ;
      if(i == l)nlmx = nlmx+1; // add a ' ' at end of string
      book -> pages = g_realloc(book -> pages,(nlmx+5)*sizeof(char));
      (*book).lenmx_pages = nlmx ;
      printf("INSERT_IN_BOOK_STRING after g_realloc nlmx=%d l=%d\n",nlmx,l);
      fflush(stdout);
      mem_pages = book -> pages;//if book_pages was changed place !
      printf("INSERT_IN_BOOK_STRING after mem_pages\n");
      fflush(stdout);
      if(i == l){ // a ' ' is added at end of string
         *(mem_pages+l) = ' ';
	 ++l;
         *(mem_pages+l) = '\0';
      }//if(i == l){
      for(j = l ; j > i; --j){ // make place for insertion
         *(mem_pages+j+lex) = *(mem_pages+j);
      }//for(j = l ; j > i; ++j){
      printf("INSERT_IN_BOOK_STRING lex=%d mem_pages=%s@@@ \n",lex,mem_pages);
      fflush(stdout);
/*
 *   Now we must do the insertion
 */
      k = i +1;
      if( ip_bar == 0){
         *(mem_pages +k) = '.';
	 ++k ;
         *(mem_pages +k) = '/';
	 ++k ;
      }//if( ip_bar == 0){
      for(j = 0 ; j < lss0 ; ++j){
         *(mem_pages +k) = *(ss0+j);
	 ++k;
      }//for(j = 0 ; j < lss0 ; ++j){
      *(mem_pages +k) = ' ';
      printf("out of INSERT_IN_BOOK_STRING mem_pages=%s@@@ \n",mem_pages);
      if( (*book).lstb_insert  < 0)(*book).lstb_insert = nb0_books ;
      if(nb0_books > 0 && nb0_books < (*book).lstb_insert )(*book).lstb_insert = nb0_books ;
      (*book).ifile_book = nb0_books + 1 ;
      (*book).ipage = 0;

}/**   INSERT_IN_BOOK_STRING  ends  **/
 /* ###################################################################*/
 int  IS_PAGE_KNOWN(char *stbp,int ipath,char *ss0,char *ss1 )
 /*
  *    This sub looks into string stbp. Question : is file name ss1
  *    into stbp ? However the case xxx->xxx is not treated.
  *    stbp is the string which contains all the book files
  *    ss0  is the string which contains the full path if ipath= 1
  *         it contains the file name otherwise. 
  *    ss1  contains always the file name
  *    we may have st = NULL if the file name is not into stbp
  *    On return  iknown = -1 if file was not found
  *    Or it is >= 1 and is the rank number of the file into stbp
  */
 {//=================================================================
 int  iknown=-1;
 char *st1,*stbp1,c;
 int i,i_pos,l,l0,page_ante;
    l=strlen(stbp);
    if(ipath == 1 ){  // path given must be also into stbp
       st1 = strstr(stbp,ss0);
       if(st1 == NULL)return(iknown);//otherwise look more carefully
       i=st1-stbp;
       i_pos=i;
       if (i > 0 && *(st1 - 1) != ' '){
          return(iknown); 
       }//if (i > 0 && *(st - 1) != ' '){ // have look at beginning
       l0=strlen(ss0);
       i= i+ l0;
       if( i < l && *(stbp+i) != ' '){
          return(iknown); // have look at end 
       }//if( i < l && *(stbp+i) != ' '){
       PAJ_BEFORE(i_pos, stbp,&page_ante);
       iknown=page_ante;
       return(iknown);// Yes the file with its full PATH was in stbp
    }//if(ipath == 1 ){
/*
 *   At that level we don't have the PATH. Still if the file name  
 *   is terminal for a substring of stbp it is considered as correct !
 *   Priority is for the first matching substring
 */
    stbp1 = stbp;
    st1 = strstr(stbp1,ss1);
    l0 = strlen(ss1);
    while(st1 != NULL){
/*
 *   Is  ending good ?
 */
       i=st1-stbp+l0;
       if(i < l && *(stbp + i) != ' '){
	  stbp1 = stbp1+ l0;
          st1 = strstr(stbp1,ss1); // have another trial farther
	  continue;
       }//if(i < l && *(stbp + i) != ' '){
/*
 *   Is  beginning good ?
 */
       i = st1 -stbp ;
       if(i > 0 ) c= *(stbp + i -1);
       if(i > 0 && c != ' ' && c != '\\' && c != '/'){
	  stbp1 = stbp1+ l0;
          st1 = strstr(stbp1,ss1); // have another trial farther
	  continue;
       }//if(i < l && c != ' '....){
/*
 *   At that level all tests were OK
 */
       iknown=1;
       if(i == 0 ){
          return(iknown);// Yes the file is in stbp. It doesn't
                               // have any PATH so it is in local directory
       }//if(i == 0 ){
       while(i >= 0 && *(stbp + i) != ' ')--i;
       ++i;
       PAJ_BEFORE(i, stbp,&page_ante);
       iknown = page_ante ;
       return (iknown);// Yes the file is in stbp. It has a PATH that 
                       // was ommited. st points to the beginning of the 
		       // substring where this PATH is.
    }//while(st != NULL){
    iknown = -1; // (not useful)
    return(iknown);  // This file name was not into stbp but 
                     //  the case xx->xx was overlooked
 }//=================================================================
 /* ###################################################################*/
 int  ARROW_IS_PAGE_KNOWN(char *stbp,int ipath,char *ss0 )
 /*
  *    This sub looks into string stbp = (*book).pages.
  *    Question : is file name ss0 into stbp ? 
  *    However ONLY the case xxx->xxx is treated.
  *    stbp is the string which contains all the book files
  *    ss0  is the string which contains the full path if ipath= 1
  *         it contains the file name only otherwise. 
  *    On return st is a pointer to the file name with path into stbp
  *    we may have st = NULL if the file name is not into stbp
  *    On return  iknown = -1 if file was not found
  *    Or it is >= 1 and is the rank number of the file into stbp
  */
 {//=================================================================
 int  iknown=-1;
 char *stp,*stbp1,c;
 int i,j,lspage,page_ante,nb_in_file;
 int iss0_start,iss0_bfnb,iss0_afnb,n0;
    lspage=strlen(stbp);
/*
 *   Does ss0 has a number in it (in its terminating file name) ?
 *   1) Computation of iss0_start
 *   2) Look for the number
 */
//    printf("ARROW_IS_FILE_KNOWN  ss0=%s \n",ss0);
    iss0_start = strlen(ss0)-1;
    if(iss0_start < 0)return(iknown);
    while(iss0_start > 0 && *(ss0 +iss0_start) == ' ')--iss0_start;
    while(iss0_start >= 0 && (c = *(ss0 +iss0_start)) != ' ' &&\
        c != '/' && c != '\\')--iss0_start;
    ++iss0_start;
    FIRST_NUMBER_IN_FILE(ss0,iss0_start,\
                 &iss0_bfnb,&iss0_afnb, &n0);
//    printf("ARROW_IS_FILE_KNOWN  n0=%d \n",n0);
/*
 */
    if(n0 < 0)return(iknown);// no number in ss0 last file
       i=0;
       stbp1=stbp;
       nb_in_file= n0;
       while(i < lspage && (stp = strstr(stbp1,"->")) != NULL){;
          j= stp-stbp ;
	  c = *(stbp+j);
//	  while(j >= 0 && c != ' ' && c != '/' && c != '\\'){
	  if(ipath == 1 ){// in that case we have a full PATH
	     while(j >= 0 && c != ' ' ){
	        --j; 
	        c = *(stbp+j);
	     }/*while(j >= 0 && c != ' ' && c != '/' && c != '\\'){*/
	  }else{/*if(iss_blanc == 0 ){*/
   	     while(j >= 0 && c != ' ' && c != '/' && c != '\\'){
	        --j; 
	        c = *(stbp+j);
	     }/*while(j >= 0 && c != ' ' && c != '/' && c != '\\'){*/
	  }/*if(iss_blanc == 0 ){*/
	  stbp1 = stbp + j + 1 ;
/*        printf("BEFORE START_OF_NUMBER stbp=%s@@@@\n",stbp);
          printf("BEFORE START_OF_NUMBER stbp1=%s@@@@\n",stbp1);*/
          START_OF_NUMBER(ss0,iss0_bfnb,iss0_afnb,nb_in_file,\
	                 stbp,stbp1,&page_ante);
/*          printf("After START_OF_NUMBER page_ante=%d \n",page_ante);
          fflush(stdout);*/
          if(page_ante > 0){
             iknown=page_ante;
	     return(iknown);
          }//if(page_ante > 0){
          j= stp-stbp ;
	  while(j < lspage && *(stbp + j) != ' ')++j;
	  if(j >= lspage)return(iknown);
	  stbp1 = stbp+ j ;
  /*        printf("AFTER START_OF_NUMBER stbp1=%s@@@@\n",stbp1);
          fflush(stdout);*/
       }/*while( (stp = strstr(stbp,"->")) != NULL){;*/
       return(iknown);//otherwise we have not found the file
 }//=================================================================
 /* ###################################################################*/
void START_OF_NUMBER(char *ss1,int iss1_bfnb,int iss1_afnb,\
        int nb_in_file, char *book_list_tot, char *book_pages, int *page_ante)
/*
 *   The file name was not found directly, we look at the names 
 *   which are including a " ->"
 *   book_list_tot  est la liste totale des fichiers 
 *   the beginning of book_pages must be the one we are looking for
 *   ss1  is the full path of the file name
 *   iss1_bfnb   is the position of the character before the number in ss1
 *   iss1_afnb   is the position of the first character 
 *               after the number in ss1
 *   On return page_ante is the number of pages before the page ss1
 *   We have page_ante = -1 if page not found
 *   Otherwise page_ante >= 0
 */
{ /*****   start of START_OF_NUMBER    *****/
    int lbp,ll_ss1;
    int i,j,n0,n1,n2,istp;
    int iss1_start;
    char *stp,c;

       *page_ante = -1;
       lbp=strlen(book_pages);
       n0=nb_in_file;
/*     printf("START_OF_NUMBER Number extracted n0=%d\n",n0);
       printf("START_OF_NUMBER file full path ss1=%s \n",ss1);
       printf("START_OF_NUMBER book.pages=%s \n",book_pages);*/
       ll_ss1=strlen(ss1);
       while(n0 > 0){
          istp=1;
/* 
 *   Verify identity before number
 */
//       for (i = 0 ; i < ll_ss1 && istp == 1 ; ++i){
          for (i = 0 ; i <= iss1_bfnb && istp == 1 ; ++i){
             if(*(book_pages+i) != ss1[i])istp = 0;
          }/*for (i = 0 ; i < ll_ss1 ; ++i){*/
//       stp= strstr(book_pages,ss1);
         if(istp == 0 )return;// no identity before number 
//       printf("START_OF_NUMBER identity before number OK \n");
/*  at that level we verify that we have the -> otherwise jump !   */
         while(i < lbp-1 && isdigit(*(book_pages + i)))++i;
//       printf("START_OF_NUMBER book_pages + i =%s \n",book_pages+i);
          if(*(book_pages+i) != '-' || *(book_pages + i + 1) != '>'){
//             printf("START_OF_NUMBER arrow not found \n");
/***  at that level look for another number in ss1    ****/
             iss1_start = iss1_afnb;
             FIRST_NUMBER_IN_FILE(ss1,iss1_start,\
                 &iss1_bfnb,&iss1_afnb, &n0);
             if(n0 < 0 ) return; // not found other number
	     continue;
          }//if(ss1[i] != '-' || ss1[i+1] != '>'){
	  break;
       }//while(n0 > 0){
          stp= book_pages;
//          printf("START_OF_NUMBER Found start of number = %s \n",stp);
          EXTRACT_2NB(stp,&n1,&n2);
//          printf("n1=%d  n2=%d \n",n1,n2);
          if(n1 < 0 || n2 <0 || n2 < n1 )return;
          if(n0 < n1 || n0 > n2)return;
/*
 *  At that level n0 is acceptable
 *  We must verify here after the numbers.
 *  We have ss1[i] == '-'  and ss1[i+1] == '>'
 */
       j=i+2;
       if(j >= lbp)return;
       c = *(book_pages+j);
       while(j < lbp && isdigit(c) ){
          ++j;
          c = *(book_pages+j);
       }/*   while */
       i = iss1_afnb ; 
       istp = 1;
       for (i = iss1_afnb ; i < ll_ss1 && istp == 1 ; ++i){
          if(*(book_pages+j) != ss1[i])istp = 0;
	  ++j;
       }/*for (i = 0 ; i < ll_ss1 ; ++i){*/
       if(istp == 0 )return; // not found identity of name
/*****
 *
 *  At that level an identity of name has been found
 *
 ****/
       i= stp - book_list_tot ;
       while(i >= 0 && *( book_list_tot + i) != ' ')--i;
       *page_ante = 0;
       if(i > 0 ){
          PAJ_BEFORE(i,book_list_tot,page_ante);
       }/*if(i > 0 ){*/
       *page_ante = *page_ante+n0-n1;
       printf("START_OF_NUMBER page_ante=%d \n",*page_ante);
       return;
} /*****   end of START_OF_NUMBER    *****/
 /* ###################################################################*/
void NUMBER_IN_FILE(char *ss1,int *iss1_bfnb,int *iss1_afnb, int *nb_in_file)
/*
 *   The file name is into ss1. We extract the last number into ss1
 *   If there is no number we return nb_in_file = -1
 *   We return also the position on the character 
 *   before the number (iss1_bfnb) and the position of the character 
 *   after the number (iss1_afnb)
 */
{ /*****   start of NUMBER_IN_FILE    *****/
    int l_ss1,j_ss1;
    int n0;

       *nb_in_file = -1;
       *iss1_bfnb=-1;
       *iss1_afnb=-1;
       l_ss1=strlen(ss1);
       j_ss1=l_ss1-1;
       printf("ss1[l-1]=%c \n",ss1[j_ss1]);
       while(j_ss1 >= 0 && !isdigit(ss1[j_ss1]) && ss1[j_ss1] !='/' &&\
                          ss1[j_ss1] !='\\')--j_ss1;
       if(ss1[j_ss1] == '/' || ss1[j_ss1] == '\\')return;
       while(j_ss1 > 0 && isdigit(ss1[j_ss1]) )--j_ss1; 
       ++j_ss1; /**  start of number  **/
       printf("ss1[j_ss1]=%s \n",(ss1+j_ss1));
       if( !isdigit(ss1[j_ss1])){
         printf("is not digit\n");
         return;
       }/*if( !isdigit(j_ss1)){*/
       n0=atoi(&ss1[j_ss1]);
       printf(" NUMBER_IN_FILE ss1=%s \n",ss1);
       printf("Number extracted  n0=%d\n",n0);
       *nb_in_file = n0 ;
       *iss1_bfnb= j_ss1-1;
       while(isdigit(ss1[j_ss1]))++j_ss1;
       *iss1_afnb= j_ss1;
//       ss1[j_ss1]='\0';
       return;
} /*****   end of NUMBER_IN_FILE    *****/
 /* ###################################################################*/
void FIRST_NUMBER_IN_FILE(char *ss1,int iss1_start,\
                 int *iss1_bfnb,int *iss1_afnb, int *nb_in_file)
/*
 *   The file name is into ss1. We extract the first number into ss1
 *   but starting not from 0 but from iss1_start
 *   If there is no number we return nb_in_file = -1
 *   We return also the position of the character 
 *   before the number (iss1_bfnb) and the position of the character 
 *   after the number (iss1_afnb)
 */
{ /*****   start of NUMBER_IN_FILE    *****/
    int l_ss1,j_ss1;
    int n0;

       *nb_in_file = -1;
       *iss1_bfnb=-1;
       *iss1_afnb=-1;
       l_ss1=strlen(ss1);
       if(iss1_start >= l_ss1)return;
       j_ss1=iss1_start;
       printf("ss1[l-1]=%c \n",ss1[j_ss1]);
       while(j_ss1 < l_ss1 && !isdigit(ss1[j_ss1]) && ss1[j_ss1] !='/' &&\
                          ss1[j_ss1] !='\\')++j_ss1;
       if(ss1[j_ss1] == '/' || ss1[j_ss1] == '\\')return;
       /**  j_ss1 = start of number  **/
       printf("ss1[j_ss1]=%s \n",(ss1+j_ss1));
       if( !isdigit(ss1[j_ss1])){
         printf("is not digit\n");
         return;
       }/*if( !isdigit(j_ss1)){*/
       n0=atoi(&ss1[j_ss1]);
       printf(" FIRST_NUMBER_IN_FILE ss1=%s \n",ss1);
       printf("Number extracted  n0=%d\n",n0);
       *nb_in_file = n0 ;
       *iss1_bfnb= j_ss1-1;
       while(isdigit(ss1[j_ss1]))++j_ss1;
       *iss1_afnb= j_ss1;
//       ss1[j_ss1]='\0';
       return;
} /*****   end of NUMBER_IN_FILE    *****/
 /* ###################################################################*/
void   PAJ_BEFORE(int i0_pos, char mem_pages[],int *page_ante)
/*
 *   This sub is the inverse of KLASK_PAJ
 *   It computes the number of pages in mem_pages BEFORE
 *   the character position i0_pos in string mem_pages[]
 *
 */
{/**   PAJ_BEFORE  begins  **/
int nb0_pages,i,j,l;
int n1,n2;
char *anv_page;
int n_anv_page;
//   printf("entree PAJ_BEFORE jpage=%d nb_pages=%d\n",*jpage,nb_pages);
   printf("entree PAJ_BEFORE mem_pages=%s \n",mem_pages);
   if(i0_pos <= 0 ){
      *page_ante = 0;
      return;
   }/*if(i0_pos <= 0 ){*/
   nb0_pages = 0;
   i=0;
   l=strlen(mem_pages);
   if(i0_pos < l)l=i0_pos;
   n1=-1;
   n2=-1;
   n_anv_page=100;
   anv_page = g_malloc((n_anv_page+1)*sizeof(char));
   while(i < l  ){
      while(mem_pages[i] == ' ')++i; /* remove preceeding blancs */
      if(i >= l)continue;
      j=0;
      while(i < l && mem_pages[i] != ' '){
/**	 printf("i=%d j=%d \n",i,j);  **/
	 *(anv_page+j) = mem_pages[i];
	 ++j;
	 if(j >= n_anv_page - 10){
	    n_anv_page = n_anv_page + 100;
            anv_page = g_realloc(anv_page,(n_anv_page+1)*sizeof(char));
	 }/*if(j >= n_anv_page - 10){*/
	 ++i;
      }/*while(i < 0 && mem_pages[i] != ' '){*/
      *(anv_page+j) = '\0';
      if(j > 0){/* extract number of pages pb  ->    */
	 if(strstr(anv_page,"->") != NULL){
	    /**  here we must extract the numbers n1 and n2 n1->n2 */
	    EXTRACT_2NB(anv_page,&n1,&n2);
	    nb0_pages = nb0_pages+abs(n2 -n1)+1;
	 }else{/*if(strstr != NULL){ */
	    ++nb0_pages;
	 }/*if(strstr != NULL){ */
      }/*if(j > 0){*/
   }/**while(i < l && nb0 < *jpage ){ **/
   *page_ante = nb0_pages;
   printf("PAJ_BEFORE page_ante=%d \n",*page_ante);
}/**   PAJ_BEFORE  ends  **/
 /* ###################################################################*/
void FILE_NOT_FOUND(Trf_extrm *extrm,int iappel, int nb ,\
		long posit[] ,int nb0,\
	long pos_db[],GtkWidget *box1,GtkWidget *lbox2[], \
	GtkWidget *scroll_bzh, GtkWidget *dico_b,   \
	Trf_string *stgs_dico,Trf_klik *klik[],char s1[]) 
/*
 *    This sub will display a book page with a file not found warning
 */
/**  nb  = dictionary   nb0 = endings  **/
/**   iappel = 0 first page call  **/
{
/****  ==================================    */
FILE *fp1, *fph ;
char s[101],s1_col[101],s1_word[101],s1_klik[101]  ;
char ss_mem [ISS_MAX+1] [100] , cc ;
long nc ;
int i,l,ib,jump,i_fin,j_fin,l_dep,l1,k,icont;
int i_dep,j_dep,ism,i_loop;
W_loop *w_loop1 ;
int blanc_line;
/*********************************************************/
printf("entree FILE_NOT_FOUND s1=%s@@@@\n",s1) ;
fflush(stdout);
//exit(71);
/*w_loop1 = (struct word_loop *) malloc (sizeof(struct word_loop));*/
w_loop1 =  g_malloc (sizeof( W_loop)); 
for(i = 0 ; i <= MAX_SHIFT ; ++i){
   (*w_loop1).s_expr[i]= NULL;
}/*for(i = 0 ; i <= MAX_SHIFT ; ++i){*/

fp1 = fopen("./idx_gene","r") ;
fph = fopen("./highlight1","r") ;
printf("FILE_NOT_FOUND level 1 \n") ;
fflush(stdout);
nc = 0 ;
/******   Extract of a file which is the book to read  ******/
/**  the pb is that we have a \n at the end of each line **/
i=0 ;
ism=ISS_MAX ; /** memory line output  **/
i_dep=1;
j_dep=0;
(*w_loop1).w_shift = 0;
/**  printf("shift=%d \n",w_loop1 -> w_shift);   OK    **/
ib=-1; /** no of button1 **/
printf("FILE_NOT_FOUND level 1.1 \n") ;
fflush(stdout);
(*extrm).nb_line=0;
(*extrm).nb_word=-1;
printf("FILE_NOT_FOUND level 1.2 \n") ;
fflush(stdout);
k=0;/* it is the number of lines in memory */
blanc_line = 0 ;/* flag for a blanc_line */
//while (fgets(s,100,fp) != NULL ){
printf("FILE_NOT_FOUND level 2 \n") ;
fflush(stdout);
for(i_loop =1 ; i_loop <= 5 ; ++i_loop) {
/**	if(iappel > 0)++ism; **/
    if(i_loop <= 3){
       strcpy(s," ");
    }else{/* if(i_loop <= 3)*/
       if(i_loop == 4){
          strcpy(s,"ar restr : ");
          strncat(s,s1,100);
       }else{/*if(i_loop == 1){*/
          strcpy(s,"n'en deus ket bet kavet ! ");
       }/*if(i_loop == 1){*/
    }/* if(i_loop <= 3)*/
	DECODE_ACCENTS(s);
//rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
   l=strlen(s);
/*   printf("LENN_LEVR boucle while ligne  i=%d l=%d s=%s \n",i,l,s);
   fflush(stdout);*/
printf("FILE_NOT_FOUND loop=%d level 3 s=%s@@@@\n",i_loop,s) ;
fflush(stdout);
   if(l == 0){
      strcpy(s," ");
      l=1;
      blanc_line= 1;
   }/** end of if(l == 0){***/
   ++i; /*  index of current memory line   */
   if(i > ism) i= i-ism ;
   ++k;
//   printf("old_k=%d on line i=%d l=%d copy s=%s@@@@ \n",k,i,l,s);
   memcpy(ss_mem[i],s,l); /**  copy n characters from s to ss  **/
   ss_mem[i][l]='\0'; /**  terminate manually the chain **/
   printf("FILE_NOT_FOUND loop=%d level 3.1 blanc_line=%d \n",i_loop,blanc_line) ;
   fflush(stdout);
 /***  ?????????????????????????????????????????? ***/
   jump=0;
   if( blanc_line != 0 ){/** possible to look at words(blank line=TRUE) **/
      /**printf("ligne bl i=%d i_dep=%d j_dep=%d \n",i,i_dep,j_dep);**/
      i_fin = i ;
      j_fin = 1;
    printf("appel 1 EXTRACT_WORD i_dep=%d j_dep=%d i_fin=%d j_fin=%d \n"\
		   , i_dep,j_dep,i_fin,j_fin); 
		   fflush(stdout);
//         APPEL_SS_MEM(i_dep,i_fin,ism,ss_mem); /* print the ring */
         EXTRACT_WORD(&i_dep,&j_dep,i_fin,j_fin,ss_mem,nb,nb0, \
	 posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
         s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
         iappel,&ib,stgs_dico,klik,extrm) ;
         printf("apres EXTRACT_WORD  \n");
		   fflush(stdout);
         /****  everything was written remains noting in memory ***/
         k = 0 ;  /** nothing in memory ss_mem  */
	 i = i_dep -1;
	 i_fin = i_dep;
	 j_fin = j_dep -1;
/*    printf("sortie 1 EXTRACT_WORD i_dep=%d j_dep=%d i_fin=%d j_fin=%d \n"\
		   , i_dep,j_dep,i_fin,j_fin); */
	 blanc_line = 0;
   }/** end of blanc_line{**/
/**   l1=strcspn(s,".,:;?!");**/ /** detection \n or \0  **/
   printf("FILE_NOT_FOUND loop=%d level 3.2 blanc_line=%d \n",i_loop,blanc_line) ;
   fflush(stdout);
   l_dep=0;
   l1=POS_NALPHA(l_dep,l,s) ;
//     printf("LENN_LEVR jump=%d l1=%d i=%d\n",jump,l1,i);
   if(l1 == 0 ){/** problem of beginning with a non alpha **/
//      printf("Problem of beginning a line by a non alpha \n"); 
//      printf("i_dep=%d j_dep=%d i=%d \n",i_dep,j_dep,i);
//      printf("ss_mem[%d]=%s@@@@@ \n",i_dep,ss_mem[i_dep]);

      if(i_dep == i && j_dep == 0 ){
//	 printf("We will have to begin by a non alpha next time \n");
      }else{
         i_fin=i-1 ;
	 cc = ss_mem[i] [0];
         if(i_fin <= 0 )i_fin=i_fin+ism ;
	 j_fin=strcspn(ss_mem[i_fin], "\0");
/*    printf("appel 3 non alpha EXTRACT_WORD i_dep=%d j_dep=%d i_fin=%d j_fin=%d \n"\
		  ,  i_dep,j_dep,i_fin,j_fin); */
//      APPEL_SS_MEM(i_dep,i_fin,ism,ss_mem); /* print the ring */
    printf("appel 2 EXTRACT_WORD i_dep=%d j_dep=%d i_fin=%d j_fin=%d \n"\
		   , i_dep,j_dep,i_fin,j_fin); 
		   fflush(stdout);
  /*       EXTRACT_WORD(&i_dep,&j_dep,i_fin,j_fin,ss_mem,nb,nb0, \
	 posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
         s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
         iappel,&ib,stgs_dico,klik,extrm) ; */
              FLUSH_SS_MEM(&i_dep,&j_dep,i_fin,ss_mem,nb,nb0, \
	    posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
            s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
            iappel,&ib,stgs_dico,klik,extrm) ;
/*    printf("sortie 3 EXTRACT_WORD i_dep=%d j_dep=%d  \n"\
		  ,  i_dep,j_dep); 
    printf("ss_mem[%d]=%s@@@@@ \n",i_dep,ss_mem[i_dep]);*/
	 ss_mem[i][0] = cc;
	 i_dep = i ;
	 j_dep = 0;
	 k = 0;
      }
   } /** end of if(l1 == 0){**/
   printf("FILE_NOT_FOUND loop=%d level 3.3 blanc_line=%d \n",i_loop,blanc_line) ;
   fflush(stdout);
   icont = 0;
//   while(l1 < l && icont < 10  ){/** possible to look at words **/
   while(l1 < l  ){/** possible to look at words **/
      while(((cc= ss_mem[i][l1]) != ' ' || !SPE_ALPHA_NUM(cc)) && l1 < l)++l1;
      if(l1 >= l)continue;  // correct error when we begins by non alpha and
                            // there is no other punctuation
      ++icont;
      i_fin=i;
      j_fin=l1;
  printf("appel 4 EXTRACT_WORD i_dep=%d j_dep=%d i_fin=%d j_fin=%d \n"\
		   , i_dep,j_dep,i_fin,j_fin); 
    printf("k=%d \n",k);
   fflush(stdout);
//      APPEL_SS_MEM(i_dep,i_fin,ism,ss_mem); /* print the ring */
      EXTRACT_WORD(&i_dep,&j_dep,i_fin,j_fin,ss_mem,nb,nb0, \
      posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
      s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
      iappel,&ib,stgs_dico,klik,extrm) ;
    printf("sortie 4 EXTRACT_WORD ajusted i_dep=%d j_dep=%d \n"\
		  ,  i_dep,j_dep); 
    printf("ss_mem[%d]=%s@@@@@ \n",i_dep,ss_mem[i_dep]);
    printf("k=%d \n",k);
   fflush(stdout);
      if(i_dep == i_fin && j_dep <= strlen(ss_mem[i_fin]) ){
	i = i_dep ;
	k = 1;
	++j_dep;
        l1=POS_NALPHA(j_dep,l,s) ;
      }else{/*if(i_dep == i_fin && j_dep <= j_dep){*/
	i = i_dep -1 ;
	k = 0;
	l1 = l ; /* to end the while loop */
      }/*if(i_dep == i_fin && j_dep <= j_dep){*/
   } /** end of while(l1 < l  || l == 0 ){ **/
//   printf("level 4 i_dep=%d  i=%d \n",i_dep,i);
/*   k=k+1;*/
   /*if(i == 0 ) i=ism ;*/
//   printf("level 4 bis i=%d i_dep=%d k=%d \n",i,i_dep,k); 
   if(k>=ism){/**  enforce output too much lines in memory !  **/
//      printf("Forced flush too many lines  in memory  \n");
      i_fin=i;
/*      printf("lines in memory k=%d >= ism=%d  i_dep=%d i_fin=%d \n",\
		      k,ism,i_dep,i_fin);*/
      j_fin=strlen(ss_mem[i]);
/*  printf("appel 5 EXTRACT_WORD i_dep=%d j_dep=%d i_fin=%d j_fin=%d \n"\
		    ,i_dep,j_dep,i_fin,j_fin); 
   fflush(stdout);*/
//      APPEL_SS_MEM(i_dep,i_fin,ism,ss_mem); /*  print the ring */
      EXTRACT_WORD(&i_dep,&j_dep,i_fin,j_fin,ss_mem,nb,nb0, \
      posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
      s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
      iappel,&ib,stgs_dico,klik,extrm) ;
/*    printf("sortie 5 EXTRACT_WORD i_dep=%d j_dep=%d  \n"\
		   , i_dep,j_dep); 
    printf("sortie 5 ss_mem[%d]=%s@@@@ \n",i_dep,ss_mem[i_dep]);
   printf("sortie 5 i=%d \n",i);*/
      i =  i_dep-1;
//      i_fin = i_dep;
//      j_fin = -1;
      k = 0;
   }
//   printf("end loop i=%d \n",i);
// printf("LENN_LEVR bottom loop while ligne  i=%d l=%d s=%s \n",i,l,s);
}/** end of for{ **/

/************/


/*     if(i == 0) i=ism;*/
/*printf("\n") ;*/
/*      printf("Every line has been read now flush remaining memory \n");
      printf("Flush if k > 0   k=%d  i_dep=%d \n",k,i_dep);*/
      if(k > 0 ){
         i_fin = i_dep+k-1 ;
         if(i_fin > ism) i_fin = i_fin-ism ;
//       printf("Flush output i_dep=%d i_fin=%d i=%d \n",i_dep,i_fin,i);
	 j_fin = strlen(ss_mem[i_fin]);
//         APPEL_SS_MEM(i_dep,i_fin,ism,ss_mem); /*  print the ring */
         if( i_dep != i_fin ){
/*  printf("appel 6 EXTRACT_WORD i_dep=%d j_dep=%d i_fin=%d j_fin=%d \n"\
		    ,i_dep,j_dep,i_fin,j_fin);*/ 
           EXTRACT_WORD(&i_dep,&j_dep,i_fin,j_fin,ss_mem,nb,nb0, \
           posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
           s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
           iappel,&ib,stgs_dico,klik,extrm) ;
	 }else{ /* if( i_dep != i_fin ){*/
	    if(j_fin >= j_dep ){
/* printf("appel 6 bis EXTRACT_WORD i_dep=%d j_dep=%d i_fin=%d j_fin=%d \n"\
		    ,i_dep,j_dep,i_fin,j_fin); */
              EXTRACT_WORD(&i_dep,&j_dep,i_fin,j_fin,ss_mem,nb,nb0, \
              posit,pos_db,fp1,fph,box1,lbox2,w_loop1, \
              s1_col,s1_word,s1_klik,scroll_bzh,dico_b, \
              iappel,&ib,stgs_dico,klik,extrm) ;
	    } /* if(j_fin >= j_deb ){*/
	 } /* if( i_dep != i_fin ){*/
      }/*  if(k > 0 ){*/
	   
 //        printf("NO ACHIEVE LINE FLUSH OUTPUT LENN_LEVR \n");
/*printf("1 Lecture du fichier terminee ib=%d\n",ib) ;
printf("1.1 call close fp1 \n") ;*/
      fclose(fp1) ;
      fclose(fph) ;
      g_free(w_loop1);
/*printf("2 Lecture du fichier terminee ib=%d\n",ib) ;
printf("3 Lecture du fichier terminee ib=%d\n",ib) ;*/
}
/************************************************************************/
  void cback_page_parachutee(GtkWidget *widget,  Trf_book  *data, char *s1)
/*****                                                           ****/
/*****                                                           ****/
/*****                                                           ****/
/*****          Call to display a file that was not in
 *               book.pages                                      ****/
/*****                                                           ****/
/*****                                                           ****/
/*****                                                           ****/
  {
   /*   static int ipage = 1 ;*/
/**   GtkWidget *button1, *label; **/
      FILE   *fp, *fp_dscr  ;
      int i,ib,iappel,ncharl,nlp_max,jtest;
   
/*
 *   perhaps the file doesn't exist, then jump
 */
//      if((fp = fopen(s1,"r")) != NULL){ 
      nlp_max=(*(*data).extrm).nline_page ;
      ncharl=(*(*data).extrm).nchar_line;
      jtest=TEST_DSCR_ASSOC_FILE(s1,ncharl,nlp_max,fp_dscr); 
      printf("jtest=%d \n",jtest);
	if(jtest == 2){
           (*data).ipage=1;
	}//if(jtest == 2){
      if((fp = fopen(s1,"r")) != NULL && jtest != 0 ){ 
         iappel=(*data).ipage;
         ib=(*(*data).extrm).nb_word;
//      printf("NEXT cback_newpage ib=%d \n",ib); 
         for(i=0;i<= ib;++i){
/*	 printf("appel destroy label_word[%d] \n",i);  */
	    gtk_widget_destroy((*(*data).klik[i]).label_word);
	    gtk_widget_destroy((*(*data).klik[i]).button1);
         }/**for(i=0;i<248;++i){ **/
                      /***************/
      /** a new page of the book is to be read              ***/
/*(*data).pos_db, (*data).box1,(*data).lbox2, (*data).next_page, \ */
/*    printf("NEXT call LENN_LEVR \n");
      fflush(stdout);*/
         LENN_LEVR((*data).extrm,iappel,fp , (*data).nb ,\
		      data -> posit , (*data).nb0 ,\
              data -> pos_db, (*data).box1,(*data).lbox2,  \
	      (*data).scroll_bzh,(*data).dico_b, 
	      data -> stgs_dico,(*data).klik) ; 
  /*    printf("NEXT after call LENN_LEVR \n");
      fflush(stdout);*/
                      /***************/
         fclose(fp) ; 
      }else{/*if((fp = fopen(s1,"r")) != NULL){ ;*/
/*         printf("call cback_page_not_found \n");
         fflush(stdout);*/
         cback_page_not_found(widget,data,s1);
      }/*if((fp = fopen(s1,"r")) != NULL){ ;*/
  }
