# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include <ctype.h>
# include <stddef.h>
#include <gtk/gtk.h>
#include "gtkb2_0.h"
#include <gdk-pixbuf/gdk-pixbuf.h>
//#include <gdk/gdkx.h>
//#define NSUP_ENTRY 50

/********************************************************************/
/*
 *   Modified  june 6 2007
 */
/********************************************************************/
/************                                            ************/
/************   This file contains the main subroutine   ************/
/************   as well as the the last written sub.     ************/
/************   For now we have the new book page call,  ************/
/************   the change of color of word cells        ************/
/************   and all the utility sub. to treat the    ************/
/************   configuration file : furch.conf          ************/
/************                                            ************/
/********************************************************************/
/********************************************************************/
/********************************************************************/

/********************************************************************/

/********************************************************************/
  void ON_QUIT(GtkWidget *widget, Trf_book *book)
/*
 *   Save the config, the present page number, 
 *   the position and size of the window...
 *   and quit
 */
{/*  begins ON_QUIT    */
   FILE *fp;
   int i,j,k ;	
   long int nc;
   gint root_x,root_y,widthb;
      fp = fopen("furch_last_state","w");
      nc = 0 ;
      fseek(fp,nc,0) ;
      i = (*book).ifile_book ;
      j = (*book).ipage ;
      k = (*book).lstb_insert ;
      printf("ON_QUIT  enter ifile_book=%d ipage=%d lstb_insert=%d  \n",i,j,k);
/*      if(i <=0 ) i =1;
      if(j <= 0 ) j=1;
      if(j > (*book).max_pages){
         ++i;
	 j=1;
      }//if(j > (*book).max_pages){*/
/*
 *    If i < 0  the book was not found then i = -i -1 (preceding book)
 *    and j = -1  (last page of preceding book)
 */
     if(i < 0 ){
        i = -i -1 ;
	if (i <= 0) i = (*book).nt_books;
	j= -1;
     }//if(i < 0 ){
/*
 *   if k > 0 some book was inserted, then we register the 
 *   present book number only if it is <= k otherwise we take k
 */
/*      if(k >= 0 ){
         if (i > k){
	    i= k;
	    j = 1;
         }//if (i > k){
      }//if(k >= 0 ){*/

      fprintf(fp,"  %d  %d  First book and first page to read\n",i,j);
      printf(" ON_QUIT i= %d j= %d  First book and first page to read\n",i,j);
      gtk_window_get_position(GTK_WINDOW(book -> win_main),\
		      &root_x,&root_y);
      printf("root_x=%d  root_y=%d Position of main window\n",root_x,root_y);
      fprintf(fp,"  %d  %d   Position of main window left upper corner\n",root_x,root_y);
      gtk_window_get_size(GTK_WINDOW(book -> win_main),\
		      &root_x,&root_y);
      printf("root_x=%d  root_y=%d Size of main window\n",root_x,root_y);
      fprintf(fp,"  %d  %d   Size of main window width height\n",root_x,root_y);
      widthb = gtk_paned_get_position(GTK_PANED(book -> hzbox));
      printf("width_book=%d  Size of book window\n",widthb);
      fprintf(fp,"  %d   Width of book window \n",widthb);
      fprintf(fp,"%s\n",(*book).pages);
      fclose(fp);
      gtk_main_quit();
}/*  begins ON_QUIT    */
/********************************************************************/
  void callback_GClear_Dicos(GtkWidget *widget,  \
		   Trf_book *data)
/*
 *  Mission of this sub is to make a general Clear of the Dico part
 */  
{/*void callback_GClear_Dicos */
int i;
/*   printf("entrance callback_GClear_Dicos nb=%d  ipage=%d \n", \
		   (*data).nb,(*data).ipage);*/
   for (i=0; i< MAX_WORD ; ++i){
//	   printf("i=%d \n",i);
      if( (*(*data).klik[i]).status_hbox  != 0 ) {	
//	 printf("hbox_trf %d already exist : destroy \n",i);
         gtk_widget_destroy((*(*data).klik[i]).hbox_trf); 
         (*(*data).klik[i]).status_hbox = 0; 
//         gdk_window_clear(*((*(*data).klik[i]).hbox_trf)); 
//         free((*(*data).klik[i]).hbox_trf); 
      }/*if( book -> klik -> hbox_trf != NULL){	*/
   }/*for (i=0; i<1000 ; ++i){*/
}/*void callback_GClear_Dicos */
/********************************************************************/
  void entry_GClear_Dicos(GtkWidget *widget,  \
		   Trf_entry *data)
/*
 *  Mission of this sub is to make a general Clear of the Dico parts
 *  for those which were created by the command line
 */  
{/*void callback_GClear_Dicos */
int i;
//   printf("entrance entry_GClear_Dicos \n");
   for (i=0; i < NSUP_ENTRY ; ++i){
//	   printf("i=%d \n",i);
      if( (*(*data).klik[i]).status_hbox  != 0 ) {	
//	 printf("hbox_trf %d already exist : destroy \n",i);
         gtk_widget_destroy((*(*data).klik[i]).hbox_trf); 
         (*(*data).klik[i]).status_hbox = 0; 
//         gdk_window_clear(*((*(*data).klik[i]).hbox_trf)); 
//         free((*(*data).klik[i]).hbox_trf); 
      }/*if( book -> klik -> hbox_trf != NULL){	*/
   }/*for (i=0; i< 2 ; ++i){*/
}/*void entry_GClear_Dicos */
/********************************************************************/
  void callback_PClear_Dicos(GtkWidget *widget,  \
		   Trf_klik *data)
/*
 *  Mission of this sub is to make a Partial Clear of the Dico part
 */  
{/*void callback_GClear_Dicos */
//   printf("entrance callback_PClear_Dicos  \n");
//	   printf("i=%d \n",i);
      if( (*data).status_hbox  != 0)  {	
/*	 printf("callback_PCLear_Dicos hbox_trf already exist : destroy \n");*/
         gtk_widget_destroy((*data).hbox_trf); 
         (*data).status_hbox = 0; 
//         gdk_window_clear(*((*(*data).klik[i]).hbox_trf)); 
//         free((*(*data).klik[i]).hbox_trf); 
      }/*if( book -> klik -> hbox_trf != NULL){	*/
}/*void callback_PClear_Dicos */
/********************************************************************/
  gboolean callback_up(GtkWidget *widget, GdkEvent *event, gpointer data)
/*
 *
 *
 *      This subroutine changes the background color of a word 
 *      when the mouse pointer comes on it
 *
 *
 */
  {
      char ss_red[]="widget \"*buttonred*\" style \"button_red_up\"";
      char ss_redhl[]="widget \"*buttonhlred*\" style \"button_red_hlight_up\"";
      char ss_green[]="widget \"*buttongreen*\" style \"button_green_up\"";
      char ss_blue[]="widget \"*buttonblue*\" style \"button_blue_up\"";
      char ss_bluehl[]="widget \"*buttonhlblue*\" style \"button_blue_hlight_up\"";
      char ss_noir[]="widget \"*buttonnoir*\" style \"button_noir_up\"";
      char ss_noirhl[]="widget \"*buttonhlnoir*\" style \"button_noir_hlight_up\"";
      char s[100] ;
      
      strcpy(s, (char *) data ) ;
/*      printf(" s= %s \n",s);   */
      if(strstr(s,"buttonred") != NULL ) {
          gtk_rc_parse_string(ss_red);
          gtk_widget_set_name( widget , "buttonred") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttonred") {  **/
      if(strstr(s,"buttonhlred") != NULL ) {
          gtk_rc_parse_string(ss_redhl);
          gtk_widget_set_name( widget , "buttonhlred") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttonred") {  **/
      if(strstr(s,"buttongreen") != NULL ) {
          gtk_rc_parse_string(ss_green);
          gtk_widget_set_name( widget , "buttongreen") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttongreen") {  **/
      if(strstr(s,"buttonblue") != NULL ) {
          gtk_rc_parse_string(ss_blue);
          gtk_widget_set_name( widget , "buttonblue") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttonblue") {  **/
      if(strstr(s,"buttonhlblue") != NULL ) {
          gtk_rc_parse_string(ss_bluehl);
          gtk_widget_set_name( widget , "buttonhlblue") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttonblue") {  **/
      if(strstr(s,"buttonnoir") != NULL ) {
          gtk_rc_parse_string(ss_noir);
          gtk_widget_set_name( widget , "buttonnoir") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttonnoir") {  **/
      if(strstr(s,"buttonhlnoir") != NULL ) {
          gtk_rc_parse_string(ss_noirhl);
          gtk_widget_set_name( widget , "buttonhlnoir") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttonnoir") {  **/
	  return (FALSE) ;
  }
/********************************************************************/
  void callback_up2(GtkWidget *widget, GdkEvent *event, Trf_klik *data)
/*
 *
 *
 *      This subroutine changes the background color of a word 
 *      when the mouse pointer comes on another GtkWidget
 *      data is a *Trf_klik
 *
 *
 */
  {
      char ss_red[]="widget \"*buttonred*\" style \"button_red_up\"";
      char ss_redhl[]="widget \"*buttonhlred*\" style \"button_red_hlight_up\"";
      char ss_green[]="widget \"*buttongreen*\" style \"button_green_up\"";
      char ss_blue[]="widget \"*buttonblue*\" style \"button_blue_up\"";
      char ss_bluehl[]="widget \"*buttonhlblue*\" style \"button_blue_hlight_up\"";
      char ss_noir[]="widget \"*buttonnoir*\" style \"button_noir_up\"";
      char ss_noirhl[]="widget \"*buttonhlnoir*\" style \"button_noir_hlight_up\"";
      char s[100] ;
      
      strcpy(s, data -> s_button ) ;
/*      printf(" s= %s \n",s);   */
      if(strstr(s,"buttonred") != NULL ) {
          gtk_rc_parse_string(ss_red);
          gtk_widget_set_name( data -> button1 , "buttonred") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttonred") {  **/
      if(strstr(s,"buttonhlred") != NULL ) {
          gtk_rc_parse_string(ss_redhl);
          gtk_widget_set_name( data -> button1 , "buttonhlred") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttonred") {  **/
      if(strstr(s,"buttongreen") != NULL ) {
          gtk_rc_parse_string(ss_green);
          gtk_widget_set_name( data -> button1 , "buttongreen") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttongreen") {  **/
      if(strstr(s,"buttonblue") != NULL ) {
          gtk_rc_parse_string(ss_blue);
          gtk_widget_set_name( data -> button1 , "buttonblue") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttonblue") {  **/
      if(strstr(s,"buttonhlblue") != NULL ) {
          gtk_rc_parse_string(ss_bluehl);
          gtk_widget_set_name( data -> button1 , "buttonhlblue") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttonblue") {  **/
      if(strstr(s,"buttonnoir") != NULL ) {
          gtk_rc_parse_string(ss_noir);
          gtk_widget_set_name( data -> button1 , "buttonnoir") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttonnoir") {  **/
      if(strstr(s,"buttonhlnoir") != NULL ) {
          gtk_rc_parse_string(ss_noirhl);
          gtk_widget_set_name( data -> button1 , "buttonhlnoir") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttonnoir") {  **/
  }
/********************************************************************/
  gboolean callback_down(GtkWidget *widget, GdkEvent *event, gpointer data)
/*
 *
 *
 *      This subroutine returns to normal the background color of a word 
 *      when the mouse pointer leaves it
 *
 *
 */
  {
      char ss_red[]="widget \"*buttonred*\" style \"button_red\"";
      char ss_redhl[]="widget \"*buttonhlred*\" style \"button_red_hlight\"";
      char ss_green[]="widget \"*buttongreen*\" style \"button_green\"";
      char ss_blue[]="widget \"*buttonblue*\" style \"button_blue\"";
      char ss_bluehl[]="widget \"*buttonhlblue*\" style \"button_blue_hlight\"";
      char ss_noir[]="widget \"*buttonnoir*\" style \"button_noir\"";
      char ss_noirhl[]="widget \"*buttonhlnoir*\" style \"button_noir_hlight\"";
      char s[100] ;
      
      strcpy(s, (char *) data ) ;
//      printf(" callback_down s= %s \n",s);  
      if(strstr(s,"buttonred") != NULL ) {
          gtk_rc_parse_string(ss_red);
          gtk_widget_set_name( widget , "buttonred") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttonred") {  **/
      if(strstr(s,"buttonhlred") != NULL ) {
          gtk_rc_parse_string(ss_redhl);
//	  printf("ss_redhl=%s \n",ss_redhl);
          gtk_widget_set_name( widget , "buttonhlred") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttonred") {  **/
      if(strstr(s,"buttongreen") != NULL ) {
          gtk_rc_parse_string(ss_green);
          gtk_widget_set_name( widget , "buttongreen") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttongreen") {  **/
      if(strstr(s,"buttonblue") != NULL ) {
          gtk_rc_parse_string(ss_blue);
          gtk_widget_set_name( widget , "buttonblue") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttonblue") {  **/
      if(strstr(s,"buttonhlblue") != NULL ) {
          gtk_rc_parse_string(ss_bluehl);
          gtk_widget_set_name( widget , "buttonhlblue") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttonblue") {  **/
      if(strstr(s,"buttonnoir") != NULL ) {
          gtk_rc_parse_string(ss_noir);
          gtk_widget_set_name( widget , "buttonnoir") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttonnoir") {  **/
      if(strstr(s,"buttonhlnoir") != NULL ) {
          gtk_rc_parse_string(ss_noirhl);
          gtk_widget_set_name( widget , "buttonhlnoir") ;
          gtk_widget_draw(widget,NULL) ;
	  return (FALSE) ;
      }/** end of if(strstr(s,"buttonnoir") {  **/
	  return (FALSE) ;
  }
/********************************************************************/
  void callback_down2(GtkWidget *widget, GdkEvent *event, Trf_klik *data)
/*
 *
 *
 *      This subroutine returns to normal the background color of a word 
 *      when the mouse pointer leaves it
 *
 *
 */
  {
      char ss_red[]="widget \"*buttonred*\" style \"button_red\"";
      char ss_redhl[]="widget \"*buttonhlred*\" style \"button_red_hlight\"";
      char ss_green[]="widget \"*buttongreen*\" style \"button_green\"";
      char ss_blue[]="widget \"*buttonblue*\" style \"button_blue\"";
      char ss_bluehl[]="widget \"*buttonhlblue*\" style \"button_blue_hlight\"";
      char ss_noir[]="widget \"*buttonnoir*\" style \"button_noir\"";
      char ss_noirhl[]="widget \"*buttonhlnoir*\" style \"button_noir_hlight\"";
      char s[100] ;
      
      strcpy(s, data -> s_button ) ;
/*      printf(" s= %s \n",s);   */
      if(strstr(s,"buttonred") != NULL ) {
          gtk_rc_parse_string(ss_red);
          gtk_widget_set_name( data -> button1 , "buttonred") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttonred") {  **/
      if(strstr(s,"buttonhlred") != NULL ) {
          gtk_rc_parse_string(ss_redhl);
          gtk_widget_set_name( data -> button1 , "buttonhlred") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttonred") {  **/
      if(strstr(s,"buttongreen") != NULL ) {
          gtk_rc_parse_string(ss_green);
          gtk_widget_set_name( data -> button1 , "buttongreen") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttongreen") {  **/
      if(strstr(s,"buttonblue") != NULL ) {
          gtk_rc_parse_string(ss_blue);
          gtk_widget_set_name( data -> button1 , "buttonblue") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttonblue") {  **/
      if(strstr(s,"buttonhlblue") != NULL ) {
          gtk_rc_parse_string(ss_bluehl);
          gtk_widget_set_name( data -> button1 , "buttonhlblue") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttonblue") {  **/
      if(strstr(s,"buttonnoir") != NULL ) {
          gtk_rc_parse_string(ss_noir);
          gtk_widget_set_name( data -> button1 , "buttonnoir") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttonnoir") {  **/
      if(strstr(s,"buttonhlnoir") != NULL ) {
          gtk_rc_parse_string(ss_noirhl);
          gtk_widget_set_name( data -> button1 , "buttonhlnoir") ;
          gtk_widget_draw(data -> button1,NULL) ;
	  return ;
      }/** end of if(strstr(s,"buttonnoir") {  **/
  }
/**##################################################################*/
  gint delete_event( GtkWidget *widget,
                     GdkEvent  *event,
                     gpointer   data )
  {
      gtk_main_quit();
      return(FALSE);
  }

/********************************************************************/
/********************************************************************/
/********                                                  **********/
/********                 MAIN  PROGRAM                    **********/
/********                                                  **********/
/********************************************************************/
/********************************************************************/
/****                                                             ***/
int main( int   argc,
            char *argv[])
/*
 *
 *      MAIN   PROGRAM
 *     it reads the dictionaries and prepares the indexes
 *     it computes the indexes of the word endings
 *     it opens the main window, separates the window in two parts
 *     one for the book the other for the dictionaries.
 *     it creates the NEXT and QUIT buttons
 *
 *
 */ 
{
/****  =========================================================    */
Trf_posit *t_posit ;
int nb, nb0 ,i;
int j;
int nb_posit, nbmx_posit,n_highlight;
int nb_pos_db, nbmx_pos_db;
int width0,height0,width_book;
char  ss1_trf[100],s_dico[300];
gchar *ss;
FILE *fp, *fp_log;
/****  ==================================    */
      gchar *drink[1][1];
      GtkWidget *window;
      GtkWidget *button, *next_page, *prev_page;
      GtkWidget *hzbox,*box1,*box2;  
      GtkWidget *frame1, *frame2;
                   /** box1 box2 box3 vertical boxes**/
      GtkWidget *separator;
      GtkWidget *label0_file,*label, *box_label;
      GtkWidget *quitbox, *ClearG_Dic;
      GtkWidget *box_bzh , *hFBE_box , *entry, *entry_book;
      GtkWidget *scroll_bzh, *scroll_page;
      GtkWidget *v_page;
/*      GtkWidget *button1[MAX_WORD] ;*/
/*      GtkWidget *label_word[MAX_WORD];*/
      GtkWidget *lbox2[100];
      Trf_klik *klik[MAX_WORD];
      Trf_klik *klik_entry[NSUP_ENTRY] ;
      Trf_book *book;
      Start_State *S_state;
      Trf_extrm *extrm;
      Trf_capsul cap;
      Prenestro *Caract_win;
      Trf_entry *Tentry;
      W_loop *w_loop1 ;
      Trf_string *G_dico ;
      GtkStyle *style;
      char ss_book_scrolled[]="widget \"*book_scrolled*\" style \"book_part\"";
//      Trf_Sklik *Sklik;
/*      GdkColor white[4] ;

      white[0].red =0xffff ;
      white[0].green = 0xffff;
      white[0].blue = 0xffff;
      
      white[1].red =0xdddd ;
      white[1].green = 0xdddd;
      white[1].blue = 0xffff ;
      
      white[2].red =0xdddd ;
      white[2].green = 0xffff;
      white[2].blue = 0xdddd ;

      white[3].red =0xffff ;
      white[3].green = 0xdddd;
      white[3].blue = 0xdddd;   */
      
      fp_log = fopen("furch_log","w");

/****  ==================================    */
/*    A pre-dimension for posit and pos_db 
 *   that will be dynamically adjusted if necessary
 */
      nb_posit = 0;
      nbmx_posit = 100;
      nb_pos_db = 0;
      nbmx_pos_db = 20;
      printf("nb_posit=%d \n",nb_posit);
      t_posit = g_malloc(sizeof(Trf_posit));
      (*t_posit).nbmx_posit = 100;
 //     malloc(t_posit -> posit ,((*t_posit).nbmx_posit+10)*sizeof(long));
      t_posit -> posit = g_malloc(((*t_posit).nbmx_posit+10)*sizeof(long));
      (*t_posit).nb_posit = 0;
      (*t_posit).nbmx_pos_db = 20;
      t_posit -> pos_db = g_malloc(((*t_posit).nbmx_pos_db+5)*sizeof(long));
      (*t_posit).nb_pos_db = 0;
      (*t_posit).n_highlight = 0;
/*      pos_db = malloc(nbmx_pos_db*sizeof(long)); */
      
      for (i=0; i < 1; ++i){
	for(j=0; j < 1 ; ++j){
	   drink[i][j] = g_malloc(101*sizeof(char));
	}/** for(j=0; j < 2 ; ++j){ **/
      }/*for (i=0; i <1; ++i){*/

//      Sklik = g_malloc(sizeof(Trf_Sklik));
//      (*Sklik).nb_klik=0;
      for(i=0;i < MAX_WORD;++i){
           klik[i]= g_malloc(sizeof(Trf_klik));
	   klik[i] -> tClist = g_malloc(sizeof(Trf_Clist));/* necessary but not really understood why */
	   klik[i] -> s_word = NULL;
	   klik[i] -> s_expr = NULL;
//         (*Sklik).klik[i]= g_malloc(sizeof(Trf_klik));
      }/** end of for(i=0,i<100,++i){ **/
      for(i=0;i < NSUP_ENTRY;++i){
         klik_entry[i]= g_malloc(sizeof(Trf_klik));
	 klik_entry[i] -> tClist = g_malloc(sizeof(Trf_Clist));/* necessary but not really understood why */
	   klik_entry[i] -> s_word = NULL;
	   klik_entry[i] -> s_expr = NULL;
      }/** end of for(i=0,i<100,++i){ **/
      book= g_malloc(sizeof(Trf_book));
      S_state = g_malloc(sizeof(Start_State));
      extrm= g_malloc(sizeof(Trf_extrm));
      Caract_win = g_malloc(sizeof(Prenestro));
      Tentry = g_malloc(sizeof(Trf_entry));
      w_loop1 = g_malloc(sizeof(W_loop));
      for(i=0;i <= MAX_SHIFT;++i){
	 (*w_loop1).s_expr[i] = NULL;
      }/*for(i=0;i <= MAX_SHIFT;++i){*/
      
      /*cap = g_malloc(sizeof(Trf_capsul)); not good  */
/**
      (*Caract_win).book_pix_size[0] = 650;
      (*Caract_win).book_pix_size[1]=900;
      (*Caract_win).npix_dico[0]=260;
      (*Caract_win).npix_dico[1]=260;
      (*Caract_win).npix_dico[2]=260;
      (*Caract_win).nc_max_dico[0]=33;
      (*Caract_win).nc_max_dico[1]=33;
      (*Caract_win).nc_max_dico[2]=33;
      (*Caract_win).level_dico[0]=3;
      (*Caract_win).level_dico[1]=3;
      (*Caract_win).level_dico[2]=3;
      strcpy((*Caract_win).BFE_dico,"FBE");
      (*Caract_win).Color_dico[0]=white[0];
      (*Caract_win).Color_dico[1]=white[1];
      (*Caract_win).Color_dico[2]=white[2];
      (*Caract_win).Color_dico[3]=white[3];   **/
/*
 *    the configuration file furch.conf is read by
 *    the subroutine FURCH_SET
 */    
 // G_dico = malloc(sizeof(Trf_string));
      G_dico = g_malloc(sizeof(Trf_string));
      (*book).lenmx_pages = 49;
      (*book).pages = g_malloc(((*book).lenmx_pages +1)*sizeof(char));
      (*book).extrm = extrm ;
      FURCH_SET(Caract_win,book,G_dico,&n_highlight);
//      exit(33);
      (*G_dico).norm_dico = g_malloc(((*G_dico).nb_dico+1)*sizeof(char));
      (*G_dico).color_dico = g_malloc(((*G_dico).nb_dico+1)*sizeof(char));
      (*t_posit).n_highlight = n_highlight;
//      printf("apres FURCH_SET n_highlight=%d\n",n_highlight);
//      printf("(*t_posit).n_highlight=%d \n",(*t_posit).n_highlight);
  /*    printf("MAIN mem_pages=%s \n",(*book).pages); */
/**      printf("level 0 \n");   **/
/*
 *     initialize the number of lines and words  in the first page
 *     and set the maximums to 100 lines and 1000 words on a
 *     book page
 */
      (*extrm).max_word= MAX_WORD;
      (*extrm).max_line=100;
      (*extrm).nb_word=0;
      (*extrm).nb_line=-1;
      (*extrm).nbsup_word=0;
      (*extrm).nbsup_line=-1;
/**      printf ("max_word=%d \n",(*extrm).max_word);   **/
/*******    read dico create indexes     ***/
//    printf("avant CALC_INDEX nbmx_posit=%d \n",(*t_posit).nbmx_posit);
      CALC_INDEX( fp_log,G_dico ,  t_posit ) ;
      fprintf(fp_log,"  \n");
      fprintf(fp_log,"  \n");
      fprintf(fp_log,"  End of updating indexes \n");
      fprintf(fp_log,"  Next action : updating list of endings \n");
      fprintf(fp_log,"  \n");
      fprintf(fp_log,"  \n");
//    printf("apres CALC_INDEX nbmx_posit=%d \n",(*t_posit).nbmx_posit);
//      exit(75);
      fp = fopen("./idx_gene","r") ;
/*      POSIT_INDEX( fp , &nb, &((*t_posit).nb_posit), \
		      &((*t_posit).nbmx_posit),t_posit -> posit ) ;*/
      nb = (*t_posit).nb_posit ;
      cap.nb = (*t_posit).nb_posit ;
      book -> posit = t_posit -> posit ;
      book -> fp_log = fp_log;
      cap.posit = t_posit -> posit ;
/*      for(i=0;i< nb ;++i){
	 (*book).posit[i]= *(t_posit -> posit + i ) ;
	 cap.posit[i] = *(t_posit -> posit + i ) ;
      }*//** end for(i=0;i<100;++i){  **/
      CALC_DIB( &nb0 ,t_posit );
      fprintf(fp_log,"  \n");
      fprintf(fp_log,"  \n");
      fprintf(fp_log,"  End of updating list of endings \n");
      fprintf(fp_log,"  Next action : Define windows and read book pages \n");
      fprintf(fp_log,"  \n");
      fprintf(fp_log,"  \n");
/*    printf("apres CALC_DIB nbmx_pos_db=%d \n",(*t_posit).nbmx_pos_db);
      printf("apres CALC_DIB nb_pos_db=%d \n",(*t_posit).nb_pos_db);
      printf("apres CALC_DIB nb0=%d \n",nb0);*/
      book -> pos_db = t_posit -> pos_db ;
      cap.nb0 = nb0;
      cap.pos_db = t_posit -> pos_db ;
/*      for(i=0;i< nb0;++i){
	 printf("i=%d pos_db[%d]= %ld \n",i,i,*(t_posit -> pos_db + i));
      }*//** end for(i=0;i<100;++i){  **/
/**      printf("On a %d entrees dans le fichier dibenn \n",nb0) ;  **/
      for(i=0;i < MAX_WORD;++i){
	 (*(*klik[i]).tClist).Caract_win = Caract_win ; /**  OK !      **/
	 (*(*klik[i]).tClist).cap = &cap ; /**  OK !      **/
	 (*klik[i]).ClearG_Dic = ClearG_Dic ; 
	 (*klik[i]).hbox_trf = g_malloc(sizeof(GtkWidget)) ; 
/**	 *((*klik[i]).cap) = cap ; compile but seg fault   **/
      }/** end for(i=0;i<100;++i){  **/
      for(i=0;i < NSUP_ENTRY;++i){
//	 (*klik_entry[i]).cap = &cap ; /**  OK !      **/
//	 (*klik_entry[i]).Caract_win = Caract_win ; /**  OK !      **/
	 (*(*klik_entry[i]).tClist).Caract_win = Caract_win ; 
	 (*(*klik_entry[i]).tClist).cap = &cap ; /**  OK !      **/
	 (*klik_entry[i]).ClearG_Dic = ClearG_Dic ; 
	 (*klik_entry[i]).hbox_trf = g_malloc(sizeof(GtkWidget)) ; 
//	 (*klik_entry[i]).stgs_dico = G_dico ; /**  OK !      **/
	 (*(*klik_entry[i]).tClist).G_dico = G_dico ; /**  OK !   **/
      }/** end for(i=0;i<100;++i){  **/
    /*  (*Tentry).cap = &cap ; */
      (*Tentry).w_loop = w_loop1 ;
      (*Tentry).ncall_entry = 0 ;
      
/*
 *  Prelecture of the text files
 */
      printf("call PRELECT_ALL_FILES \n");
      fflush(stdout);
      PRELECT_ALL_FILES(book) ;
      printf("after PRELECT_ALL_FILES \n");
      fflush(stdout);
/*
 *
 */

      
/**      nc = (*klik[0])-> cap.posit[0] ;  **/
/**      nc = (*klik[0])-> (*cap).posit[0] ;  **/
/**      cap1 = *((*klik[0]).cap);    **   OK !    **/
/*      cap1 = *((*klik[87]).cap);*/
/**      nc = *((*klik[0]).cap).posit[0] ;  not good !  **/
/**      nc = (*((*klik[0]).cap)).posit[0] ;   **   OK !      **/
/**      nc = (*(*klik[0]).cap).posit[0] ;    **   OK !      **/
/**      cap1 = *((*klik[0]).cap); nc = cap1.posit[0] ;  good **/
/*      nc = cap1.posit[0] ;  */
 /*     nc = (*(*klik[0]).cap).posit[0] ;   le plus logique !  **/
/**      printf("nc=%ld  \n",nc);   **/
                /****************/
      gtk_rc_parse ("gtkb.rc");/** definition of fonts and colors 
				  used by GTK+   **/
      /* Our init, don't forget this! :) */
      gtk_init (&argc, &argv);

/****  ==================================    */

/**       iloop=0 ;
       while ( iloop <= 2) {
	       ++iloop ;**/
      /* Create our main window */
      START_PAGE_NUMBER(S_state,book);
      printf("after START_PAGE_NUMBER \n");
      fflush(stdout);
      window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

      /* You should always remember to connect the delete_event signal
       * to the main window. This is very important for proper intuitive
       * behavior */
      gtk_signal_connect (GTK_OBJECT (window), "delete_event",
                          GTK_SIGNAL_FUNC (delete_event), NULL);
      gtk_container_set_border_width (GTK_CONTAINER (window), 10);
/**      printf("level 1 \n");  **/
/*
 *   We have to create an horizontal box to pack the book window 
 *   and the dictionary window
 */   
      if((*S_state).root_width > 0 && (*S_state).root_height > 0){
           width0= (*S_state).root_width;
           height0= (*S_state).root_height;
           width_book = (*S_state).width_book;
      }else{
           width0= (*Caract_win).book_pix_size[0];
//           + (*Caract_win).npix_tot_dico[0] + 30; 
	   height0= (*Caract_win).book_pix_size[1];
           width_book= (*Caract_win).book_pix_size[2];
      }/*if((*S_state).root_width > 0 && (*S_state).root_width > 0){*/
      printf("Main_Window_default width=%d height=%d\n",width0,height0);
      printf("Book_Window_default width=%d \n",width_book);
      gtk_window_set_default_size(GTK_WINDOW(window),width0,height0);
//hz      hzbox = gtk_hbox_new (FALSE, 0);/**  h box to pack book and dico **/
      hzbox = gtk_hpaned_new ();/**  h box to pack book and dico **/
      gtk_paned_set_position(GTK_PANED(hzbox),width_book);
      gtk_container_add (GTK_CONTAINER (window), hzbox);/***box1**/
//hz      gtk_box_set_homogeneous(GTK_BOX(hzbox),FALSE);/* for its chidrend*/
/*
 *    box1 is the book window it contains from top to back
 *          1  a window to display the name of the file which is read
 *             this is the "box_label" box
 *          2  a window to display the writings on the book page
 *          3  a separator
 *          4  a window for the buttons (quit,next ...)
 */          
//hz      box1 = gtk_vbox_new (FALSE, 0);
      frame1 = gtk_frame_new (NULL);
      gtk_frame_set_shadow_type(GTK_FRAME(frame1),GTK_SHADOW_IN);
      gtk_widget_set_size_request(frame1,50,-1);
/** gtk_box_pack_start (GTK_BOX (box), button1, expand, fill, padding);**/
//      gtk_box_pack_start (GTK_BOX (hzbox), box1, FALSE, FALSE, 0);
//hz      gtk_box_pack_start (GTK_BOX (hzbox), box1, TRUE,TRUE, 0);
      gtk_paned_pack1 (GTK_PANED (hzbox), frame1, TRUE,FALSE);
      box1 = gtk_vbox_new (FALSE, 0);
      gtk_container_add(GTK_CONTAINER(frame1),box1);
/*
 *    the "box_label" box is an horizontal box which will pack 
 *    2 boxes. the first with the label: "file ;" and the second
 *    is a clist window with the name of the file
 *    name of first box : "label0_file
 *    name of second box :  "label" (This is a Clist)
 */
      box_label = gtk_hbox_new (FALSE, 0);/**  a box to pack the label **/
//	    pango_font_description_from_string("Helvetica bald 25");
      gtk_box_pack_start (GTK_BOX (box1), box_label, FALSE, FALSE, 0);
          /* create a new label box whose name is "label0_file". */
          label0_file = gtk_label_new ("file : ");
      style = gtk_style_copy(gtk_widget_get_style( GTK_WIDGET(label0_file)));
	    style -> font_desc = \
	    pango_font_description_from_string(Caract_win -> font_dico);
	    gtk_widget_set_style(label0_file, style);
          gtk_box_pack_start (GTK_BOX (box_label), label0_file, FALSE, FALSE, 0);
          gtk_widget_show (label0_file);
/*
 */
/*
 *     Create the entry widget (the command line)
 *     to display the page filename in the book part
 */     
      entry_book = gtk_entry_new_with_max_length (50);
      /*  these four lines are working well */
            style = gtk_style_copy(gtk_widget_get_style( GTK_WIDGET(entry_book)));
	    style -> font_desc = \
	    pango_font_description_from_string(Caract_win -> font_dico);
//	    pango_font_description_from_string("Helvetica bald 25");
	    gtk_widget_set_style(entry_book, style);
/*      (*Tentry).entry = entry ;  */
/* 
 * Activation of the widget (it is the return signal)
 */ 
      gtk_signal_connect(GTK_OBJECT(entry_book), "activate",
                         GTK_SIGNAL_FUNC(callback_entry_book), book);
/**/
      g_signal_connect((gpointer) entry_book, "button-press-event",
                         G_CALLBACK(clean_entry_book), book);
//                         G_CALLBACK(clean_entry_book), Tentry);
/*      gtk_entry_set_text (GTK_ENTRY (entry), "B> ");
      gtk_entry_append_text (GTK_ENTRY (entry), "hello world");*/
//xx      gtk_entry_set_text (GTK_ENTRY (entry_book),"new_file ");
/*      gtk_entry_select_region (GTK_ENTRY (entry_book),
                               0, GTK_ENTRY(entry_book)->text_length);*/
/*      gtk_editable_cut_clipboard(GTK_EDITABLE(entry));*/
      gtk_box_pack_start (GTK_BOX (box_label), entry_book, TRUE, TRUE, 0);
//      (*book).win_label = entry_book ; 
//      (*book).entry_book = entry_book ; 
//	  START_PAGE_NUMBER(S_state);
          (*book).ipage = (*S_state).num_page ;
          (*book).ifile_book = (*S_state).num_book ;
//      int nt_books ; // total number of books in library
//      int lstb_insert ; // last book before book insertion
          (*book).nt_books = -1 ;
          (*book).lstb_insert = -1 ;

      gtk_widget_show (entry_book);
/*
 */
      gtk_widget_show (box_label);

	  
	  
/**  creates the scrolled page of the book  and packs it into the
 *    book window box1 **/
	  
      scroll_page = gtk_scrolled_window_new (NULL,NULL);
          gtk_rc_parse_string(ss_book_scrolled);
          gtk_widget_set_name( scroll_page , "book_scrolled") ;
          gtk_scrolled_window_set_policy \
		  (GTK_SCROLLED_WINDOW (scroll_page), \
		   GTK_POLICY_AUTOMATIC,GTK_POLICY_ALWAYS);
	  gtk_box_pack_start( GTK_BOX (box1),scroll_page,TRUE,TRUE,0);
/*    a vbox must be created to put in the scrolled page.
 *    the vbox of name v_page will contain the box lines which will
 *    contain the box words
 */
      v_page = gtk_vbox_new (FALSE, 0); /* viewport de scroll_page */
/*      gtk_widget_set_usize(scroll_page,(*Caract_win).book_pix_size[0]\
		      ,(*Caract_win).book_pix_size[1]);*/
/*      gtk_window_set_default_size(GTK_SCROLLED_WINDOW(scroll_page)\
		      ,(*Caract_win).book_pix_size[0]\
		      ,(*Caract_win).book_pix_size[1]);*/
      gtk_scrolled_window_add_with_viewport \
	              (GTK_SCROLLED_WINDOW(scroll_page),v_page);



/**  ================================================================ */



/***   creates a v box for the scrolled dictionary to be packed into **/
//hz      box_bzh = gtk_vbox_new (FALSE, 0);
          frame2 = gtk_frame_new (NULL);
	  gtk_frame_set_shadow_type(GTK_FRAME (frame2),GTK_SHADOW_IN);
	  gtk_widget_set_size_request(frame2,50,-1);
          box_bzh = gtk_vbox_new (FALSE, 0);
          gtk_container_add(GTK_CONTAINER(frame2),box_bzh);

/*      box_bzh_e = gtk_event_box_new ();
      gtk_container_add(GTK_CONTAINER(window),box_bzh_e);*/
    /**  gdk_window_clear(box_bzh_e->window);  **/
          /***  an event box to detroy something  ???    ***/
      
/*
 *     Writes a string such as "dico= F3 B3 E1"    showing the
 *     version of the dictionary and its level . In the example given
 *     we will have French level 3 followed by Breton level 3 and
 *     Eng. It was a Clist
 *     and it has to be changed into a command line
 * /lish level 1. This is what you asked in the furch.conf file ...
 */
//      sprintf(s_dico,"dico= %c%d  %c%d  %c%d ",
      sprintf(s_dico," %c%d  %c%d  %c%d ",\
      (*Caract_win).BFE_dico[0], (*Caract_win).level_dico[0], \
      (*Caract_win).BFE_dico[1], (*Caract_win).level_dico[1], \
      (*Caract_win).BFE_dico[2], (*Caract_win).level_dico[2]);
/*
 *     An horizontal box is created to pack the F1B3E2 label
 *     and a command line window
 */
      hFBE_box = gtk_hbox_new (FALSE, 0);/**  h box to pack albel
					   and command line **/
      gtk_box_pack_start (GTK_BOX(box_bzh), hFBE_box, FALSE, FALSE, 0);
/*
 *     With the string just defined a label box is created and packed
 *     into the dictionary main vertical box : box_bzh
 */
          label = gtk_label_new (s_dico);
      style = gtk_style_copy(gtk_widget_get_style( GTK_WIDGET(label)));
/***** Provisional   **********/
	    style -> font_desc = \
	    pango_font_description_from_string("helvetica 10");
//	    pango_font_description_from_string(Caract_win -> font_dico);
	    gtk_widget_set_style(label, style);
          gtk_misc_set_alignment (GTK_MISC (label), 0, 0);
          gtk_box_pack_start (GTK_BOX (hFBE_box), label, FALSE, FALSE, 0);
          gtk_widget_show (hFBE_box);
          gtk_widget_show (label);
/*
 *    Now we must have a button for the general clearing of the
 *    dico part
 */
      ClearG_Dic = gtk_button_new_with_label ("ClrD");
      gtk_widget_set_name( ClearG_Dic , "buttonnoir") ; 
/*
 *     Create the entry widget (the command line)
 */     
/*      for(i=0;i<100;++i){
         Tentry -> klik[i] -> ClearG_Dic = ClearG_Dic ;
      }*//** end for(i=0;i<100;++i){  **/
      entry = gtk_entry_new_with_max_length (50);
      /*  these four lines are working well */
            style = gtk_style_copy(gtk_widget_get_style( GTK_WIDGET(entry)));
	    style -> font_desc = \
	    pango_font_description_from_string(Caract_win -> font_dico);
//	    pango_font_description_from_string("Helvetica bald 25");
	    gtk_widget_set_style(entry, style);
/*      (*Tentry).entry = entry ;  */
      gtk_signal_connect(GTK_OBJECT(entry), "activate",
                         GTK_SIGNAL_FUNC(callback_entry), Tentry);
      g_signal_connect((gpointer) entry, "button-press-event",
                         G_CALLBACK(clean_entry), Tentry);
/*      gtk_entry_set_text (GTK_ENTRY (entry), "B> ");
      gtk_entry_append_text (GTK_ENTRY (entry), "hello world");*/
      ss = g_locale_to_utf8("Enter a word",-1,NULL,NULL,NULL); 
      gtk_entry_set_text (GTK_ENTRY (entry),ss);
      g_free(ss);
//      printf("enter a word = %d \n", GTK_ENTRY (entry) -> text_length);
/*
 *   does not work for unknown reason
 */
      gtk_editable_select_region (GTK_EDITABLE (entry),
                               0, -1); 
//                               0, GTK_ENTRY(entry)->text_length); 
//                               0, 5);
/*      gtk_editable_cut_clipboard(GTK_EDITABLE(entry));*/
      gtk_box_pack_start (GTK_BOX (hFBE_box), entry, TRUE, TRUE, 0);
      cap.entry = entry ; 
      gtk_widget_show (entry);

/*   This is to set the horizontal size of the dictionary windows  */
//      gtk_widget_set_usize(box_bzh,(*Caract_win).npix_tot_dico[0],15); 
//      gtk_window_set_default_size(GTK_WINDOW(box_bzh),(*Caract_win).npix_tot_dico[0],15); 
/*
 *    The dictionary needs to be scrolled. This is done by creating
 *    a scrolled window : "scroll_bzh" and its associated 
 *    viewport : "box2"
 */
      scroll_bzh = gtk_scrolled_window_new (NULL,NULL);
          gtk_scrolled_window_set_policy \
		  (GTK_SCROLLED_WINDOW (scroll_bzh), \
		   GTK_POLICY_AUTOMATIC,GTK_POLICY_ALWAYS);
	  gtk_box_pack_start( GTK_BOX(box_bzh),scroll_bzh,TRUE,TRUE,0);
	  gtk_widget_show(scroll_bzh);
      box2 = gtk_vbox_new (FALSE, 0);
      gtk_scrolled_window_add_with_viewport \
	              (GTK_SCROLLED_WINDOW(scroll_bzh),box2);
      gtk_widget_show(box2);

      ss1_trf[0]='\0';
      /**clist = gtk_clist_new(1);  **/
/*
 * The NEXT button on the book window needs also to be created
 * before the call to LECT_FICH_QUERE where the book is
 * displayed. It is the same for the prev (previous page) button
 */
      /* Our clear_page buttons. Together with the QUIT button it
       * will be packed into the quitbox*/
      next_page = gtk_button_new_with_label ("next");
      gtk_widget_set_name( next_page , "buttonnoir") ; 
      prev_page = gtk_button_new_with_label ("prev");
      gtk_widget_set_name( prev_page , "buttonnoir") ; 
/*
 *    Now we must have a button for the general clearing of the
 *    dico part
 */
/*      ClearG_Dic = gtk_button_new_with_label ("ClrD");
      gtk_widget_set_name( ClearG_Dic , "buttonnoir") ; */
      for(i=0;i < MAX_WORD;++i){
	 (*klik[i]).status_hbox = 0;
	 (*klik[i]).ClearG_Dic = ClearG_Dic ;  
      }
      for(i=0;i < NSUP_ENTRY;++i){
	 (*klik_entry[i]).status_hbox = 0 ; 
	 (*klik_entry[i]).ClearG_Dic = ClearG_Dic ;  
      }
/**	 *((*klik[i]).cap) = cap ; compile but seg fault   **/

      /*******************************************************/
      /*******************************************************/
      /* Lecture of the file corresponding to Quere's book   */
      /*     here is the main subroutine for the display of
       *     the book pages 
       */     

//      (*book).box1 = v_page ;
//      (*book).scroll_bzh = scroll_bzh;
//      (*book).dico_b = box2 ;
//      book -> stgs_dico = G_dico;
//      for(i=0;i< MAX_WORD;++i){
//	 (*book).klik[i]=klik[i];
//      }/** end for(i=0;i<100;++i){  **/
//      for(i=0;i<100;++i){
//	 lbox2[i] = g_malloc(sizeof(GtkWidget)) ; 
//	 (*book).lbox2[i]= lbox2[i] ;
//      }/** end for(i=0;i<100;++i){  **/
      (*book).nb = nb ; //attempt reduce nb argument
      (*book).nb0 = nb0;  //attempt reduce nb argument;
/*
 *   e passage dans book de nb nb0 lbox2  = segmentation error
 */
   LECT_FICH_QUERE(extrm,nb0,nb,t_posit -> posit, t_posit -> pos_db, \
		   v_page,lbox2, \
		   scroll_bzh,box2, \
	  G_dico,klik,book,box_label,entry_book);  
      gtk_editable_select_region (GTK_EDITABLE (entry),
                               0, -1); 
//                               0, GTK_ENTRY(entry)->text_length); 
/*	  G_dico,klik,(*book).pages , \
		   box_label,(*book).win_label) ;*/

      /*******************************************************/
      /*******************************************************/
   /*  We can now display the page and its scrolled window  */
	  gtk_widget_show(scroll_page);
          gtk_widget_show(v_page);
/****  ============================================================    */
          /* Creates a separator, we'll learn more about these later,
           * but they are quite simple. */
          separator = gtk_hseparator_new ();

          /* Pack the separator into the vbox. Remember each of these
           * widgets is being packed into a vbox, so they'll be stacked
           * vertically. */
          gtk_box_pack_start (GTK_BOX(box1), separator, FALSE, TRUE, 5);
          gtk_widget_show (separator);

/****  ===== =============================    */
	
  /* Create another new hbox.. remember we can use as many as we need! */
	  /*  Create the quitbox to pack the next_page, the ClearG_Dic
	   *  and the QUIT buttons into */
      quitbox = gtk_hbox_new (FALSE, 0);

      /* Our quit button. */
      button = gtk_button_new_with_label ("Quit");
      gtk_widget_set_name( button , "buttonnoir") ; 

      /* Setup the signal to terminate the program when the button is clicked */
  /*    gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
                                 GTK_SIGNAL_FUNC (gtk_main_quit),
                                 GTK_OBJECT (window));*/
            gtk_signal_connect(GTK_OBJECT (button),\
	    "clicked",  GTK_SIGNAL_FUNC (ON_QUIT), book );
/*
 *    Now we must have a button for the general clearing of the
 *    dico part
 */
/*      ClearG_Dic = gtk_button_new_with_label ("ClrD");
      gtk_widget_set_name( ClearG_Dic , "buttonnoir") ; */
/***   The next_page button must do everything that was done for the
 *     first page by the LECT_FICH_QUERE sub. That is why the 
 *     structure book must be transmitted to it
 */
 /*     (*book).nb0 = nb0 ;
      (*book).nb = nb ; // attempt reducing nb of arguments in LECT_FICH_QUERE */
      (*book).hzbox = hzbox ;
      (*book).box1 = v_page ;
     /* (*book).next_page = next_page ;*/
      (*book).scroll_bzh = scroll_bzh;
      (*book).dico_b = box2 ;
      (*book).win_book = box_label;
      (*book).win_main = window;
      (*book).entry_book = entry_book ; 
      book -> stgs_dico = G_dico;
/*      for(i=0;i<100;++i){
         (*(*Tentry).klik[i]).pbox_trf = box2 ;
      }*//** end for(i=0;i<100;++i){  **/
      for(i=0;i < NSUP_ENTRY ;++i){
	 (*klik_entry[i]).pbox_trf = box2 ; 
      }
      for(i=0;i < NSUP_ENTRY;++i){
         (*Tentry).klik[i] = klik_entry[i] ;
      }/** end for(i=0;i<100;++i){  **/
/*      (*book).clist = clist ;  */
//      (*book).extrm = extrm ;
//      printf("avant book \n");
      for(i=0;i< MAX_WORD;++i){
/*	 (*book).label_word[i]= label_word[i] ;*/
/*	 (*book).button1[i]= button1[i] ;*/
	 (*book).klik[i]=klik[i];
//	 (*Sklik).klik[i]=klik[i];
      }/** end for(i=0;i<100;++i){  **/
//      (*book).Sklik = Sklik ;
//      printf("apres book \n");
/**      printf("*book.klik.sklik=%s \n",(*(*book).klik[0]).s_klik);  **/
      for(i=0;i<100;++i){
	 (*book).lbox2[i]= lbox2[i] ;
      }/** end for(i=0;i<100;++i){  **/
      gtk_signal_connect (GTK_OBJECT (next_page), "clicked",
                        GTK_SIGNAL_FUNC (cback_new_page),book);
      gtk_signal_connect (GTK_OBJECT (prev_page), "clicked",
                        GTK_SIGNAL_FUNC (cback_prev_page),book);
      /* Pack the button into the quitbox.
       * The last 3 arguments to gtk_box_pack_start are:
       * expand, fill, padding. */
      gtk_box_pack_start (GTK_BOX (quitbox), prev_page, TRUE, FALSE,0);
      gtk_box_pack_start (GTK_BOX (quitbox), next_page, TRUE, FALSE,0);
//      gtk_box_pack_start (GTK_BOX (quitbox), klik[0] -> ClearG_Dic, TRUE, FALSE, 0);
      
      gtk_box_pack_start (GTK_BOX (quitbox), ClearG_Dic, TRUE, FALSE, 0);
/*            (*book).nb=-1;  */
/*  
 *  We have to define the action of the General Clear Dicos button
 *  It will clear the Trf_klik in book and Tentry
 */
            gtk_signal_connect(GTK_OBJECT (ClearG_Dic),\
	    "clicked",  GTK_SIGNAL_FUNC (callback_GClear_Dicos), \
	    book );
            gtk_signal_connect(GTK_OBJECT (ClearG_Dic),\
	    "clicked",  GTK_SIGNAL_FUNC (entry_GClear_Dicos), \
	    Tentry );
      gtk_box_pack_start (GTK_BOX (quitbox), button, TRUE, FALSE, 0);
      /* pack the quitbox into the vbox (box1) */

      gtk_box_pack_start (GTK_BOX(box1), quitbox, FALSE, FALSE, 0);

      /* Pack the vbox (box1) which now contains all our widgets, into the
       * main window. */

      /* And show everything left */
      gtk_widget_show (button);
      gtk_widget_show (ClearG_Dic);
      gtk_widget_show (next_page);
      gtk_widget_show (prev_page);
      gtk_widget_show (quitbox);

      gtk_widget_show (box1);
      /******   the end for box1  the BOOK    *****/
/*          separator = gtk_vseparator_new ();
          gtk_box_pack_start (GTK_BOX (hzbox), separator, FALSE, TRUE, 5);
          gtk_widget_show (separator);*/
   /**   box2 = gtk_vbox_new (FALSE, 0); **/
/** gtk_box_pack_start (GTK_BOX (box), button1, expand, fill, padding);**/
//    gtk_box_pack_start (GTK_BOX (hzbox), box_bzh, FALSE,FALSE, 0);
//hz      gtk_box_pack_start (GTK_BOX (hzbox), box_bzh, TRUE,TRUE, 0);
      gtk_paned_pack2 (GTK_PANED (hzbox), frame2, TRUE,FALSE);
      gtk_widget_show (box_bzh);
      gtk_widget_show (frame1);
      gtk_widget_show (frame2);
      gtk_widget_show (hzbox);  
      /* Showing the window last so everything pops up at once. */
      gtk_widget_show (window);
      if( (*S_state).root_x >= 0 && (*S_state).root_y >= 0 ){
          gtk_window_move(GTK_WINDOW(window)\
	  ,(*S_state).root_x, (*S_state).root_y);
      }/*if( (*S_state).root_x > 0 && (*S_state).root_y > 0 ){*/

/****  ===== =============================    */
      /* And of course, our main function. */
      gtk_main ();
      

        /** end while ( iloop <= 2) { **/
/****  ==================================    */
fclose(fp_log);
exit(0);
}
/**********************************************************************/
/**********************************************************************/
/**********************************************************************/
/**********************************************************************/
/*********************   End of gtkb2.c  ******************************/
/**********************************************************************/
/**********************************************************************/
/**********************************************************************/
