/*
 *   This software is released without any guaranty of any kind.
 *   It is released under the terms of the GPL licence
 */
# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include <ctype.h>
# include <stddef.h>
#include <gtk/gtk.h>
#include "gtkb2_0.h"
/*
 *    This file is devoted to the extraction of new information
 *    from a dico with a complete norm
 */

/********************************************************************/
  void DOWN_DICO_COMBING(FILE *fp_log, char BFE, FILE *fp, long *first,\
		  Trf_combing *t_combing )
/*
 *     Goal of this sub : Go down the dictionary while combing
 *     it to extract words and translations which are into the
 *       B>1 B>2  F>1 ... E>3   paragraphs
 *       these words are in between quotes.
 */
/***   means go down the dico down to next # or end of file     ***/
/*
*     BFE is the letter for the language dictionary "B", "F" or "E"
*     at present time. first is the position of start to read
*     the dico
*     fp  is the dico  
*     
*/
/*    int len_words_add ; 
    int len_gramm_add ; 
    char *st_words_add;
    char *st_gramm_add;   */
//      path = g_realloc(path,lenpf*sizeof(char));
  {
   char s[101],y[101];
   int i,iloop,y_case[4];
   int i_quote,l;
   long firstb ;
   int nw,ng;
      
//   printf("ENTRANCE DOWN_DICO_COMBING \n");
         firstb= *first ;
	 fseek(fp,firstb,0);
	 y[0]=' ';
	 iloop=0;
	 i_quote = -1 ;  /* initialize the toggle quote button */
/*         *((*t_combing).st_words_add)='\0';
	 *((*t_combing).st_gramm_add)='\0';  */
	 nw=(*t_combing).len_words_add;
	 ng=(*t_combing).len_gramm_add;
	/*
 *  initialise the y_case because it may not be done in ANALY_EXTRA
 */
	 for (i= 0 ; i <= 3 ; ++i){ /* initialize y_case  */
             y_case[i] = -1 ;
         }/** end of for (i= 0 ; i <= 3 ; ++i){  **/
/**   	 while(y[0] == ' ' || y[0] == BFE){      **/
   	 while(iloop == 0 ){  /* y is the character chain like B>2[1.1.1]*/    
	   *first=ftell(fp);
//	    printf("iloop=%d first= %ld  \n",iloop,*first);  
	   if(fgets(s,100,fp) == NULL ){
              ++iloop;
	   }else{/*if(fgets(s,100,fp) == NULL ){  */
	    /**   printf("avant RM_EXTRA s=%s@@@ \n",s);**/
//rrrrrrrrrrrrrrrrrrrrrrrrrrrr
	      l=strcspn(s,"\r\n\0");
	      s[l]='\0';
	      RM_EXTRA(s,y);
	      if(y[0] == '#'){
		 ++iloop;
		 continue ;
	      }/*  if(y[0] == '#'){*/
//	      printf("DOWN_DICO s=%s  y=%s \n",s,y);
/*
 * Remark :  ANALY_EXTRA does not change y_case if y=" "
 */
              ANALY_EXTRA( y, y_case);/* See function comments for y_case */
   /* ANALY_EXTRA initialize y_case and put y_case[1] = -1 
   * for a continuation line
   *  i_quote is a toggle button we start with a "end quote"
   *  value ( 1 ) The start quote value is -1 	      
   */
             if ((y_case[1] == 0 && y[0] == BFE ) )i_quote = 1;	      
/**     printf("apres RM_EXTRA s=%s@@@ \n",s); **/
             DECODE_ACCENTS(s);
/*
*  For the case B1> douar = "douar (ag)" Anv gourel ....
*  That is to say at the beginning of the explanations we want
*  to remove (ag)  which is a coded grammatical information			
*/
	    if ((y_case[1] == 0 && y[0] == BFE ) ||\
	        (y_case[1] == 0 && y[0] == ' ' ) ){
//	       printf("OK y_case[1]=%d y_case_mem[1]=%d y=%s@@@\n",
//		   y_case[1],y_case_mem[1],y);
	      if(i_quote == 1) *((*t_combing).words_extracted)='\0';
              EXTRACT_BETW_QUOTES(fp_log,&i_quote,s,t_combing);
//    printf("DOWN_DICO_COMBING wd_extr=%s@@@ \n",(*t_combing).words_extracted);
	    }	
   /**            printf("apres DECODE_ACCENTS s=%s## \n",s); **/
	       if(y[0] == ' ' || y[0] == BFE){
	          if(y[0] == BFE )y[0] = ' ';
	       }else{
/****   the following code has been added to deal with the mixing
 *      of languages in paragraphs. We go down to next BFE
 */      
  		    while(y[0] != BFE  &&  y[0] != '#' ){   
		        *first=ftell(fp);
		        if(fgets(s,100,fp) == NULL) {
			   y[0] = '#';
		        }else{/*{if(fgets(s,100,fp) == NULL {*/
	                   RM_EXTRA(s,y);
		        }/*{if(fgets(s,100,fp) == NULL {*/
		    }/* end of while(y[0] != BFE  &&  y[0] != '#' ){ */  
	            if( y[0] == '#')++iloop;
	            fseek(fp,*first,0); /*  Go back one line */
	       }/** if(y[0] == ' ' || y[0] == 'B'){  **/
	    }/*if(fgets(s,100,fp) == NULL ){  */
	 }/** while(y[0] == ' ' || y[0] =='B'){ **/
}/** end of  DOWN_DICO_COMBING( File *fp, long *first, int *iclist **/
/********************************************************************/
  void DOWN_DICO_SCOMBING(FILE *fp_log,int code, char BFE, FILE *fp,\
		  long *first,Trf_combing *t_combing )
/*
 *     This is the combing of the dictionaries for secondary entries
 *     such as  <".....">  or ("......")
 *               code= 1        code=2
 *     Goal of this sub : Go down the dictionary while combing
 *     it to extract words and translations which are into the
 *       B>1 B>2  F>1 ... E>3   paragraphs
 *       these words are in between quotes.
 */
/***   means go down the dico down to next # or end of file     ***/
/*
*     BFE is the letter for the language dictionary "B", "F" or "E"
*     at present time. first is the position of start to read
*     the dico
*     fp  is the dico  
*     
*/
/*    int len_words_add ; 
    int len_gramm_add ; 
    char *st_words_add;
    char *st_gramm_add;   */
//      path = g_realloc(path,lenpf*sizeof(char));
  {
   char s[101],y[101];
   int i,iloop,y_case[4];
   int i_quote,l;
   long firstb ;
   int nw,ng;
      
//   printf("ENTRANCE DOWN_DICO_COMBING \n");
         firstb= *first ;
	 fseek(fp,firstb,0);
	 y[0]=' ';
	 iloop=0;
	 i_quote = -1 ;  /* initialize the toggle quote button */
/*         *((*t_combing).st_words_add)='\0';
	 *((*t_combing).st_gramm_add)='\0';  */
	 nw=(*t_combing).len_words_add;
	 ng=(*t_combing).len_gramm_add;
	/*
 *  initialise the y_case because it may not be done in ANALY_EXTRA
 */
	 for (i= 0 ; i <= 3 ; ++i){ /* initialize y_case  */
             y_case[i] = -1 ;
         }/** end of for (i= 0 ; i <= 3 ; ++i){  **/
/**   	 while(y[0] == ' ' || y[0] == BFE){      **/
   	 while(iloop == 0 ){  /* y is the character chain like B>2[1.1.1]*/    
	   *first=ftell(fp);
//	    printf("iloop=%d first= %ld  \n",iloop,*first);  
	   if(fgets(s,100,fp) == NULL ){
              ++iloop;
	   }else{/*if(fgets(s,100,fp) == NULL ){  */
	    /**   printf("avant RM_EXTRA s=%s@@@ \n",s);**/
//rrrrrrrrrrrrrrrrrrrrrrrrrrrr
	      l=strcspn(s,"\r\n\0");
	      s[l]='\0';
	      RM_EXTRA(s,y);
	      if(y[0] == '#'){
		 ++iloop;
		 continue ;
	      }/*  if(y[0] == '#'){*/
//	      printf("DOWN_DICO s=%s  y=%s \n",s,y);
/*
 * Remark :  ANALY_EXTRA does not change y_case if y=" "
 */
              ANALY_EXTRA( y, y_case);/* See function comments for y_case */
   /* ANALY_EXTRA initialize y_case and put y_case[1] = -1 
   * for a continuation line
   *  i_quote is a toggle button we start with a "end quote"
   *  value ( 1 ) The start quote value is -1 	      
   */
             if ((y_case[1] == 0 && y[0] == BFE ) )i_quote = 1;	      
/**     printf("apres RM_EXTRA s=%s@@@ \n",s); **/
             DECODE_ACCENTS(s);
/*
*  For the case B1> douar = "douar (ag)" Anv gourel ....
*  That is to say at the beginning of the explanations we want
*  We don't examin the B>1  but the B>1[0.1.2] or over
*/
	    if ((y_case[1] > 0 && y[0] == BFE ) ||\
	        (y_case[1] > 0 && y[0] == ' ' ) ){
//	       printf("OK y_case[1]=%d y_case_mem[1]=%d y=%s@@@\n",
//		   y_case[1],y_case_mem[1],y);
	      if(i_quote == 1) *((*t_combing).words_extracted)='\0';
	      EXTRACT_BETW_SQUOTES(fp_log,&i_quote,code,s,\
			      t_combing);
/*	     printf("DOWN_DICO_SCOMBING wd_extr=%s@@@ \n",\
			     (*t_combing).words_extracted);*/
	    }	
   /**            printf("apres DECODE_ACCENTS s=%s## \n",s); **/
	       if(y[0] == ' ' || y[0] == BFE){
	          if(y[0] == BFE )y[0] = ' ';
	       }else{
/****   the following code has been added to deal with the mixing
 *      of languages in paragraphs. We go down to next BFE
 */      
  		    while(y[0] != BFE  &&  y[0] != '#' ){   
		        *first=ftell(fp);
		        if(fgets(s,100,fp) == NULL) {
			   y[0] = '#';
		        }else{/*{if(fgets(s,100,fp) == NULL {*/
	                   RM_EXTRA(s,y);
		        }/*{if(fgets(s,100,fp) == NULL {*/
		    }/* end of while(y[0] != BFE  &&  y[0] != '#' ){ */  
	            if( y[0] == '#')++iloop;
	            fseek(fp,*first,0); /*  Go back one line */
	       }/** if(y[0] == ' ' || y[0] == 'B'){  **/
	    }/*if(fgets(s,100,fp) == NULL ){  */
	 }/** while(y[0] == ' ' || y[0] =='B'){ **/
}/** end of  DOWN_DICO_COMBING( File *fp, long *first, int *iclist **/
/********************************************************************/
void  EXTRACT_BETW_SQUOTES(FILE *fp_log,int *i_quote,int code,char s[],\
	 Trf_combing *t_combing)
   /*
    *   Extract the words which are between the quotes with the
    *   problem of the parenthesis ()  and the [] 
   *     into "word(xxx)". This will be handled into ADD_WORDS 
   * 
   *    for quotes "  "      already seen opening "  i_quote = -1 
   *                         already seen closing "  i_quote = 1
   *    i_quote is a toggle button we start with a "end quote"
   *    value ( 1 ) 
   *    code = 1  look for <"   ">
   *    code = 2  look for ("   ")
   */
{
   char *stp , *stp1, *stp2;
//     printf("sub EXTRACT_BETW_QUOTES s=%s \n",s);
//     printf("i_parenth=%d \n",*i_parenth );
     stp = NULL;
     if(*i_quote == 1  ){
        if( code == 1 ){
           stp= strstr(s,"<\"");
        }else{/* if(*i_quote == 1 && code == 1 )*/
           if( code == 2 ){
	      stp= strstr(s,"(\"");
           }/* if(*i_quote == 1 && code == 1 )*/
        }/* if(*i_quote == 1 && code == 1 )*/
     }else{/*if(*i_quote == 1  ){*/
        if(*i_quote == -1 ){
           if( code == 1 ){
	      stp= strstr(s,"\">");
           }else{/* if(*i_quote == 1 && code == 1 )*/
              if( code == 2 ){
	         stp= strstr(s,"\")");
              }/* if(*i_quote == 1 && code == 1 )*/
           }/* if(*i_quote == 1 && code == 1 )*/
	}/*if(*i_quote == -1 ){*/
     }/*if(*i_quote == 1  ){*/
//     if(stp == NULL)printf("stp= NULL \n");
      if( stp == NULL && *i_quote == 1 ) return ;
      if( stp == NULL && *i_quote == -1 ){
	 /* extract words and grammatical values on the whole line */
	 stp2 = strchr(s,'\0');
//	 printf("call ELIM_B 1 \n")
	 WORDS_BETW_QUOTES(fp_log, s,s, stp2,t_combing);
/*	 printf("EXTRACT_BETW_QUOTES level 0 w_ext=%s@@@ \n",\
	    (*t_combing).words_extracted);  */
	 return;
      }/*if( stp == NULL && *i_parenth == -1 ){*/
      if( stp != NULL && *i_quote == -1 ){
	 /* continue the words_extracted ..." */
//	 printf("call ELIM_B 2 \n");
         stp2=stp;
	 WORDS_BETW_QUOTES(fp_log, s,s, stp,t_combing);
/*	 printf("EXTRACT_BETW_QUOTES level 1 w_ext=%s@@@ \n",\
	    (*t_combing).words_extracted);*/
/* 
 *    add the words extracted into the structure    
 */
	 ADD_T_SCOMBING(t_combing);
//	 words_extracted[0] = '\0';
	 
	 *i_quote = 1 ;
	 *((*t_combing).words_extracted)='\0';
            if( code == 1 ){
               stp= strstr(stp2+1,"<\"");
	       if(stp != NULL)++stp;
            }else{/* if(*i_quote == 1 && code == 1 )*/
               if( code == 2 ){
	          stp= strstr(stp2+1,"(\"");
	          if(stp != NULL)++stp;
               }/* if(*i_quote == 1 && code == 1 )*/
            }/* if(*i_quote == 1 && code == 1 )*/
      }/*if( stp == NULL && *i_parenth == -1 ){*/
/*
 *   At that level stp != NULL && *i_quote == 1,
 *   we know there is a beginning ".... and we must look 
 *   for it      
 */  
//      printf("enter 1 loop while stp=%s@@@@\n",stp);
  /*    stp1 = stp - 1;
      stp = stp1;
      printf("enter 2 loop while stp=%s@@@@\n",stp);*/
      while (stp != NULL){
	 stp1 = strchr(stp , '"'); /* look for beginning of "..... */
//	 printf("stp +1=%s@@@@ \n",stp+1);
	 if(stp1 != NULL){
	    *i_quote = -1; /* start quote */
	    *((*t_combing).words_extracted)='\0';
	     ELIM_BLANK(stp1);
	      stp2=NULL;
              if( code == 1 ){
	         stp2= strstr(stp1+1,"\">");
              }else{/* if(*i_quote == 1 && code == 1 )*/
                 if( code == 2 ){
	            stp2= strstr(stp1+1,"\")");
                 }/* if(*i_quote == 1 && code == 1 )*/
	      }/*if( code == 1 ){*/
	    if(stp2 != NULL){
//	       printf("Case 1 call ELIM_BETW_PARENTH \n");
//	       printf("call ELIM_B 3 \n");
	       WORDS_BETW_QUOTES(fp_log, s,stp1, stp2,t_combing);
//	       printf("after ELIM_BETW stp2=%s@@@ \n",stp2);
/*	       printf("EXTRACT_BETW_QUOTES level 2 w_ext=%s@@@ \n",\
	           (*t_combing).words_extracted);*/
//	       words_extracted[0] = '\0';
/*
 *    Store into the structure
 */
	       ADD_T_SCOMBING(t_combing);
	       *i_quote = 1 ;
	       *((*t_combing).words_extracted)='\0';
	       stp2 = strchr(stp1+1,'"'); /* necessary to recompute stp2*/
	       stp2=NULL;
               if( code == 1 ){
	          stp2= strstr(stp1+1,"\">");
               }else{/* if(*i_quote == 1 && code == 1 )*/
                  if( code == 2 ){
	             stp2= strstr(stp1+1,"\")");
                  }/* if(*i_quote == 1 && code == 1 )*/
	       }/*if( code == 1 ){*/
	       if(stp2 == NULL){
                 fprintf(fp_log,"sub EXTRACT_BETW_SQUOTES Error 1 stop s=%s \n",s);
		 exit(1);
	       }/*if(stp2 == NULL){*/
	       stp = strstr(stp2+1,"<\"");
	    }else{/* if(stp2 != NULL){*/
	       /* here there is no ending to the ".....    */
	       stp2 = strchr(stp1,'\0');
//	       printf("call ELIM_B 4 \n");
	       WORDS_BETW_QUOTES(fp_log,s,stp1, stp2,t_combing);
/*	       printf("EXTRACT_BETW_QUOTES level 3 w_ext=%s@@@ \n",\
	           (*t_combing).words_extracted);*/
	       *i_quote = -1 ;
	       stp = NULL;
	    }/* if(stp2 != NULL){*/
	 }else{/*    if(stp1 != NULL){*/
	    stp = NULL;
	 }/*if(stp1 != NULL){*/
      }/*while (stp != NULL){*/
 /*     printf("end EXTRACT_BETW_SQUOTES words_ext=%s@@@ \n",\
		      (*t_combing).words_extracted);  */
      return;
}/* end of void  EXTRACT_BETW_SQUOTES   */
/********************************************************************/
void  EXTRACT_BETW_QUOTES(FILE *fp_log,int *i_quote,char s[],\
	 Trf_combing *t_combing)
   /*
    *   Extract the words which are between the quotes with the
    *   problem of the parenthesis ()  and the [] 
   *     into "word(xxx)" 
   * 
   *    for quotes "  "      already seen opening "  i_quote = -1 
   *                         already seen closing "  i_quote = 1
   *    i_quote is a toggle button we start with a "end quote"
   *    value ( 1 ) 
   */
{
   char *stp , *stp1, *stp2;
   int l;
//     printf("sub EXTRACT_BETW_QUOTES s=%s \n",s);
//     printf("i_parenth=%d \n",*i_parenth );
     stp = strchr(s,'"');
//     if(stp == NULL)printf("stp= NULL \n");
      if( stp == NULL && *i_quote == 1 ) return ;
      if( stp == NULL && *i_quote == -1 ){
	 /* extract words and grammatical values on the whole line */
	 stp2 = strchr(s,'\0');
//	 printf("call ELIM_B 1 \n")
	 WORDS_BETW_QUOTES(fp_log, s,s, stp2,t_combing);
/*	 printf("EXTRACT_BETW_QUOTES level 0 nwe=%d w_ext=%s@@@ \n",\
	 (*t_combing).len_words_extracted,(*t_combing).words_extracted);*/
	 return;
      }/*if( stp == NULL && *i_parenth == -1 ){*/
      if( stp != NULL && *i_quote == -1 ){
	 /* continue the words_extracted ..." */
//	 printf("call ELIM_B 2 \n");
         stp2=stp;
/*	 printf("EXTRACT_BETW_QUOTES level 0.9 nwe=%d w_ext=%s@@@ \n",\
	 (*t_combing).len_words_extracted,(*t_combing).words_extracted);*/
	 WORDS_BETW_QUOTES(fp_log, s,s, stp,t_combing);
/*	 printf("EXTRACT_BETW_QUOTES level 1 nwe=%d w_ext=%s@@@ \n",\
	 (*t_combing).len_words_extracted,(*t_combing).words_extracted);*/
	 l=strlen((*t_combing).words_extracted);
//	 printf("EXTRACT_BETW_QUOTES level 1 l=%d  \n",l);
	 
/* 
 *    add the words extracted into the structure    
 */
	 ADD_T_COMBING(t_combing);
//	 words_extracted[0] = '\0';
	 
	 *i_quote = 1 ;
	 *((*t_combing).words_extracted)='\0';
	 stp = strchr(stp2+1,'"');
      }/*if( stp == NULL && *i_parenth == -1 ){*/
/*
 *   At that level stp != NULL && *i_quote == 1,
 *   we know there is a beginning ".... and we must look 
 *   for it      
 */  
//      printf("enter 1 loop while stp=%s@@@@\n",stp);
  /*    stp1 = stp - 1;
      stp = stp1;
      printf("enter 2 loop while stp=%s@@@@\n",stp);*/
      while (stp != NULL){
	 stp1 = strchr(stp , '"'); /* look for beginning of "..... */
//	 printf("stp +1=%s@@@@ \n",stp+1);
	 if(stp1 != NULL){
	    *i_quote = -1; /* start quote */
	    *((*t_combing).words_extracted)='\0';
	     ELIM_BLANK(stp1);
	     stp2 = strchr(stp1+1 , '"'); /* look for end of "....." */
	    if(stp2 != NULL){
	       /* eliminate parenthesis on the ...." */
//	       printf("Case 1 call ELIM_BETW_PARENTH \n");
//	       printf("call ELIM_B 3 \n");
	       WORDS_BETW_QUOTES(fp_log, s,stp1,stp2,t_combing);
//	       printf("after ELIM_BETW stp2=%s@@@ \n",stp2);
/*	       printf("EXTRACT_BETW_QUOTES level 2 w_ext=%s@@@ \n",\
	           (*t_combing).words_extracted);*/
//	       words_extracted[0] = '\0';
/*
 *    Store into the structure
 */
	       ADD_T_COMBING(t_combing);
	       *i_quote = 1 ;
	       *((*t_combing).words_extracted)='\0';
	       stp2 = strchr(stp1+1,'"'); /* necessary to recompute stp2*/
	       stp = strchr(stp2+1,'"');
	    }else{/* if(stp2 != NULL){*/
	       /* here there is no ending to the ".....    */
	       stp2 = strchr(stp1,'\0');
//	       printf("call ELIM_B 4 \n");
	       WORDS_BETW_QUOTES(fp_log,s,stp1,stp2,t_combing);
/*	       printf("EXTRACT_BETW_QUOTES level 3 w_ext=%s@@@ \n",\
	           (*t_combing).words_extracted);*/
	       *i_quote = -1 ;
	       stp = NULL;
	    }/* if(stp2 != NULL){*/
	 }else{/*    if(stp1 != NULL){*/
	    stp = NULL;
	 }/*if(stp1 != NULL){*/
      }/*while (stp != NULL){*/
  //  printf("end EXTRACT_BETW_QUOTES words_ext=%s@@@ \n",(*t_combing).words_extracted);
      return;
}/* end of void  EXTRACT_BETW_QUOTES   */
/********************************************************************/
void  ADD_T_COMBING(Trf_combing *t_combing)
/*
 *   Aim of this subroutine is to separate the words and the grammar
 *   identification into the structure t_combing
 *
 *  typedef struct _Trf_combing {  used to comb dictionaries  
 *     int len_words_add ; length of string st_words_add 
 *     int len_gramm_add ; length of string st_gramm_add for grammar adds
 *     char *st_words_add;
 *     char *st_gramm_add;
 *  }Trf_combing;* struct used to transfer strings of additional words **
 *
 */
{/*  enter ADD_T_COMBING*/
   char *stp,c;
   int l,lw,lg,nw,ng,i,i1,j,k;
   int nbg,jj,wd,clean;

/*   printf("ADD_T_COMBING enter words_extracted=%s@@@ \n",\
	  (*t_combing).words_extracted);*/
/*
 *    Remove [.....]
 */
   l=strlen((*t_combing).words_extracted);
   if(l <= 0 ) return;
/*   printf("ADD_T_COMBING enter st_words_add=%s@@@ \n",\
			 (*t_combing).st_words_add);
   printf("ADD_T_COMBING enter st_gramm_add=%s@@@ \n",\
			 (*t_combing).st_gramm_add);*/
/*
 * First of all remove the [...] into words_extracted
 */
   stp = strchr((*t_combing).words_extracted,'[');
   i1=0;
   while(stp != NULL){
      ++i1;
      i=0;
      while(*(stp+i) != ']' && *(stp+i) != '\0'){
	 *(stp+i) = ' ';
	 ++i;
      }/*while(*(stp+i) != ']' && *(stp+i) != '\0'){ */
      if( *(stp+i) == ']') *(stp+i) = ' ';
      j=stp+i-(*t_combing).words_extracted;
      stp=NULL;
      if(j < l) stp = strchr(((*t_combing).words_extracted+j),'[');
   }/* while(stp != NULL){*/
   if(i1 > 0){
      RM_EXTRA_BLANCS((*t_combing).words_extracted);
      l=strlen((*t_combing).words_extracted);
   }/*if(i1 > 0){*/
/*   printf("ADD_T_COMBING enter words_extracted=%s@@@ \n",\
	  (*t_combing).words_extracted);*/
/*
 * End of removing the [...] into words_extracted
 */
    lw= (*t_combing).len_words_add;
    lg= (*t_combing).len_gramm_add;
    nw=strlen((*t_combing).st_words_add);
    ng=strlen((*t_combing).st_gramm_add);
//    printf("nw=%d ng=%d \n",nw,ng);
/*
 * Adjustment of the string lengths is only good most of the time
 * but not always
 */
    if(nw+l >= lw){
      (*t_combing).st_words_add= g_realloc((*t_combing).st_words_add,\
	(nw+l+21)*sizeof(char));
      lw=nw+l+20;
      (*t_combing).len_words_add=lw;
    }/* if(nw+l >= lw){*/
    if(ng+l >= lg){
      (*t_combing).st_gramm_add= g_realloc((*t_combing).st_gramm_add,\
	(ng+l+21)*sizeof(char));
      lg=ng+l+20;
      (*t_combing).len_gramm_add=lg;
    }/* if(ng+l >= lg){*/
/*    printf("ADD_T_COMBING level 1 \n");
    fflush(stdout);*/
    i=0;
    j=nw;/* for words*/
    jj=ng;/* for grammar*/
    while (i < l){
/*
 * Remove the blancs and (xx) (yy) before next word and also the , ;
 * but don't remove the .
 */ 
       clean=0;
       while( clean == 0){
          while(*((*t_combing).words_extracted+i) == ' ' && i < l)++i;
	  clean =  1;
          if(*((*t_combing).words_extracted+i) == '('){
	     clean =  0;
	     ++i;
	     while(i < l && *((*t_combing).words_extracted+i) != ')')++i;
	     ++i;
          }/*if(words_extracted[i] == '('){*/
       }/* while( clean == 0){*/
       c=*((*t_combing).words_extracted+i);
       while(i < l && !(SPE_ALPHA_NUM(c)) ){
	  ++i;
          c=*((*t_combing).words_extracted+i);
       }/*while(i < l && !(SPE_ALPHA_NUM(c)) ){*/
/*
 *  End of remove
 */
       wd=0;/* next word */
       i1=i; /*  mdf 25-1-2006  */
/*       printf("ADD_T_COMBING level 2 j=%d i=%d \n",j,i);*/
     /*  *((*t_combing).st_words_add + j) = '\0';
          printf("ADD_T_COMBING level2.1 j=%d st_words_add=%s@@@ \n",\
			 j, (*t_combing).st_words_add);*/
       fflush(stdout);
       c=*((*t_combing).words_extracted+i);
       while(i < l && (SPE_ALPHA_NUM(c) ||  c == ' ')){
          if(j >= lw){
	    lw=lw+20;
            (*t_combing).st_words_add=\
	    g_realloc((*t_combing).st_words_add,(lw+1)*sizeof(char));
            (*t_combing).len_words_add=lw;
          }/* if(nw+l >= lw){*/
          *((*t_combing).st_words_add + j) = (*t_combing).words_extracted[i];
	  ++i;
          c=*((*t_combing).words_extracted+i);
	  ++j;
	  ++wd;
       }/*while(SPE_ALPH_NUM(words_extracted[i]) || */
   /*       *((*t_combing).st_words_add + j) = '\0';
          printf("ADD_T_COMBING level2.2 j=%d st_words_add=%s@@@ \n",\
			 j, (*t_combing).st_words_add); */
/*
 *   If no word was added, we can go out
 */
       if(wd == 0){
          if(j >= lw){
	    lw=lw+20;
            (*t_combing).st_words_add=\
	    g_realloc((*t_combing).st_words_add,(lw+1)*sizeof(char));
            (*t_combing).len_words_add=lw;
          }/* if(nw+l >= lw){*/
          *((*t_combing).st_words_add + j) = '\0';
          if(jj >= lg){
            lg=lg+20;
            (*t_combing).st_gramm_add=\
            g_realloc((*t_combing).st_gramm_add,(lg+1)*sizeof(char));
            (*t_combing).len_gramm_add=lg;
          }/* if(nw+l >= lw){*/
          *((*t_combing).st_gramm_add + jj) = '\0';
/*        printf("ADD_T_COMBING output st_words_add=%s@@@ \n",\
			  (*t_combing).st_words_add);
          printf("ADD_T_COMBING output st_gramm_add=%s@@@ \n",\
			  (*t_combing).st_gramm_add);  */
	  return;
       }/*if(wd == 0){*/
 /*      printf("ADD_T_COMBING level 3 i=%d l=%d \n",i,l);
       fflush(stdout);*/
/*
 *   End of : If no word was added, we can go out
 */
/*
 *  Terminate the word
 */  
       if(j+1 >= lw){
         lw=lw+20;
         (*t_combing).st_words_add=\
         g_realloc((*t_combing).st_words_add,(lw+1)*sizeof(char));
         (*t_combing).len_words_add=lw;
       }/* if(nw+l >= lw){*/
       /*   mdf 25-1-2006   */
       if(j >= 1 && *((*t_combing).st_words_add + j-1) != ' '){
          *((*t_combing).st_words_add + j) = ' ';
	  ++j;
       }/*if(*((*t_combing).st_words_add + j) != ' '){*/
       *((*t_combing).st_words_add + j) = '\"';
       ++j;
       *((*t_combing).st_words_add + j) = '\0';
  /*      printf("ADD_T_COMBING level3.1 j=%d st_words_add=%s@@@ \n",\
			 j, (*t_combing).st_words_add);   */
/*
 *  End terminate the word
 */  
//       i1=i;
          *((*t_combing).st_gramm_add + jj) = '\0';
/*        printf("ADD_T_COMBING level3.1 jj=%d st_gramm_add=%s@@@ \n",\
			 jj, (*t_combing).st_gramm_add);  */
       nbg=0;
       k=i1;
       c= *((*t_combing).words_extracted+k);
       while( k < l && c != '(' && c != ';'){
	  ++k;
          c= *((*t_combing).words_extracted+k);
       }/*while( k < l && c != '(' && c != ';'){*/
       if(k == l || c == ';'){
/*	  printf("ADD_T_COMBING grammar add (x) \n");
	  fflush(stdout);*/
	  strcat(((*t_combing).st_gramm_add + jj),"(x) ");
	  jj=jj+4;
       }else{/*if(k == l){*/
/*	  printf("ADD_T_COMBING  grammar add something \n");
	  fflush(stdout);*/
/*
 *  at that level we extract the grammatical definitions (xx) (yy)
 *  we may have more than one !
 */  
          c= *((*t_combing).words_extracted+k);
          while(k <l && ( c== '(' || c == ')' || c == ' ' || c == '.' ||\
		SPE_ALPHA_NUM(c))){
             if(jj+1 >= lg){
	       lg=lg+20;
               (*t_combing).st_gramm_add=\
	       g_realloc((*t_combing).st_gramm_add,(lg+1)*sizeof(char));
               (*t_combing).len_gramm_add=lg;
             }/* if(nw+l >= lw){*/
             *((*t_combing).st_gramm_add + jj) = c ;
	     if(c == ')'){
		++jj;
                *((*t_combing).st_gramm_add + jj) = ' ' ;
	     }/*if(c == ')'){*/
	     ++k;
	     ++jj;
             c= *((*t_combing).words_extracted+k);
	  }/* end while */
       }/*if(k == l){*/
/*
 *  Terminate the grammar of the word
 */  
       if(jj >= lg){
         lg=lg+20;
         (*t_combing).st_gramm_add=\
         g_realloc((*t_combing).st_gramm_add,(lg+1)*sizeof(char));
         (*t_combing).len_gramm_add=lg;
       }/* if(nw+l >= lw){*/
       *((*t_combing).st_gramm_add + jj) = '\"';
       ++jj;
       *((*t_combing).st_gramm_add + jj) = '\0';
/*          printf("ADD_T_COMBING level3.2 jj=%d st_gramm_add=%s@@@ \n",\
			 jj, (*t_combing).st_gramm_add);*/
/*
 *  End terminate the grammar of the word
 */  
    }/*while (i <= l){*/
       *((*t_combing).st_gramm_add + jj) = '\0';
       *((*t_combing).st_words_add + j) = '\0';
/*          printf("ADD_T_COMBING output2 st_words_add=%s@@@ \n",\
			  (*t_combing).st_words_add);
          printf("ADD_T_COMBING output2 st_gramm_add=%s@@@ \n",\
			  (*t_combing).st_gramm_add);*/
}/*  end of ADD_T_COMBING*/
/********************************************************************/
void  ADD_T_SCOMBING(Trf_combing *t_combing)
/*
 *   Aim of this subroutine is to separate the words and the grammar
 *   identification into the structure t_combing
 *
 *  typedef struct _Trf_combing {  used to comb dictionaries  
 *     int len_words_add ; length of string st_words_add 
 *     int len_gramm_add ; length of string st_gramm_add for grammar adds
 *     char *st_words_add;
 *     char *st_gramm_add;
 *  }Trf_combing;* struct used to transfer strings of additional words **
 *
 */
{/*  enter ADD_T_COMBING*/
   char *stp,c;
   int l,lw,lg,nw,ng,i,i1,j,k;
   int nbg,jj,wd,clean;

/*   printf("ADD_T_SCOMBING enter words_extracted=%s@@@ \n",\
	  (*t_combing).words_extracted);*/
   l=strlen((*t_combing).words_extracted);
   if(l <= 0 ) return;
/*   printf("ADD_T_COMBING enter st_words_add=%s@@@ \n",\
			 (*t_combing).st_words_add);
   printf("ADD_T_COMBING enter st_gramm_add=%s@@@ \n",\
			 (*t_combing).st_gramm_add);*/
/*
 * First of all remove the [...] into words_extracted
 */
   stp = strchr((*t_combing).words_extracted,'[');
   i1=0;
   while(stp != NULL){
      ++i1;
      i=0;
      while(*(stp+i) != ']' && *(stp+i) != '\0'){
	 *(stp+i) = ' ';
	 ++i;
      }/*while(*(stp+i) != ']' && *(stp+i) != '\0'){ */
      if( *(stp+i) == ']') *(stp+i) = ' ';
      j=stp+i-(*t_combing).words_extracted;
      stp=NULL;
      if(j < l) stp = strchr(((*t_combing).words_extracted+j),'[');
   }/* while(stp != NULL){*/
   if(i1 > 0){
      RM_EXTRA_BLANCS((*t_combing).words_extracted);
      l=strlen((*t_combing).words_extracted);
   }/*if(i1 > 0){*/
/*   printf("ADD_T_SCOMBING enter words_extracted=%s@@@ \n",\
	  (*t_combing).words_extracted);*/
/*
 * End of removing the [...] into words_extracted
 */
    lw= (*t_combing).len_words_add;
    lg= (*t_combing).len_gramm_add;
    nw=strlen((*t_combing).st_words_add);
    ng=strlen((*t_combing).st_gramm_add);
//    printf("nw=%d ng=%d \n",nw,ng);
/*
 * Adjustment of the string lengths is only good most of the time
 * but not always
 */
    if(nw+l >= lw){
      (*t_combing).st_words_add= g_realloc((*t_combing).st_words_add,\
	(nw+l+21)*sizeof(char));
      lw=nw+l+20;
      (*t_combing).len_words_add=lw;
    }/* if(nw+l >= lw){*/
    if(ng+l >= lg){
      (*t_combing).st_gramm_add= g_realloc((*t_combing).st_gramm_add,\
	(ng+l+21)*sizeof(char));
      lg=ng+l+20;
      (*t_combing).len_gramm_add=lg;
    }/* if(ng+l >= lg){*/
/*    printf("ADD_T_COMBING level 1 \n");
    fflush(stdout);*/
    i=0;
    j=nw;/* for words*/
    jj=ng;/* for grammar*/
    while (i < l){
/*
 * Remove the blancs and (xx) (yy) before next word and also the , ;
 * but don't remove the .
 */ 
       clean=0;
       while( clean == 0){
          c= *((*t_combing).words_extracted+i);
          while(c == ' ' && i < l){
	     ++i;
             c= *((*t_combing).words_extracted+i);
	  }/*while(c == ' ' && i < l){*/
	  clean =  1;
          if(c == '('){
	     clean =  0;
	     ++i;
             c= *((*t_combing).words_extracted+i);
	     while(i < l && c != ')'){
		++i;
                c= *((*t_combing).words_extracted+i);
	     }/*while(i < l && c != ')'){*/
	     ++i;
          }/*if(words_extracted[i] == '('){*/
       }/* while( clean == 0){*/
       c= *((*t_combing).words_extracted+i);
       while(i < l && !(SPE_ALPHA_NUM(c)) &&  c != '.' ){
	  ++i;
          c= *((*t_combing).words_extracted+i);
       }/*while(i < l && !(SPE_ALPHA_NUM(c)) &&  c != '.' ){*/
/*
 *  End of remove
 */
       wd=0;/* next word */
       i1=i; /*  mdf 25-1-2006  */
/*       printf("ADD_T_COMBING level 2 j=%d i=%d \n",j,i);*/
     /*  *((*t_combing).st_words_add + j) = '\0';
          printf("ADD_T_COMBING level2.1 j=%d st_words_add=%s@@@ \n",\
			 j, (*t_combing).st_words_add);*/
//       fflush(stdout);
/* 
 * Here we accept a first point
 */
       if(i < l && (SPE_ALPHA_NUM(c) || \
          c == ' ' || c == '.' )){
          if(j >= lw){
	    lw=lw+20;
            (*t_combing).st_words_add=\
	    g_realloc((*t_combing).st_words_add,(lw+1)*sizeof(char));
            (*t_combing).len_words_add=lw;
          }/* if(nw+l >= lw){*/
          *((*t_combing).st_words_add + j) = c;
	  ++i;
          c= *((*t_combing).words_extracted+i);
	  ++j;
	  ++wd;
       }/*if(SPE_ALPH_NUM(words_extracted[i]) || */
       while(i < l && (SPE_ALPHA_NUM(c) || \
		       c == ' ')){
          if(j >= lw){
	    lw=lw+20;
            (*t_combing).st_words_add=\
	    g_realloc((*t_combing).st_words_add,(lw+1)*sizeof(char));
            (*t_combing).len_words_add=lw;
          }/* if(nw+l >= lw){*/
          *((*t_combing).st_words_add + j) = c;
	  ++i;
          c= *((*t_combing).words_extracted+i);
	  ++j;
	  ++wd;
       }/*while(SPE_ALPH_NUM(words_extracted[i]) || */
   /*       *((*t_combing).st_words_add + j) = '\0';
          printf("ADD_T_COMBING level2.2 j=%d st_words_add=%s@@@ \n",\
			 j, (*t_combing).st_words_add); */
/*
 *   If no word was added, we can go out
 */
       if(wd == 0){
          if(j >= lw){
	    lw=lw+20;
            (*t_combing).st_words_add=\
	    g_realloc((*t_combing).st_words_add,(lw+1)*sizeof(char));
            (*t_combing).len_words_add=lw;
          }/* if(nw+l >= lw){*/
          *((*t_combing).st_words_add + j) = '\0';
       if(jj >= lg){
         lg=lg+20;
         (*t_combing).st_gramm_add=\
         g_realloc((*t_combing).st_gramm_add,(lg+1)*sizeof(char));
         (*t_combing).len_gramm_add=lg;
       }/* if(nw+l >= lw){*/
       *((*t_combing).st_gramm_add + jj) = '\0';
/*        printf("ADD_T_COMBING output st_words_add=%s@@@ \n",\
			  (*t_combing).st_words_add);
          printf("ADD_T_COMBING output st_gramm_add=%s@@@ \n",\
			  (*t_combing).st_gramm_add);*/
	  return;
       }/*if(wd == 0){*/
 /*      printf("ADD_T_COMBING level 3 i=%d l=%d \n",i,l);
       fflush(stdout);*/
/*
 *   End of : If no word was added, we can go out
 */
/*
 *  Terminate the word
 */  
       if(j >= lw){
         lw=lw+20;
         (*t_combing).st_words_add=\
         g_realloc((*t_combing).st_words_add,(lw+1)*sizeof(char));
         (*t_combing).len_words_add=lw;
       }/* if(nw+l >= lw){*/
       *((*t_combing).st_words_add + j) = '\"';
       ++j;
/*       *((*t_combing).st_words_add + j) = '\0';
          printf("ADD_T_COMBING level3.1 j=%d st_words_add=%s@@@ \n",\
			 j, (*t_combing).st_words_add);*/
/*
 *  End terminate the word
 */  
       i1=i;
       nbg=0;
       k=i1;
       c= *((*t_combing).words_extracted+k);
       while( k < l && c != '(' && c != ';'){
	  ++k;
          c= *((*t_combing).words_extracted+k);
       }/*while( k < l && c != '(' && c != ';'){*/
       if(k == l || c == ';'){
	  strcat(((*t_combing).st_gramm_add + jj),"(x) ");
	  jj=jj+4;
       }else{/*if(k == l){*/
/*
 *  at that level we extract the grammatical definitions (xx) (yy)
 *  we may have more than one !
 */  
          c= *((*t_combing).words_extracted+k);
          while(k <l && ( c== '(' || c == ')' || c == ' ' || c == '.' ||\
		SPE_ALPHA_NUM(c))){
             if(jj+1 >= lg){
	       lg=lg+20;
               (*t_combing).st_gramm_add=\
	       g_realloc((*t_combing).st_gramm_add,(lg+1)*sizeof(char));
               (*t_combing).len_gramm_add=lg;
             }/* if(nw+l >= lw){*/
             *((*t_combing).st_gramm_add + jj) = c ;
	     if(c == ')'){
		++jj;
                *((*t_combing).st_gramm_add + jj) = ' ' ;
	     }/*if(c == ')'){*/
	     ++k;
	     ++jj;
             c= *((*t_combing).words_extracted+k);
	  }/* end while */
       }/*if(k == l){*/
/*
 *  Terminate the grammar of the word
 */  
       if(jj >= lg){
         lg=lg+20;
         (*t_combing).st_gramm_add=\
         g_realloc((*t_combing).st_gramm_add,(lg+1)*sizeof(char));
         (*t_combing).len_gramm_add=lg;
       }/* if(nw+l >= lw){*/
       *((*t_combing).st_gramm_add + jj) = '\"';
       ++jj;
/*
 *  End terminate the grammar of the word
 */  
    }/*while (i <= l){*/
       *((*t_combing).st_gramm_add + jj) = '\0';
       *((*t_combing).st_words_add + j) = '\0';
/*        printf("ADD_T_COMBING output2 st_words_add=%s@@@ \n",\
			  (*t_combing).st_words_add);
          printf("ADD_T_COMBING output2 st_gramm_add=%s@@@ \n",\
			  (*t_combing).st_gramm_add);*/
}/*  end of ADD_T_COMBING*/
/********************************************************************/
void  CONDENS_T_COMBING(FILE *fp_log,Trf_combing *t_combing)
/*
 * Make a condensation of the character strings 
 * in the structure t_combing
 * Example :
ADD_T_COMBING output st_words_add=komz "komz "komzet "komz "@@@ 
ADD_T_COMBING output st_gramm_add=(v) (pgv) (aw) "(v) "(agv) "(pgv) "@@@

ADD_T_COMBING output st_words_add=prest "prest "prest "prest "presto "prest "presto "prest "@@@ 
ADD_T_COMBING output st_gramm_add=(agn) (rkv) (ag) (ag) (pgv) "(agn) "(rkv) "(ag) "(agl) "(ag) "(agl) "(pgv) "@@@ 
 * 
 *
 */
{/*  beginning of CONDENS_T_COMBING*/
 int lw,lg,i,j,k;
 int ident,i1,j1,j2,ideb,jdeb;
 int ipar,iknown ;
 char *stp,*stp1,*stp2,s_work[50];
/*   printf("CONDENS_T_COMBING enter st_words_add=%s@@@ \n",\
			 (*t_combing).st_words_add);
   printf("CONDENS_T_COMBING enter st_gramm_add=%s@@@ \n",\
			 (*t_combing).st_gramm_add);*/
   lw=strlen((*t_combing).st_words_add);
   if(lw <= 0) return;
   lg=strlen((*t_combing).st_gramm_add);
/*
 * Remove last "
 */
   i=lw-1;
   while(*((*t_combing).st_words_add +i) == ' ')--i;
   if(*((*t_combing).st_words_add + i) == '\"'){
      *((*t_combing).st_words_add + i) = ' ';
   }/*if(*((*t_combing).st_words_add + lw -1) == '\"'){*/
   i=lg-1;
   while(*((*t_combing).st_gramm_add +i) == ' ')--i;
   if(*((*t_combing).st_gramm_add + i) == '\"'){
      *((*t_combing).st_gramm_add + i) = ' ';
   }/*if(*((*t_combing).st_words_add + lw -1) == '\"'){*/
   RM_EXTRA_BLANCS((*t_combing).st_words_add);
   RM_EXTRA_BLANCS((*t_combing).st_gramm_add);
   lw=strlen((*t_combing).st_words_add);
   lg=strlen((*t_combing).st_gramm_add);
/*
 * End of Remove last "
 */
   i=0;
   i1=0;
   stp = strchr(((*t_combing).st_words_add + i),'\"');
   ideb=0;
   if(stp != NULL) ideb = stp-(*t_combing).st_words_add;
   stp1 = strchr(((*t_combing).st_gramm_add + i),'\"');
   jdeb=0;
   if(stp1 != NULL) jdeb = stp1 -(*t_combing).st_gramm_add;
   while(stp != NULL && stp1 != NULL){/* loop on all the found words*/
     j=stp-(*t_combing).st_words_add;
     i=j+1;
     k=0;
     while(k < lw && *((*t_combing).st_words_add + k) == ' ')++k;
     while(i < lw && *((*t_combing).st_words_add + i) == ' ')++i;
     ident= 1; /*  comparison to nominal word  */
     while(ident == 1 && i < lw && *((*t_combing).st_words_add + i) != '\"'){
       if( *((*t_combing).st_words_add + k) != \
                *((*t_combing).st_words_add + i) )ident=0; 
       ++i;
       ++k;
     }/*while(i < lw && *((*t_combing).st_words_add + i) != '\"'){*/
//     printf("CONDENS stp=%s@@@@ ident=%d \n",stp,ident);
     if(ident == 1){/* Perhaps remove word if grammar is known */
	if(stp1 == NULL){
	   printf("CONDENS_T_COMBING error 1 stop \n");
	   fprintf(fp_log,"CONDENS_T_COMBING error 1 stop \n");
	   exit(1);
	}/*if(stp1 == NULL){*/
        i1=stp1-(*t_combing).st_gramm_add;
	j1=i1+1;
	ipar=1;
	iknown=1;
	while(ipar == 1 && iknown == 1 ){
	   while ( j1 < lg && *((*t_combing).st_gramm_add+j1) != '(' &&\
			*((*t_combing).st_gramm_add+j1) != '\"')++j1;
	   ipar=0;
	   if(*((*t_combing).st_gramm_add+j1) == '(')ipar=1;
	   if(ipar == 0) continue;
	   j2=0;
	   while ( j1 < lg &&\
	   *((*t_combing).st_gramm_add+j1) != ')' &&\
			*((*t_combing).st_gramm_add+j1) != '\"'){
              s_work[j2]= *((*t_combing).st_gramm_add+j1);
	      ++j1;
	      ++j2;
	   }/* while ( ipar == 1 && j1 < lg &&\ ...*/
	   if( *((*t_combing).st_gramm_add+j1) != ')'){
	      printf("CONDENS_T_COMBING error 2 stop \n");
	      fprintf(fp_log,"CONDENS_T_COMBING error 2 stop \n");
	      exit(2);
	   }/*if(stp1 == NULL){*/
	   ++j1;
	   s_work[j2] = ')';
	   ++j2;
	   s_work[j2] = '\0';
//	   printf("CONDENS s_work=%s@@@ \n",s_work);
           stp2 = strstr((*t_combing).st_gramm_add ,s_work);
	   j2=lg+1;
	   if(stp2 != NULL)j2=stp2-(*t_combing).st_gramm_add;
	   if(j2 > jdeb)iknown=0;
	}/*while(ipar == 1 && iknown == 1 ){*/
//     printf("CONDENS stp1=%s@@@@ iknown=%d \n",stp1,iknown);
          i=j+1;
	if(iknown == 1){/*   remove word  */
	   j2=i;
           *((*t_combing).st_words_add+j) = ' ';
	   while ( j2 < lw  &&\
			*((*t_combing).st_words_add+j2) != '\"'){
             *((*t_combing).st_words_add+j2) = ' ';
	     ++j2;
	   }/*while ( j2 < lg  &&\*/
	   j2=i1;
           *((*t_combing).st_gramm_add+j2) = ' ';
	   while ( j2 < lg  &&\
			*((*t_combing).st_gramm_add+j2) != '\"'){
             *((*t_combing).st_gramm_add+j2) = ' ';
	     ++j2;
	   }/*while ( j2 < lg  &&\*/
	}/*if(iknown == 1){   */
     }/*if(ident == 1){ Perhaps remove word */
     i= stp - (*t_combing).st_words_add +1 ;
     stp = NULL;
     if(i < lw) stp = strchr(((*t_combing).st_words_add + i),'\"');
     i1= stp1 - (*t_combing).st_gramm_add +1 ;
     stp1 = NULL;
     if(i1 < lg)stp1 = strchr(((*t_combing).st_gramm_add + i1),'\"');
/*     printf("CONDENS_T_COMBING loop stp st_words_add=%s@@@ \n",\
			 (*t_combing).st_words_add);
     printf("CONDENS_T_COMBING loop stp st_gramm_add=%s@@@ \n",\
			 (*t_combing).st_gramm_add);*/
   }/*while(stp != NULL){*/
   RM_EXTRA_BLANCS((*t_combing).st_words_add);
   RM_EXTRA_BLANCS((*t_combing).st_gramm_add);
/*   printf("CONDENS_T_COMBING exit st_words_add=%s@@@ \n",\
			 (*t_combing).st_words_add);
   printf("CONDENS_T_COMBING exit st_gramm_add=%s@@@ \n",\
			 (*t_combing).st_gramm_add);*/
   CONDENS1_T_COMBING(fp_log,t_combing);
}/*  end of CONDENS_T_COMBING*/
/********************************************************************/
void  CONDENS1_T_COMBING(FILE *fp_log,Trf_combing *t_combing)
/*
 * Make a condensation of the character strings 
 * in the structure t_combing . However it is limited to the non
 * nominal words ( so it begins to the third word )
 * Example :
ADD_T_COMBING output st_words_add=komz "komz "komzet "komz "@@@ 
ADD_T_COMBING output st_gramm_add=(v) (pgv) (aw) "(v) "(agv) "(pgv) "@@@

ADD_T_COMBING output st_words_add=prest "presto "presto @@@ 
ADD_T_COMBING output st_gramm_add=(agn) (rkv) (ag) (ag) (pgv) "(agl) "(agl) "@@@ 
 * 
 *
 */
{/*  beginning of CONDENS1_T_COMBING*/
 int lw,lg,i,k;
 int ident,i1,j1,j2,ideb,jdeb,ideb_w,jdeb_g,ideb_w1,jdeb_g1;
 int jdeb_g2;
 int ipar,iknown,ii1,ii2 ;
 char *stp,*stp1,*stp2,s_work[50];
/*   printf("CONDENS1_T_COMBING enter st_words_add=%s@@@ \n",\
			 (*t_combing).st_words_add);
   printf("CONDENS1_T_COMBING enter st_gramm_add=%s@@@ \n",\
			 (*t_combing).st_gramm_add);*/
   lw=strlen((*t_combing).st_words_add);
   if(lw <= 0) return;
   lg=strlen((*t_combing).st_gramm_add);
   if(lg <= 0) return;
/*
 * Compute ideb jdeb start of the second word
 */
   i=0;
   i1=0;
   stp = strchr(((*t_combing).st_words_add + i),'\"');
   ideb=0;
   if(stp != NULL) ideb = stp-(*t_combing).st_words_add;
   stp1 = strchr(((*t_combing).st_gramm_add + i1),'\"');
   jdeb=0;
   if(stp1 != NULL) jdeb = stp1 -(*t_combing).st_gramm_add;
   if(stp == NULL){
//       printf("CONDENS1 return 1 \n");
       return;
   }/*if(stp == NULL){*/
/*
 * Compute start of the third word
 */
   i=ideb+1;
   i1=jdeb+1;
   stp=NULL;
   if(i<lw) stp = strchr(((*t_combing).st_words_add + i),'\"');
   if(stp == NULL)return;
   stp1=NULL;
   if(i1 < lg) stp1 = strchr(((*t_combing).st_gramm_add + i1),'\"');
   if(stp1 == NULL)return;
/*
 */
   while(stp != NULL && stp1 != NULL){/* loop on all the words after 
                                          the second */
     ideb_w = stp-(*t_combing).st_words_add;/* start for current word*/
     jdeb_g = stp1 - (*t_combing).st_gramm_add;
     ideb_w1 = ideb;/*  start for preceeding words */
     jdeb_g1 = jdeb;
     while(ideb_w1 < ideb_w && jdeb_g1 < jdeb_g  ){/* loop 
	       on all the preceeding words  */
/*
 *    end of the preceeding word for the grammar
 */
	jdeb_g2=jdeb_g1+1;
	while(jdeb_g2 < lg && \
	     *((*t_combing).st_gramm_add + jdeb_g2) != '\"')++jdeb_g2;
/*	printf("CONDENS1 loop ideb_w=%d ideb_w1=%d jdeb_g=%d jdeb_g1=%d jdeb_g2=%d \n",\
	ideb_w,ideb_w1,jdeb_g,jdeb_g1,jdeb_g2);*/
/******/
        k=ideb_w1+1;
        while(k < lw && *((*t_combing).st_words_add + k) == ' ')++k;
        i=ideb_w+1;
        while(i < lw && *((*t_combing).st_words_add + i) == ' ')++i;
        ident= 1; /*  comparison to word kw */
        while(ident == 1 && i < lw && *((*t_combing).st_words_add + i) != '\"'){
          if( *((*t_combing).st_words_add + k) != \
                *((*t_combing).st_words_add + i) )ident=0; 
          ++i;
          ++k;
        }/*while(i < lw && *((*t_combing).st_words_add + i) != '\"'){*/
//      printf("CONDENS1 stp=%s@@@@ ident=%d \n",stp,ident);
        if(ident == 1){/* Remove word, easy if grammar is known */
	   j1=jdeb_g+1;
	   ipar=1;
	   iknown=1;
	   while(ipar == 1 && iknown == 1 ){
	      while ( j1 < lg && *((*t_combing).st_gramm_add+j1) != '(' &&\
			*((*t_combing).st_gramm_add+j1) != '\"')++j1;
	      ipar=0;
	      if(*((*t_combing).st_gramm_add+j1) == '(')ipar=1;
	      if(ipar == 0) continue;
	      /******not outside the loop can have more than one () *****/
	      ii1=j1;
	      j2=0;
	      while ( j1 < lg &&\
	         *((*t_combing).st_gramm_add+j1) != ')' &&\
			*((*t_combing).st_gramm_add+j1) != '\"'){
                 s_work[j2]= *((*t_combing).st_gramm_add+j1);
	         ++j1;
	         ++j2;
	      }/* while ( ipar == 1 && j1 < lg &&\ ...*/
	      if( *((*t_combing).st_gramm_add+j1) != ')'){
	         printf("CONDENS1_T_COMBING error 2 stop \n");
	         fprintf(fp_log,"CONDENS1_T_COMBING error 2 stop \n");
	         exit(2);
	      }/*if(stp1 == NULL){*/
	      ii2=j1;
	      ++j1;
	      s_work[j2] = ')';
	      ++j2;
	      s_work[j2] = '\0';
	      /***********/
//	      printf("CONDENS1 s_work=%s@@@ \n",s_work);
              stp2 = strstr(((*t_combing).st_gramm_add + jdeb_g1) ,s_work);
	      j2=lg+1;
	      if(stp2 != NULL)j2=stp2-(*t_combing).st_gramm_add;
	      if(j2 > jdeb_g2){
                 DEPLACE_GRAMM(&jdeb_g2,&jdeb_g,ii1, ii2,\
		  (*t_combing).st_gramm_add);
//		 iknown=0;
	      }/*if(j2 > jdeb_g2){*/
	   }/*while(ipar == 1 && iknown == 1 ){*/
//      printf("CONDENS1 stp1=%s@@@@ iknown=%d \n",stp1,iknown);
   	   if(iknown == 1){/*   remove word  */
	      j2=ideb_w;
              *((*t_combing).st_words_add+j2) = ' ';
	      ++j2;
	      while ( j2 < lw  &&\
			*((*t_combing).st_words_add+j2) != '\"'){
                *((*t_combing).st_words_add+j2) = ' ';
	        ++j2;
	      }/*while ( j2 < lg  &&\*/
	      j2=jdeb_g;
              *((*t_combing).st_gramm_add+j2) = ' ';
	      ++j2;
	      while ( j2 < lg  &&\
			*((*t_combing).st_gramm_add+j2) != '\"'){
                *((*t_combing).st_gramm_add+j2) = ' ';
	        ++j2;
	      }/*while ( j2 < lg  &&\*/
/*     printf("CONDENS1_T_COMBING iknown=1 st_words_add=%s@@@ \n",\
			 (*t_combing).st_words_add);
     printf("CONDENS1_T_COMBING iknown=1 st_gramm_add=%s@@@ \n",\
			 (*t_combing).st_gramm_add);*/
	   }/*if(iknown == 1){   */
        }/*if(ident == 1){ Perhaps remove word */
	++ideb_w1;
	while(ideb_w1 < lw && \
	     *((*t_combing).st_words_add + ideb_w1) != '\"')++ideb_w1;
	++jdeb_g1;
	while(jdeb_g1 < lg && \
	     *((*t_combing).st_gramm_add + jdeb_g1) != '\"')++jdeb_g1;
     }/*while(ideb_w1 < ideb_w  loop on all the preceeding words  */    
     i= stp - (*t_combing).st_words_add +1 ;
     stp = NULL;
     if(i < lw) stp = strchr(((*t_combing).st_words_add + i),'\"');
     i1= stp1 - (*t_combing).st_gramm_add +1 ;
     stp1 = NULL;
     if(i1 < lg)stp1 = strchr(((*t_combing).st_gramm_add + i1),'\"');
/*     printf("CONDENS1_T_COMBING loop stp st_words_add=%s@@@ \n",\
			 (*t_combing).st_words_add);
     printf("CONDENS1_T_COMBING loop stp st_gramm_add=%s@@@ \n",\
			 (*t_combing).st_gramm_add);*/
   }/*while(stp != NULL){*/
   RM_EXTRA_BLANCS((*t_combing).st_words_add);
   RM_EXTRA_BLANCS((*t_combing).st_gramm_add);
/*   printf("CONDENS1_T_COMBING exit st_words_add=%s@@@ \n",\
			 (*t_combing).st_words_add);
   printf("CONDENS1_T_COMBING exit st_gramm_add=%s@@@ \n",\
			 (*t_combing).st_gramm_add);*/
}/*  end of CONDENS1_T_COMBING*/
/********************************************************************/
void  DEPLACE_GRAMM(int *ideb_g2, int *ideb_g,int i1, int i2, char *s)
/*
 *   s = ...... ".............."..... (xx) ..........
 *              |              |      |  |
 *            ideb_g2       ideb_g    i1 i2
 *
 *      On veut obtenir :
 *      
 *   s = ...... (xx) ".............."..... ..........
 *                   |              | |  |
 *               ideb_g2       ideb_g i1 i2
 *
 */
{/*   enter DEPLACE_GRAMM    */
char ss[11];
int ierr,i,j,k;
int jdeb_g2,jdeb_g;
/*   printf("DEPLACE_GRAMM enter ideb_g2=%d ideb_g=%d i1=%d i2=%d \n",\
		   *ideb_g2,*ideb_g,i1,i2);
   printf("DEPLACE_GRAMM enter s=%s@@@ \n", s);*/
   jdeb_g2=*ideb_g2;
   jdeb_g=*ideb_g;
   ierr=0;
   if(i1 >= i2)++ierr;
   if(jdeb_g2 >= i1)++ierr;
   if(jdeb_g2 <= 0)++ierr;
   if(ierr != 0){
      printf("DEPLACE_GRAMM error 1 stop \n");
      exit(1);
   }/*if(ierr != 0){*/
   if(*(s+jdeb_g2-1) != ' ' )++ierr;
   if(*(s+i1-1) != ' ' && *(s+i1-1) != '\"')++ierr;
   if(*(s+i2+1) != ' ')++ierr;
   if(i2-i1+1 > 10)++ierr;
   if(ierr != 0){
      printf("DEPLACE_GRAMM error 2 stop \n");
      exit(2);
   }/*if(ierr != 0){*/
   i=i1;
   j=0;
   while(i <= i2){
      *(ss + j) = *(s+i);
      ++j;
      ++i;
   }/*while(i <= i2){*/
   k=j-1;
   i=i1-1;
   j=i2+1;
   while(i >= jdeb_g2){
      *(s + j) = *(s + i );
      --i;
      --j;
   }/*while(i >= jdeb_g2){*/
   i=jdeb_g2;
   j=0;
   for(j=0 ; j <= k ; ++j){
      *(s + i) = *(ss + j);
      ++i;
   }/*for(j=0 ; j <= k ; ++j){*/
   *(s + i) = ' ';
/*
 *    We have to adjust ideb_g2   and ideb_g
 * 
 */ 
   *ideb_g2 = jdeb_g2+i2-i1+2;
   *ideb_g = jdeb_g + i2-i1+2;
/* printf("DEPLACE_GRAMM output ideb_g2=%d ideb_g=%d s=%s@@@ \n",\
		   *ideb_g2,*ideb_g,s);*/
}/*   end of DEPLACE_GRAMM    */
/********************************************************************/
  void INIT_GRAMM( FILE *fp_log,char ss[],Trf_combing *t_combing )
/*
 * The line ss is a line of idx1_diconame. We want to extract
 * the grammatical information from this line
 */
{/*  begining of INIT_GRAMM  */
   int i,jj,lg,l;
   char *stp;
      lg= (*t_combing).len_gramm_add;
      l=strlen(ss);
 /*     printf("INIT_GRAMM ss=%s@@@ l=%d ss[l-2]=%c \n",ss,l,ss[l-2]);
      fflush(stdout);*/
      if(l <= 0){
	 printf("INIT_GRAMM error 1 stop \n");
	 fprintf(fp_log,"INIT_GRAMM error 1 stop \n");
	 exit(1);
      }/*if(l <= 0){*/
      stp=strchr(ss,'(');
//      printf("INIT_GRAMM stp=%s@@@ \n",stp);
//      fflush(stdout);
      if(stp == NULL){
         if(6 >= lg){
           lg=lg+20;
           (*t_combing).st_gramm_add=\
           g_realloc((*t_combing).st_gramm_add,(lg+1)*sizeof(char));
           (*t_combing).len_gramm_add=lg;
         }/* if(nw+l >= lw){*/
	 strcpy((*t_combing).st_gramm_add,"(x) \"");
	 return;
      }/*if(stp == NULL){*/
      jj=0;
      while(stp != NULL && *(stp) == '('){
	 i=stp-ss;
	 while(i < l && ss[i] != ')' && ss[i] != '-'){
             if(jj >= lg){
               lg=lg+20;
               (*t_combing).st_gramm_add=\
               g_realloc((*t_combing).st_gramm_add,(lg+1)*sizeof(char));
               (*t_combing).len_gramm_add=lg;
             }/* if(nw+l >= lw){*/
	    *((*t_combing).st_gramm_add + jj) = ss[i];
	    ++i;
	    ++jj;
	 }/*while(i < l && ss[i] != ')' && ss[i] != '-'){*/
         if(jj+1 >= lg){
           lg=lg+20;
           (*t_combing).st_gramm_add=\
           g_realloc((*t_combing).st_gramm_add,(lg+1)*sizeof(char));
           (*t_combing).len_gramm_add=lg;
         }/* if(nw+l >= lw){*/
	 *((*t_combing).st_gramm_add + jj) = ')';
	 ++jj;
	 *((*t_combing).st_gramm_add + jj) = ' ';
	 ++jj;
	 stp=NULL;
         if(i < l)stp=strchr((ss+i),'(');
//         printf("INIT_GRAMM stp=%s@@@ \n",stp);
//         fflush(stdout);
      }/* while(*(stp) == '('){*/
/*
 *  Terminate the grammar of the word
 */  
       if(jj+1 >= lg){
         lg=lg+20;
         (*t_combing).st_gramm_add=\
         g_realloc((*t_combing).st_gramm_add,(lg+1)*sizeof(char));
         (*t_combing).len_gramm_add=lg;
       }/* if(nw+l >= lw){*/
       *((*t_combing).st_gramm_add + jj) = '\"';
       ++jj;
       *((*t_combing).st_gramm_add + jj) = '\0';
/*
 *  End terminate the grammar of the word
 */  
/*   printf("INIT_GRAMM output st_gramm=%s@@@ \n",\
		   (*t_combing).st_gramm_add);
    fflush(stdout);*/
}/*  end of INIT_GRAMM  */
/********************************************************************/
void  WFILE_T_COMBING(FILE *fp_log,FILE *fp2,char s2[],\
		Trf_combing *t_combing, int *tnbw)
/*
 *    This subroutine writes on file fp2 an idx2 file
 *    s2 is the position of the word into the dictionary. This
 *    position is set as a character chain.
 *    tnwb is the total of numbers written.
 */
{/*enter WFILE_T_COMBING  */
int i,i1,j,k,l,l1,ln,ls,nb_par,nbw;
char *stp,*stp1,ss[101],s_par[10];
/*   printf("Enter WFILE_T_COMBING \n");
   fflush(stdout);*/
   fprintf(fp2,"%s \n",s2);
   nbw=0;
   i=0;
   i1=0;
   ln=strlen(s2);
   l = strlen((*t_combing).st_words_add );
   l1 = strlen((*t_combing).st_gramm_add );
   stp = strchr(((*t_combing).st_words_add + i),'\"');
   stp1 = strchr(((*t_combing).st_gramm_add + i1),'\"');
   if(stp == NULL ) return;
   while(stp != NULL){
      j=0;
      i=stp-(*t_combing).st_words_add + 1;
      while(i < l && *((*t_combing).st_words_add + i) != '\"' && j < 100){
	ss[j] = *((*t_combing).st_words_add + i);
	++i;
	++j;
      }/*while(i < l && *((*t_combing).st_words_add + i) != '\"'){*/
      if(j+3 >= 100 ) {
	 fprintf(fp_log,"ERROR 1 WFILE_T_COMBING \n");
	 return;
      }/*if(j+3 >= 100 ) {*/
      ss[j]='\0';
      if( j == 0 ){
	 stp = NULL;
	 continue;
      }/*if( j == 0 ){*/
      strcat(ss," * ");
 /*     printf("WFILE_T_COMBING level 1 ss=%s@@@ \n",ss);
      fflush(stdout);*/
      j=j+3;
      if(j+ln >= 100 ) {
	 printf("ERROR 2 WFILE_T_COMBING \n");
	 fprintf(fp_log,"ERROR 2 WFILE_T_COMBING \n");
	 return;
      }/*if(j+3 >= 100 ) {*/
      strcat(ss,s2);
      j=strlen(ss);
      i1=stp1-(*t_combing).st_gramm_add + 1;
/*
 *   we count the number of (
 */
      k=i1;
      nb_par= 0;
      while(k < l1 && *((*t_combing).st_gramm_add + k) != '\"'){
	if(*((*t_combing).st_gramm_add + k) == '(')++nb_par ;
	++k;
      }/*while(i < l && *((*t_combing).st_words_add + i) != '\"'){*/
      if(nb_par == 0 ) {
	 printf("ERROR 3 WFILE_T_COMBING \n");
	 fprintf(fp_log,"\n");
	 fprintf(fp_log,"ERROR 3 WFILE_T_COMBING no (..) in st_gramm\n");
	 fprintf(fp_log,"st_words=%s@@@ \n",(*t_combing).st_words_add);
	 fprintf(fp_log,"st_gramm=%s@@@ \n",(*t_combing).st_gramm_add);
	 return;
      }/*if(j+3 >= 100 ) {*/
      sprintf(s_par," %d ",nb_par);
      ls=strlen(s_par);
      if(j+ls >= 100 ) {
	 printf("ERROR 4 WFILE_T_COMBING \n");
	 fprintf(fp_log,"ERROR 4 WFILE_T_COMBING \n");
	 return;
      }/*if(j+3 >= 100 ) {*/
      strcat(ss,s_par);
      j=strlen(ss);
/*
 *  we add the grammatical identities
 */
      k=i1;
      while(k < l1 && *((*t_combing).st_gramm_add + k) != '(')++k;
      while(k < l1 && *((*t_combing).st_gramm_add + k) == '('){
         while(k < l1 && *((*t_combing).st_gramm_add + k) != ')'){
            ss[j]= *((*t_combing).st_gramm_add + k);
	    ++j;
	    ++k;
	    if(j >= 100){
	      printf("ERROR 5 WFILE_T_COMBING \n");
	      fprintf(fp_log,"ERROR 5 WFILE_T_COMBING \n");
	      return;
	    }/*if(j >= 100){*/
	 }/*while(k < l1 && *((*t_combing).st_gramm_add + k) != ')'){*/
	 ++k;
         while(k < l1 && *((*t_combing).st_gramm_add + k) == ' ')++k;
         if(j+4 >= 100 ) {
	    printf("ERROR 6 WFILE_T_COMBING \n");
	    fprintf(fp_log,"ERROR 6 WFILE_T_COMBING \n");
	    return;
         }/*if(j+3 >= 100 ) {*/
	 ss[j]='\0';
         strcat(ss,"-0) ");
         j=strlen(ss);
      }/* while(k < l1 && *((*t_combing).st_gramm_add + k) == '('){ */
      RM_EXTRA_BLANCS(ss);
      ++nbw;
      fprintf(fp2,"%s \n",ss);
      stp = NULL;
      if(i < l) stp = strchr(((*t_combing).st_words_add + i),'\"');
      ++i1;
      stp1 = NULL;
      if(i1 < l1) stp1 = strchr(((*t_combing).st_gramm_add + i1),'\"');
   }/*while(stp != NULL){*/
   i1 =  nbw + *tnbw ;
   *tnbw = i1;
}/*output WFILE_T_COMBING  */
/********************************************************************/
void  WFILE_T_SCOMBING(FILE *fp_log,FILE *fp2,char s2[],\
		Trf_combing *t_combing, int *tnbw)
/*
 *    This subroutine writes secondary words on file fp2 an idx2 file
 *    s2 is the position of the word into the dictionary. This
 *    position is set as a character chain.
 *    tnwb is the total of numbers written.
 *    The problem of capital letters <". Jeruzalem "> = Jeruzalem
 *                                   <" Jeruzalem "> = jerusalem
 *                                   <". Jezuz-Krist "> = Jezuz-Krist
 *                                   <" Jezuz-Krist "> = jezuz-Krist
 */
{/*enter WFILE_T_COMBING  */
int i,i1,j,k,l,l1,ln,ls,nb_par,nbw;
char *stp,*stp1,ss[101],s_par[10],c;
/*   printf("Enter WFILE_T_SCOMBING \n");
   fflush(stdout);   */
//   fprintf(fp2,"%s \n",s2);
   nbw=0;
   i=-1;
   i1=-1;
   ln=strlen(s2);
   l = strlen((*t_combing).st_words_add );
   l1 = strlen((*t_combing).st_gramm_add );
   if(l <= 0 || l1 <= 0 ) return;
/*
 *   for secondary words we must start from the beginning
 */
   stp = ((*t_combing).st_words_add + i);
   stp1 = ((*t_combing).st_gramm_add + i1);
   while(stp != NULL){
      j=0;
      i=stp-(*t_combing).st_words_add + 1;
/*
 *   added for the problem of capital letter as first character
 *   of a secondary word
 */
      while(i < l && *((*t_combing).st_words_add + i) == ' ')++i;
         c = *((*t_combing).st_words_add + i);
      if(c == '.'){
         *((*t_combing).st_words_add + i) = ' ';
         while(i < l && *((*t_combing).st_words_add + i) == ' ')++i;
      }else{/*if(*((*t_combing).st_words_add + i) == '.'){*/
         *((*t_combing).st_words_add + i) = tolower(c);
      }/*if(*((*t_combing).st_words_add + i) == '.'){*/
      while(i < l && *((*t_combing).st_words_add + i) != '\"' && j < 100){
	ss[j] = *((*t_combing).st_words_add + i);
	++i;
	++j;
      }/*while(i < l && *((*t_combing).st_words_add + i) != '\"'){*/
      if(j+3 >= 100 ) {
	 printf("ERROR 1 WFILE_T_SCOMBING \n");
	 fprintf(fp_log,"ERROR 1 WFILE_T_SCOMBING \n");
	 return;
      }/*if(j+3 >= 100 ) {*/
      ss[j]='\0';
//      printf("ss=%s@@@ \n",ss);
      if(j == 0 ){
	  stp = NULL;
	  continue;
      }/*if(j == 0 ){*/
      strcat(ss," ** ");
/*      printf("WFILE_T_SCOMBING level 1 ss=%s@@@ \n",ss);
      fflush(stdout);*/
      j=j+4;
      if(j+ln >= 100 ) {
	 printf("ERROR 2 WFILE_T_SCOMBING \n");
	 fprintf(fp_log,"ERROR 2 WFILE_T_SCOMBING \n");
	 return;
      }/*if(j+3 >= 100 ) {*/
      strcat(ss,s2);
      j=strlen(ss);
      i1=stp1-(*t_combing).st_gramm_add + 1;
/*
 *   we count the number of (
 */
      k=i1;
      nb_par= 0;
      while(k < l1 && *((*t_combing).st_gramm_add + k) != '\"'){
	if(*((*t_combing).st_gramm_add + k) == '(')++nb_par ;
	++k;
      }/*while(i < l && *((*t_combing).st_words_add + i) != '\"'){*/
      if(nb_par == 0 ) {
	 printf("ERROR 3 WFILE_T_SCOMBING \n");
	 fprintf(fp_log,"\n");
	 fprintf(fp_log,"ERROR 3 WFILE_T_SCOMBING no (..) in st_gramm\n");
	 fprintf(fp_log,"st_words=%s@@@ \n",(*t_combing).st_words_add);
	 fprintf(fp_log,"st_gramm=%s@@@ \n",(*t_combing).st_gramm_add);
	 fprintf(fp_log,"ss=%s@@@ \n",ss);
	 return;
      }/*if(j+3 >= 100 ) {*/
      sprintf(s_par," %d ",nb_par);
      ls=strlen(s_par);
      if(j+ls >= 100 ) {
	 printf("ERROR 4 WFILE_T_SCOMBING \n");
	 fprintf(fp_log,"ERROR 4 WFILE_T_SCOMBING \n");
	 return;
      }/*if(j+3 >= 100 ) {*/
      strcat(ss,s_par);
      j=strlen(ss);
/*
 *  we add the grammatical identities
 */
      k=i1;
      while(k < l1 && *((*t_combing).st_gramm_add + k) != '(')++k;
      while(k < l1 && *((*t_combing).st_gramm_add + k) == '('){
         while(k < l1 && *((*t_combing).st_gramm_add + k) != ')'){
            ss[j]= *((*t_combing).st_gramm_add + k);
	    ++j;
	    ++k;
	    if(j >= 100){
	      printf("ERROR 5 WFILE_T_SCOMBING \n");
	      fprintf(fp_log,"ERROR 5 WFILE_T_SCOMBING \n");
	      return;
	    }/*if(j >= 100){*/
	 }/*while(k < l1 && *((*t_combing).st_gramm_add + k) != ')'){*/
	 ++k;
         while(k < l1 && *((*t_combing).st_gramm_add + k) == ' ')++k;
         if(j+4 >= 100 ) {
	    printf("ERROR 6 WFILE_T_SCOMBING \n");
	    fprintf(fp_log,"ERROR 6 WFILE_T_SCOMBING \n");
	    return;
         }/*if(j+3 >= 100 ) {*/
	 ss[j]='\0';
         strcat(ss,"-0) ");
         j=strlen(ss);
      }/* while(k < l1 && *((*t_combing).st_gramm_add + k) == '('){ */
      RM_EXTRA_BLANCS(ss);
      ++nbw;
      fprintf(fp2,"%s \n",ss);
      stp = NULL;
      if(i < l) stp = strchr(((*t_combing).st_words_add + i),'\"');
      ++i1;
      stp1 = NULL;
      if(i1 < l1) stp1 = strchr(((*t_combing).st_gramm_add + i1),'\"');
   }/*while(stp != NULL){*/
   i1 =  nbw + *tnbw ;
   *tnbw = i1;
//   printf("output tnbw=%d \n",*(tnbw));
}/*output WFILE_T_SCOMBING  */
/**************************************************************/
void WORDS_BETW_QUOTES(FILE *fp_log,char s[],char *stp, char *stp3,\
	Trf_combing *t_combing)
/*
 *  This sub will extract everything in between quotes
  *    which may be at stp ...stp3 
  *    If there is no quote at stp we extract from stp otherwise
  *    from stp+1
  *    If there is a quote at stp3 we go up to stp3-1 otherwise up
  *    to stp3
  */
{
   int l,lextr,im,i,i1,j,k,err;
   char *stp1, *stp2;
/*      printf("entrance WORDS_BETW_QUOTES  stp=%s@@@ \n",stp);
      printf("entrance WORDS_BETW_QUOTES stp3=%s@@@ \n",stp3);*/
      l = strlen(s);
      if(l<= 0 )return;
      lextr = strlen((*t_combing).words_extracted);
/*      printf("WORDS_BETW_QUOTES lextr=%d@@@ wrd_extr=%s@@@\n",\
		      lextr,(*t_combing).words_extracted);*/
    if(lextr+l+10 >= (*t_combing).len_words_extracted){
	k = lextr+l+20;
	(*t_combing).len_words_extracted = k;
/*      printf("WORDS_BETW_QUOTES realloc words_extracted[%d] \n",\
         k);*/
      (*t_combing).words_extracted = g_realloc((*t_combing).words_extracted,\
	(k+1)*sizeof(char));
/*      printf("WORDS_BETW_QUOTES apres realloc nwe=%d  wrd_extr=%s@@@\n",\
	(*t_combing).len_words_extracted ,(*t_combing).words_extracted);*/
    }/* if(nw+l >= lw){*/
/*	 printf("s=%s@@@@ \n",s);
	 printf("stp=%s@@@@ \n",stp);
	 printf("stp3=%s@@@@ \n",stp3);
	 printf("l=%d stp3-s=%d stp-s=%d \n",l,stp3-s,stp-s);*/
      if( stp - s < 0){
         printf("error 1 WORDS_BETW_QUOTES stop \n");
         fprintf(fp_log,"error 1 WORDS_BETW_QUOTES stop \n");
	 fprintf(fp_log,"   s=%s@@@@",s);
	 fprintf(fp_log," stp=%s@@@@",stp);
	 fprintf(fp_log,"stp3=%s@@@@",stp3);
         exit(1);
      }/* if(stp-s < 0 )*/
      if( stp3 - stp < 1){
         printf("error 2 WORDS_BETW_QUOTES stop \n");
         fprintf(fp_log,"error 2 WORDS_BETW_QUOTES stop \n");
	 fprintf(fp_log,"   s=%s@@@@",s);
	 fprintf(fp_log," stp=%s@@@@",stp);
	 fprintf(fp_log,"stp3=%s@@@@",stp3);
         exit(2);
      }/* if(stp-s < 0 )*/
      if( stp3 - s > l){
         printf("error 3 stp3-s > l WORDS_BETW_QUOTES stop \n");
	 printf("stp3-s=%d > l=%d \n",stp3-s,l);
         fprintf(fp_log,"error 3 stp3-s > l WORDS_BETW_QUOTES stop \n");
	 fprintf(fp_log,"stp3-s=%d > l=%d \n",stp3-s,l);
	 fprintf(fp_log,"   s=%s@@@@",s);
	 fprintf(fp_log," stp=%s@@@@",stp);
	 fprintf(fp_log,"stp3=%s@@@@",stp3);
         exit(3);
      }/* if(stp-s < 0 )*/
	 stp1= stp ;
	 stp2 = NULL;
         stp2 = strchr(stp1+1,'"');
	 if(stp2 != NULL){
  //          printf("stp2=%s@@@ \n",stp2);
	    if(stp2 > stp3)stp2=stp3;
	 }else{/*if(stp2 != NULL){*/
//            printf("stp2=NULL \n");
	    stp2=stp3;
	 }/*if(stp2 != NULL){*/
//	 if(*(stp2) == '\"' || *(stp2) == '\0')--stp2;
	 if(stp2 != NULL &&  *(stp2) == '\0')--stp2; /* mdf 25-1-2006 */
	 if (stp2 != NULL && stp3 - stp2 >= 0) { 
	    im = stp2 - stp1 ;
	    err = 0;
	    j=lextr;
	    i1=0;
	    if( *(stp1+i1) == '"'  ) ++i1;
	    for(i = i1 ; i < im ; ++i){
	       if( *(stp1+i) == '"'  ) ++err;
	       *((*t_combing).words_extracted+j)= *(stp1+i);
	       if(j < (*t_combing).len_words_extracted )++j;
	    }/*    for(i = 1 ; i < im ; ++i){*/
	    if( *(stp1+im) != '"'  ){
	       *((*t_combing).words_extracted+j)= *(stp1+im);
	       if(j < (*t_combing).len_words_extracted )++j;
	    }/*if( *(stp1+im) != '"'  ){*/
//	    if(*(stp1+i) != '-' && *(stp1+i) != '\"' && j < 100){
	    if(*(stp1+i) != '-'  && j < (*t_combing).len_words_extracted){/* mdf 25-1-2006  */ 
	       *((*t_combing).words_extracted+j)= ' ';
	       ++j;
	    }/*if(*(stp1+i) != '-' && *(stp1+i) != '\"'){*/
	    *((*t_combing).words_extracted+j)= '\0';
	    l=strlen((*t_combing).words_extracted);
/*    printf("WORDS_BETW_QUOTES output l=%d wrds_extr=%s@@@ \n",l,(*t_combing).words_extracted);*/
	    if(err != 0) fprintf(fp_log,"WORDS_BETW_QUOTES error () s=%s@@@@ \n",s);
	 } /*if(stp2 != NULL){*/
}/*void WORDS_BETW_QUOTES(char s[],char *stp, char *stp3) */


